﻿/****************************************
 *  
 *  Autoplay images gallery component (AS3) 
 *  Copyright (c) 2009 Vuzum LLC <http://www.vuzum.com/>
 *  
 ***************************************/
package com.vuzum.autoplayimagesgallery
{
	/*
	 * FLASH IMPORTS
	 */
	import com.zorked.URLNavigator;
	import flash.utils.setInterval;
	import caurina.transitions.*;
	import caurina.transitions.properties.*;
	
	import com.vuzum.utils.*;
	
	import flash.display.Loader;
	import flash.display.MovieClip;
	import flash.display.SWFVersion;
	import flash.display.StageAlign;
	import flash.display.StageDisplayState;
	import flash.display.StageScaleMode;
	import flash.events.Event;
	import flash.events.KeyboardEvent;
	import flash.events.MouseEvent;
	import flash.external.ExternalInterface;
	import flash.geom.Rectangle;
	import flash.net.URLRequest;
	import flash.net.navigateToURL;
	import flash.system.Capabilities;
	import flash.system.Security;
	import flash.system.System;
	import flash.text.TextFormat;
	import flash.ui.Mouse;
	import flash.utils.clearTimeout;
	import flash.utils.setTimeout;
	/**
	 * THE CLASS
	 */
	public class AutoplayImagesGallery extends MovieClip 
	{
		/**
		 * COMPONENTS INSIDE
		 */
		public var mcLoader : MovieClip;
		public var mcTooltip : Tooltip;
		public var mcGallery : MovieClip;		
		public var mcControllerMask : MovieClip;		
		public var mcController : MovieClip;		
		public var mcBack : MovieClip;

		/**
		 * INTERNAL MEMBERS
		 */
		 
		// COMPONENT VARS
		public var componentWidth : Number;
		public var componentHeight : Number;
		//
		public var pathToFiles : String = "";
		public var xmlPath : String;
		// 		 
		public var extSelectItemFunction : Function;		 
		 
		// PLAYING VARS
		private var autoResize : Boolean = true;
		private var autoStart : Boolean = false;
		private var autoPlayStep : Number = 1; // in pixels, how muck to move with the scrub
		private var initAutoPlayStep : Number;
		private var initScrollerWidth : Number;
		//
		private var keyListener : Boolean = true;
		
		// BACKGROUND
		private var backgroundColor : Number;
		private var backgroundAlpha : Number = 100;
		
		// GALLERY vars
		private var itemsName : String = "mcItem";
		private var itemsNo : Number = 0;
		//
		private var currReleasedItem : MovieClip;
		public var selectedItemNo : Number;
		//
		public var itemsWidth : Number = 100;
		public var itemsHeight : Number = 100;
		public var itemsMargin : Number = 5;
		public var distBetweenItems : Number = 5;
		//
		public var itemNormalAlpha : Number = 50;
		public var itemOverAlpha : Number = 100;
		//
		public var itemsBackNormalColor : Number;
		public var itemsBackOverColor : Number;
		// reflection settings
		private var showReflections : Boolean = false; // enable / disable the reflections
		public var reflectionDistance : Number = 3; // distance between the reflection and the item
		public var reflectionAlpha : Number = 50;
		public var reflectionHeight : Number = 20; // how height will be the reflection
		//
		public var reflectionRatio : Number = 100;
		public var reflectionUpdateTime : Number = -1;
		
		// TOOLTIP
		private var itemsListMarginX : Number = 0;
		private var itemsListMarginY : Number = 0;
		private var tooltipXmlObject : XMLList;
		
		// CONTROLLER
		public var controllerPosition : String = "bottom";
		public var controllerIsVertical : Boolean = false;
		public var controllerHeight : Number;
		public var controllerBackColor : Number;
		public var controllerBackAlpha : Number = 100;
		public var controllerDistFromBottom : Number = 5;
		//
		public var controlsDimension : Number;
		public var controlsDistanceBetween : Number = 5;
		public var controlsStrokeColor : Number;
		public var controlsFillColor : Number;
		public var controlsNormalAlpha : Number = 50;
		public var controlsOverAlpha : Number = 100;
		public var controlsOverTweenTime : Number = 0.5;
		public var controlsOverTweenTransition : String = "easeOutQuad";
		//
		private var disablePrevNextItemBts : Boolean = false;
		private var disablePlayBt : Boolean = false;
		private var disableFullBt : Boolean = false;
		private var controllerScrollBarXMLObject : XMLList;
		// controller autohide vars
		public var controllerAutohideTime : Number = -1;
		public var controllerShowTime : Number = 0.7; // for tween
		private var autoHideTimeOutId : uint;
		//				
		private var makeItemVisibleTime : Number = 0.5;				
		
		// DATA VARS
		// handlers vars
		private var currentPressedObject : MovieClip;
		public var interaction : Boolean = false;
		
		// AUX VARS
		// postion of the gallery
		private var initPlayerXPos:Number;
		private var initPlayerYPos:Number;
		//position of the gallery in full state
		private var fullPlayerXPos:Number;
		private var fullPlayerYPos: Number;
		//
		public var strokePixelIssue : Number = 1;		
		
		
		/**
		 * CONSTRUCTOR
		 */
		public function AutoplayImagesGallery() 
		{
			// Prototypes			
			new Prototypes();
			
			// TWEENER init the colors
			ColorShortcuts.init();

			
			// HIDE EVERYTHING
			show(false, true);
			mcGallery.mcAllItems.mcItem.visible = false;
			mcGallery.mcAllItems.mcItem.scaleX = mcGallery.mcAllItems.mcItem.scaleY = 0;
			//
			mcControllerMask.x = mcControllerMask.y = 0;
			mcController.mask = mcControllerMask;
			mcController.wasFloating = false;
			//
			mcController.mcNextBt.mouseChildren = false;
			mcController.mcPrevBt.mouseChildren = false;
			mcController.mcPauseBt.mouseChildren = false;
			mcController.mcFullBt.mouseChildren = false;
			//
			mcTooltip.visible = false;		
		}
		
		/**
		 * INIT THE COMPONENT
		 */
		public function init(pComponentWidth : Number = NaN, pComponentHeight : Number = NaN, pPathToFiles : String = "", pXmlPath : String = "") : void
		{
			// HIDE EVERYTHING before everything
			show(false);
			
			// read the params
			componentWidth = pComponentWidth;
			componentHeight = pComponentHeight;
			
			// path
			pathToFiles = Prototypes.readPathTo(pPathToFiles, pathToFiles);
			xmlPath = Prototypes.readAssetPath(pXmlPath, pathToFiles);			
			
			// LOADER
			prepareLoad();
			
			/*
			 * LOAD XML and then START COMPONENT after
			 */
			Prototypes.loadXML(xmlPath, xmlLoadedHandler, mcLoader); //trace("xmlPath:", xmlPath); 
		}
		
		/*
		 * XML LOADED EVENT HANDLER
		 */
		private function xmlLoadedHandler(xmlObject : *) : void
		{
			initWithSettingsAndContentXMLList(componentWidth, componentHeight, xmlObject.settings, xmlObject.content);
		}
		
		/*
		 * init with SETTINGS and CONTENT
		 */		
		public function initWithSettingsAndContentXMLList(pComponentWidth : Number = NaN, pComponentHeight : Number = NaN, xmlObjectSettings : * = null, xmlObjectContent : * = null) : void
		{
			// read the dimensions params
			componentWidth = pComponentWidth;
			componentHeight = pComponentHeight;			
			
			// load the settings
			initWithSettingsXMLList(componentWidth, componentHeight, xmlObjectSettings);
			
			// load the content and start component
			initWithContentXMLList(componentWidth, componentHeight, xmlObjectContent);
		}
		
		/*
		 * init with SETTINGS
		 */
		public function initWithSettingsXMLList(pComponentWidth : Number = NaN, pComponentHeight : Number = NaN, xmlObject : * = null) : void
		{
			// HIDE EVERYTHING before everything
			show(false);
			
			// read the dimensions params
			componentWidth = pComponentWidth;
			componentHeight = pComponentHeight;
			
			/*
			 * READ THE SETTINGS
			 */
			// read COMPONENT DIMENSIONS if they were not defined in flash vars
			if(isNaN(componentWidth)) componentWidth = Prototypes.readNumberVar(xmlObject.@width, stage.stageWidth);
			if(isNaN(componentHeight)) componentHeight = Prototypes.readNumberVar(xmlObject.@height, stage.stageHeight);			
			
			// autoStart flag for the play button if there is
			autoStart = Prototypes.readBooleanVar(xmlObject.autoStart, autoStart); //trace("autoStart: ", autoStart);
			// read the time to stay
			initAutoPlayStep = autoPlayStep = Prototypes.readNumberVar(xmlObject.autoStart.@floatStep, autoPlayStep); //mcBack.ttrace("init autoPlayStep: ", autoPlayStep);
			initScrollerWidth = mcController.mcScroller.mcBack.width;
			
			// autoresize flag
			autoResize = Prototypes.readBooleanVar(xmlObject.autoResize, autoResize); //trace("autoResize: ", autoResize);
			
			// keylistener flag
			keyListener = Prototypes.readBooleanVar(xmlObject.keyListener, keyListener); //trace("keyListener: ", keyListener);
			
			// BACKGROUND
			backgroundColor = Prototypes.readNumberVar(xmlObject.backgroundColor, backgroundColor);
			backgroundAlpha = Prototypes.readNumberVar(xmlObject.backgroundColor.@alpha, backgroundAlpha) / 100;
			
			/*
			 * READ ITEMS SETTINGS
			 */
			itemsListMarginX = Prototypes.readNumberVar(xmlObject.itemsList.@marginX, itemsListMarginX); 
			itemsListMarginY = Prototypes.readNumberVar(xmlObject.itemsList.@marginY, itemsListMarginY);
			//
			distBetweenItems = Prototypes.readNumberVar(xmlObject.itemsList.distanceBetweenItems, distBetweenItems); //trace("distBetweenItems:", distBetweenItems);
			//
			itemsWidth = Prototypes.readNumberVar(xmlObject.itemsList.itemWidth, itemsWidth);
			itemsHeight = Prototypes.readNumberVar(xmlObject.itemsList.itemHeight, itemsHeight);
			itemsMargin = Prototypes.readNumberVar(xmlObject.itemsList.itemMargin, itemsMargin);
			//
			itemNormalAlpha = Prototypes.readNumberVar(xmlObject.itemsList.itemNormalAlpha, itemNormalAlpha) / 100;
			itemOverAlpha = Prototypes.readNumberVar(xmlObject.itemsList.itemOverAlpha, itemOverAlpha) / 100;
			//
			itemsBackNormalColor = Prototypes.readNumberVar(xmlObject.itemsList.itemsBackground.normalColor);
			itemsBackOverColor = Prototypes.readNumberVar(xmlObject.itemsList.itemsBackground.overColor);
			// reflections settings
			showReflections = Prototypes.readBooleanVar(xmlObject.itemsList.reflections, false); //trace("showReflections:", showReflections);
			reflectionAlpha = Prototypes.readNumberVar(xmlObject.itemsList.reflections.@alpha, reflectionAlpha); //trace("showReflections:", showReflections);
			//
			reflectionDistance = Prototypes.readNumberVar(xmlObject.itemsList.reflections.@distance, reflectionDistance); //trace("showReflections:", showReflections);
			reflectionHeight = Prototypes.readNumberVar(xmlObject.itemsList.reflections.@height, reflectionHeight); //trace("showReflections:", showReflections);
			//
			reflectionRatio = Prototypes.readNumberVar(xmlObject.itemsList.reflections.@ratio, reflectionRatio); //trace("showReflections:", showReflections);
			reflectionUpdateTime = Prototypes.readNumberVar(xmlObject.itemsList.reflections.@updateTime, reflectionUpdateTime); //trace("showReflections:", showReflections);
			 
			 /*
			  * READ THE CONTROLLER SETTINGS
			  */
			controllerDistFromBottom = Prototypes.readNumberVar(xmlObject.controller.@marginAround, controllerDistFromBottom); //trace("controllerDistFromBottom: ", controllerDistFromBottom);
			//
			controllerPosition = Prototypes.readStringVar(xmlObject.controller.position, controllerPosition); //trace("controllerPosition: ", controllerPosition);
			controllerIsVertical = (controllerPosition == "left" || controllerPosition == "right");
			//						
			controllerHeight = Prototypes.readNumberVar(xmlObject.controller.background.height, mcController.mcBack.height); //trace("controllerHeight: ", controllerHeight);
			controllerBackColor = Prototypes.readNumberVar(xmlObject.controller.background.color); //trace("controllerBackColor: ", controllerBackColor);
			controllerBackAlpha = Prototypes.readNumberVar(xmlObject.controller.background.alpha, controllerBackAlpha) / 100; //trace("controllerBackAlpha: ", controllerBackAlpha);
			//
			controlsDimension = Prototypes.readNumberVar(xmlObject.controller.controls.dimension, mcController.mcPrevBt.mcBack.width); //trace("controlsDimension: ", controlsDimension);
			controlsDistanceBetween = Prototypes.readNumberVar(xmlObject.controller.controls.distanceBetween, controlsDistanceBetween); //trace("controlsDistanceBetween: ", controlsDistanceBetween);
			controlsStrokeColor = Prototypes.readNumberVar(xmlObject.controller.controls.strokeColor); //trace("controlsStrokeColor: ", controlsStrokeColor);
			controlsFillColor = Prototypes.readNumberVar(xmlObject.controller.controls.fillColor); //trace("fillColor: ", fillColor);
			controlsNormalAlpha = Prototypes.readNumberVar(xmlObject.controller.controls.normalAlpha, controlsNormalAlpha) / 100; //trace("controlsNormalAlpha: ", controlsNormalAlpha);
			controlsOverAlpha = Prototypes.readNumberVar(xmlObject.controller.controls.overAlpha, controlsOverAlpha) / 100; //trace("controlsOverAlpha: ", controlsOverAlpha);
			controlsOverTweenTime = Prototypes.readNumberVar(xmlObject.controller.controls.overOutTime, controlsOverTweenTime); //trace("controlsOverTweenTime: ", controlsOverTweenTime);
			//
			disablePrevNextItemBts = Prototypes.readBooleanVar(xmlObject.controller.controls.disablePrevNextItemBts, disablePrevNextItemBts); //trace("disablePrevNextItemBts: ", disablePrevNextItemBts);
			disablePlayBt = Prototypes.readBooleanVar(xmlObject.controller.controls.disablePlayBt, disablePlayBt); //trace("disablePlayBt: ", disablePlayBt);
			disableFullBt = Prototypes.readBooleanVar(xmlObject.controller.controls.disableFullBt, disableFullBt); //trace("disableFullBt: ", disableFullBt);
			// scroller settings
			controllerScrollBarXMLObject = xmlObject.controller.scroller;
			// controllerAutoHideTime
			controllerAutohideTime = Prototypes.readNumberVar(xmlObject.controller.autohideTime, -1);			
			controllerShowTime = Prototypes.readNumberVar(xmlObject.controller.autohideTime.@hideDurationTime, controllerShowTime);	//trace(controllerAutohideTime, controllerShowTime);
			
			// READ THE TOOLTIP SETTINGS
			tooltipXmlObject = xmlObject.tooltip;			
		}	
			
		/*
		 * READ THE CONTENT and START component
		 */
		public function initWithContentXMLList(pComponentWidth : Number = NaN, pComponentHeight : Number = NaN, pXmlObject : * = null) : void
		{		
			// HIDE EVERYTHING before everything
			show(false);
			
			// read the dimensions params
			if(!isNaN(componentWidth)) componentWidth = pComponentWidth;
			if(!isNaN(componentHeight)) componentHeight = pComponentHeight;			
						
			// read the start with item no if not already set
			if(isNaN(selectedItemNo)) selectedItemNo = Prototypes.readNumberVar(pXmlObject.@startAlbumNo, selectedItemNo) - 1;  //trace("selectedItemNo:", selectedItemNo);
			
			// read the LIST OF IMAGES and create the instances
			var xmlItemsArray : XMLList = pXmlObject.children();
			var mc : MovieClip;
			itemsNo = xmlItemsArray.length(); //trace(itemsNo);
			for(var i : Number = 0; i < itemsNo; i++)
			{
				// create the thumb
				mc = mcGallery.mcAllItems.duplicateMovieClip(new mcGalleryItem(), itemsName + i);
				
				// resize the thumb
				mc.mcBack.width = itemsWidth;
				mc.mcBack.height = itemsHeight;
				mc.mcBack.setColor(itemsBackNormalColor);
				//
				mc.mcLoader.centerOnClip(mc.mcBack);
				//
				mc.mcMask.x = mc.mcMask.y = mc.mcHolder.x = mc.mcHolder.y = itemsMargin;
				mc.mcMask.width = mc.mcBack.width - 2 * itemsMargin;
				mc.mcMask.height = mc.mcBack.height - 2 * itemsMargin;
				
				// set up the thumb
				mc.alpha = itemNormalAlpha;
				mc.loaded = false;
				mc.index = i;
				
				// store data
				mc.imagePath = Prototypes.readAssetPath(xmlItemsArray[i].image, pathToFiles); //trace("item " + i + " image path:", mc.imagePath);
				mc.link = Prototypes.readStringVar(xmlItemsArray[i].link); //trace("item " + i + " image link:", galleryArray[i].link);
				mc.target = Prototypes.readStringVar(xmlItemsArray[i].link.@target, "_blank"); //trace("item " + i + " image link target:", galleryArray[i].target);
				mc.text = Prototypes.readStringVar(xmlItemsArray[i].author); //trace("item " + i + " text:", galleryArray[i].text);
				mc.description = Prototypes.readStringVar(xmlItemsArray[i].description); //trace("item " + i + " description:", galleryArray[i].description);
				//trace("---------\n");
				
				// rotate the item
				mc.rotation = (controllerIsVertical ? -90 : 0);
				
				// position the item
				if(controllerIsVertical) 
				{
					mc.x = i * (itemsHeight + distBetweenItems);
					mc.y += itemsWidth;
				}
				else mc.x = i * (itemsWidth + distBetweenItems);
				
				// add events
				mc.mouseChildren = false;
				mc.addEvents(this);
			}
			
			/*
			 * START THE APPLICATION
			 */
			main();
		}

		/************************************************************
		 * 
		 * 						MAIN FUNCTION
		 * 					
		 ************************************************************/
		private function main() : void
		{
			// BACKGROUND
			mcBack.setColor(backgroundColor); 
			mcBack.alpha = backgroundAlpha;
			
			// GALLERY
			mcGallery.rotation = (controllerIsVertical ? 90 : 0);
//			mcGallery.mcBack.buttonMode = true;
			mcGallery.mcBack.addEventListener(MouseEvent.ROLL_OVER, overHandler);
			mcGallery.mcBack.addEventListener(MouseEvent.ROLL_OUT, outHandler);
			
			// TOOLTIP
			mcTooltip.setCheckFunction = checkTooltip;
			mcTooltip.initWithXMLList(NaN, NaN, tooltipXmlObject);
			
			// INIT THE CONTROLLER
			// BACKGROUND
			mcController.mcBack.setColor(controllerBackColor); 
			mcController.mcBack.alpha = controllerBackAlpha;
			
			// ROTATION	
			mcController.rotation = (controllerIsVertical ? 90 : 0);			
			
			// PREV BUTTON
			mcController.mcPrevBt.xPercent = mcController.mcPrevBt.mcSign.width / mcController.mcPrevBt.mcBack.width;
			mcController.mcPrevBt.mcBack.mcFill.width = mcController.mcPrevBt.mcBack.mcFill.height = controlsDimension;
			mcController.mcPrevBt.mcBack.mcStroke.width = mcController.mcPrevBt.mcBack.mcStroke.height = controlsDimension-strokePixelIssue;;
			//
			mcController.mcPrevBt.mcSign.width = mcController.mcPrevBt.xPercent * mcController.mcPrevBt.mcBack.width;
			mcController.mcPrevBt.mcSign.scaleY = mcController.mcPrevBt.mcSign.scaleX;
			mcController.mcPrevBt.mcSign.centerOnClip(mcController.mcPrevBt.mcBack);		
			//
			mcController.mcPrevBt.mcSign.setColor(controlsFillColor);
			mcController.mcPrevBt.alpha = controlsNormalAlpha;
			//
			mcController.mcPrevBt.addEvents(this);
			if(itemsNo <= 1) mcController.mcPrevBt.toggle(false, (controlsNormalAlpha / 2));
			
			// NEXT BUTTON
			mcController.mcNextBt.xPercent = mcController.mcNextBt.mcSign.width / mcController.mcNextBt.mcBack.width;
			mcController.mcNextBt.mcBack.mcFill.width = mcController.mcNextBt.mcBack.mcFill.height = controlsDimension;
			mcController.mcNextBt.mcBack.mcStroke.width = mcController.mcNextBt.mcBack.mcStroke.height = controlsDimension-strokePixelIssue;;
			//
			mcController.mcNextBt.mcSign.width = mcController.mcNextBt.xPercent * mcController.mcNextBt.mcBack.width;
			mcController.mcNextBt.mcSign.scaleY = mcController.mcNextBt.mcSign.scaleX;
			mcController.mcNextBt.mcSign.centerOnClip(mcController.mcNextBt.mcBack);			
			//
			mcController.mcNextBt.mcSign.setColor(controlsFillColor);
			mcController.mcNextBt.alpha = controlsNormalAlpha;
			//
			mcController.mcNextBt.addEvents(this);
			if(itemsNo <= 1) mcController.mcNextBt.toggle(false, (controlsNormalAlpha / 2));
			//
			mcController.mcPrevBt.visible = mcController.mcNextBt.visible = !disablePrevNextItemBts;
			
			// init the SCROLLBAR in the controller
			mcController.mcScroller.initWithXMLList(NaN, NaN, mcGallery.mcAllItems, mcGallery.mcMask, controllerScrollBarXMLObject);
			this.setChildIndex(mcController, this.numChildren - 3);
			
			// visible
			mcController.visible = false;				
			
			// FULL TOGGLE BUTTON
			mcController.mcFullBt.xPercent = mcController.mcFullBt.mcSign.width / mcController.mcFullBt.mcBack.width;
			mcController.mcFullBt.mcBack.mcFill.width = mcController.mcFullBt.mcBack.mcFill.height = controlsDimension;
			mcController.mcFullBt.mcBack.mcStroke.width = mcController.mcFullBt.mcBack.mcStroke.height = controlsDimension-strokePixelIssue;
			//
			mcController.mcFullBt.mcSign.width = mcController.mcFullBt.xPercent * mcController.mcFullBt.mcBack.width;
			mcController.mcFullBt.mcSign.scaleY = mcController.mcFullBt.mcSign.scaleX;
			mcController.mcFullBt.mcSign.centerOnClip(mcController.mcFullBt.mcBack);
			//			
			mcController.mcFullBt.mcSign.setColor(controlsFillColor);
			mcController.mcFullBt.alpha = controlsNormalAlpha;
			//
			mcController.mcFullBt.addEvents(this);
			if(disableFullBt) mcController.mcFullBt.visible = false;
			
			// PLAY SLIDESHOW TOGGLE BUTTON
			mcController.mcPauseBt.xPercent = mcController.mcPauseBt.mcSign.width / mcController.mcPauseBt.mcBack.width;
			mcController.mcPauseBt.mcBack.mcFill.width = mcController.mcPauseBt.mcBack.mcFill.height = controlsDimension;
			mcController.mcPauseBt.mcBack.mcStroke.width = mcController.mcPauseBt.mcBack.mcStroke.height = controlsDimension-strokePixelIssue;
			//
			mcController.mcPauseBt.mcSign.width = mcController.mcPauseBt.xPercent * mcController.mcPauseBt.mcBack.width;
			mcController.mcPauseBt.mcSign.scaleY = mcController.mcPauseBt.mcSign.scaleX;
			mcController.mcPauseBt.mcSign.centerOnClip(mcController.mcPauseBt.mcBack); 			
			//
			mcController.mcPauseBt.addEvents(this);
			mcController.mcPauseBt.mcSign.mcPlaySign.visible = true;			
			mcController.mcPauseBt.mcSign.mcPauseSign.visible = false;
			mcController.mcPauseBt.mcSign.setColor(controlsFillColor);
			mcController.mcPauseBt.alpha = controlsNormalAlpha;
			if(disablePlayBt) mcController.mcPauseBt.visible = false;
			
			// STROKE OF THE CONTROLS
			if(controlsStrokeColor < 0)
			{
				mcController.mcPrevBt.mcBack.mcStroke.visible = false;
				mcController.mcNextBt.mcBack.mcStroke.visible = false;
				mcController.mcPauseBt.mcBack.mcStroke.visible = false;
				mcController.mcFullBt.mcBack.mcStroke.visible = false;
			}
			else
			{
				mcController.mcPrevBt.mcBack.setColor(controlsStrokeColor);
				mcController.mcNextBt.mcBack.setColor(controlsStrokeColor);
				mcController.mcPauseBt.mcBack.setColor(controlsStrokeColor);
				mcController.mcFullBt.mcBack.setColor(controlsStrokeColor);
			}
			
			// ROTATE SIMBOLS IF IS THE CASE
			if(controllerIsVertical)
			{
				mcController.mcPauseBt.mcSign.mcPlaySign.rotation = -90;
				mcController.mcPauseBt.mcSign.mcPauseSign.rotation = -90;
			}
			
			// RESIZE THE FIRST TIME
	    	// retain the initial position of the component
			initPlayerXPos = fullPlayerXPos = this.x; 
			initPlayerYPos = fullPlayerYPos = this.y; 
			// call resize handler
			resize(componentWidth, componentHeight);
			//resizeHandler(new Event(Event.RESIZE)); //dispatchEvent(new Event(Event.RESIZE));
			stage.addEventListener(Event.RESIZE, resizeHandler);
			
			
			// STAGE HANDLERS
			//stage.addEventListener(Event.MOUSE_LEAVE, stageOutHandler);
			//this.addEventListener(Event.ENTER_FRAME, enterFrameHandler);
			//this.addEventListener(MouseEvent.MOUSE_MOVE, mouseMoveHandler);
			// stage LEAVE event handler to hide the control panel
			if(controllerAutohideTime > 0)
			{ 
				showController();
				stage.addEventListener(MouseEvent.MOUSE_MOVE, componentMoveOverHandler);
            	stage.addEventListener(Event.MOUSE_LEAVE, stageOutHandler);
			}			
					
			// start listening keys
			if(keyListener) stage.addEventListener(KeyboardEvent.KEY_UP, keyUpListener);						
			
			// SHOW EVERYTHIUNG
			show(true);
			
			// controller visible
			mcController.visible = false;				
			
			// START LOADING THE IMAGES
			loadItem(0);
			

			// SELECT THE SPECIFIC ITEM IF IS THE CASE
			if(!isNaN(selectedItemNo)) selectedItemNo = (selectedItemNo >= 0 && selectedItemNo < itemsNo ? selectedItemNo : NaN);
			if(!isNaN(selectedItemNo))
			{
				//trace(selectedItemNo);
				selectItemNo(selectedItemNo, true);
			}
			// START AUTOPLAY			
			else
			{
				if(autoStart && !disablePlayBt) toggleFloat();
			}						
		}
			
		/*
		 * opens(show / load) an item
		 */
		public function loadItem(currItem : Number) : void
		{
			var mcItem : MovieClip = mcGallery.mcAllItems[itemsName + currItem];
			mcItem.mcHolder.alpha = 0;
			mcItem.mcHolder.loadContent(mcItem.imagePath, imageLoaded, mcItem.mcLoader, false);
		}		
		
		/*
		 * to do after an image is loaded
		 */
		/**
		 * 
		 * @param pTarget
		 * 
		 */
		private function imageLoaded(pTarget : MovieClip) : void
		{
			var mcParent : MovieClip = pTarget.parent as MovieClip;
			var i : Number;
			
			// resize and / or center the holder if needed
			pTarget.fitToObject(mcParent.mcMask);
			
			// create reflection
			if(showReflections) 
			{
				mcParent.reflection = new Reflection({mc : mcParent, 
																	 alpha : reflectionAlpha, ratio : 
																	 reflectionRatio, 
																	 distance : reflectionDistance, 
																	 size : reflectionHeight, 
																	 updateTime : reflectionUpdateTime});
				// show reflection																	 
//				mcParent.reflection.alpha = 0;
//				mcParent.reflection.showObject();			
			}
			
			// show clip
			pTarget.showObject(true, 0.5, null, "easeOutExpo", (mcParent.reflection ? mcParent.reflection.update : null));			
			
			
			// resize the image's parent
			if(controllerIsVertical)
			{
				if(mcParent.mcMask.height > pTarget.height)
				{
					// resize mask
					Tweener.addTween(mcParent.mcMask, {height : pTarget.height, y : itemsMargin, time : 0.5, transition : "easeOutQuad", onUpdate : checkContent});
					Tweener.addTween(pTarget, {y : itemsMargin, time : 0.5, transition : "easeOutQuad"});
//					mcParent.mcMask.width = pTarget.width;
//					mcParent.mcMask.x = pTarget.x = itemsMargin;
					
					// resize background
					Tweener.addTween(mcParent.mcBack, {height : pTarget.height + 2 * itemsMargin, time : 0.5, transition : "easeOutQuad"});
					//mcParent.mcBack.width = mcParent.mcMask.width + 2 * itemsMargin;
					
					
					// reposition items after this item
					for(i = mcParent.index + 1; i < itemsNo; i++) 
					{
						//Tweener.addTween(galleryArray[i], {x : (galleryArray[i-1].x + (i == (mcParent.index + 1) ? galleryArray[i-1].mcHolder.width + 2 * itemsMargin : galleryArray[i-1].mcBack.width) + distBetweenItems), time : 0.5, transition : "easeOutQuad"});
						mcGallery.mcAllItems[itemsName + i].x = mcGallery.mcAllItems[itemsName + (i-1)].x + (i == (mcParent.index + 1) ? mcGallery.mcAllItems[itemsName + (i-1)].mcHolder.height + 2 * itemsMargin : mcGallery.mcAllItems[itemsName + (i-1)].width) + distBetweenItems;
					}
				}				
			}
			else
			{
				if(mcParent.mcMask.width > pTarget.width)
				{
					// resize mask
					Tweener.addTween(mcParent.mcMask, {width : pTarget.width, x : itemsMargin, time : 0.5, transition : "easeOutQuad", onUpdate : checkContent});
					Tweener.addTween(pTarget, {x : itemsMargin, time : 0.5, transition : "easeOutQuad"});
//					mcParent.mcMask.width = pTarget.width;
//					mcParent.mcMask.x = pTarget.x = itemsMargin;
					
					// resize background
					Tweener.addTween(mcParent.mcBack, {width : pTarget.width + 2 * itemsMargin, time : 0.5, transition : "easeOutQuad"});
					//mcParent.mcBack.width = mcParent.mcMask.width + 2 * itemsMargin;
					
					
					// reposition items after this item
					for(i = mcParent.index + 1; i < itemsNo; i++) 
					{
						//Tweener.addTween(galleryArray[i], {x : (galleryArray[i-1].x + (i == (mcParent.index + 1) ? galleryArray[i-1].mcHolder.width + 2 * itemsMargin : galleryArray[i-1].mcBack.width) + distBetweenItems), time : 0.5, transition : "easeOutQuad"});
						mcGallery.mcAllItems[itemsName + i].x = mcGallery.mcAllItems[itemsName + (i-1)].x + (i == (mcParent.index + 1) ? mcGallery.mcAllItems[itemsName + (i-1)].mcHolder.width + 2 * itemsMargin : mcGallery.mcAllItems[itemsName + (i-1)].width) + distBetweenItems;
					}
				}
			}
			
			// change the status
			mcParent.loaded = true;
			
			// start showing the target
			//pTarget.showObject(true, showItemsTime);
			
			// REPOSITION ITEMS HOLDER at the end
			//if(mcGallery.mcAllItems.x + mcGallery.mcAllItems.width < mcGallery.mcMask.x + mcGallery.mcMask.width) mcGallery.mcAllItems.x  = -mcGallery.mcAllItems.width + mcGallery.mcMask.x + mcGallery.mcMask.width;
			
			
			// LOAD NEXT ITEM
			if(mcParent.index != itemsNo - 1) loadItem(mcParent.index + 1);
			
			// check if the items holder became bigger then the mask
			checkControllerVisible();
			//trace("load:", mcController.visible);
		}
		
		private function checkControllerVisible() : void
		{
			mcController.visible = (mcGallery.mcAllItems.width > mcGallery.mcMask.width);
			//trace(mcGallery.mcAllItems.width, mcGallery.mcMask.width);
		}	
		
		public function checkContent() : void
		{
			// UPDATE THE SCRUB
			mcController.mcScroller.update();
			
			// centrate the CONTENT inside if is the case
			if(mcGallery.mcAllItems.width < mcGallery.mcMask.width) mcGallery.mcAllItems.centerOn(mcGallery.mcMask.width);
			
			// (de) activate play/pause toggle
			mcController.mcPauseBt.toggle((mcGallery.mcAllItems.width > mcGallery.mcMask.width), (controlsNormalAlpha / (mcGallery.mcAllItems.width > mcGallery.mcMask.width ? 1 : 2)));
			if(mcGallery.mcAllItems.width < mcGallery.mcMask.width) toggleFloat(false);
		}
		
		
		/*
		 * to do when an item is released
		 */
		public function selectItem(mc : MovieClip, selectFlag : Boolean = false) : void
		{
			// call the specific function for an item no
			selectItemNo(mc.index, selectFlag);
		}
		
		public function selectItemNo(currItem : Number, selectFlag : Boolean = false) : void
		{
			var mc : MovieClip = mcGallery.mcAllItems[itemsName + currItem];
			
			// check if is not already released
			//if(mc != currReleasedItem)
			{
				// if it was flaoting stop it
				toggleFloat(false);
				mcController.wasFloating = false;				
				
								
				// change the CURRENT ITEM over state
				if(currReleasedItem != null) 
				{
					// out the current selected item
					overFunction(currReleasedItem, false);
					currReleasedItem.featured = false;
				}


				// update the CURRENT SELECTED ITEM 
				currReleasedItem = mc; // the object								
				selectedItemNo = currItem; // the number
				
				
				// change the NEW ITEM
				// change this new item's over state
				overFunction(currReleasedItem);
				
				// make this NEW ITEM visible
				makeItemVisible(currReleasedItem);
			}
			
			// call select action if is the case
			if(selectFlag) selectItemAction(mc);			
		}
		
		public function isVisible(item : MovieClip) : Boolean
		{
			var itemX : Number = mcGallery.mcAllItems.x + item.x;
			
			if((itemX < mcGallery.mcMask.x) || (itemX + item.width > mcGallery.mcMask.x + mcGallery.mcMask.width)) return false;
			else return true;
		}
		
		/*
		 * centrates the an item to be visible
		 */
		public function makeItemVisible(item : MovieClip) : void
		{	
			if(item != null && !isVisible(item))
			{
				var goToX : Number = - item.x + Math.round((mcGallery.mcMask.width - item.mcBack[controllerIsVertical ? "height" : "width"]) / 2);
				
				// check items holder margins
				//if(mcGallery.mcAllItems.width > mcGallery.mcMask.width)
				{
					if(goToX > mcGallery.mcMask.x) goToX = mcGallery.mcMask.x;
					if(goToX + mcGallery.mcAllItems.width < mcGallery.mcMask.x + mcGallery.mcMask.width) goToX = - mcGallery.mcAllItems.width + mcGallery.mcMask.x + mcGallery.mcMask.width;
				}
				
				// check the item position in center
//				if(mcGallery.mcAllItems.x + item.x - item.width / 2 < mcGallery.mcMask.x) goToX = - item.x + item.width / 2 + mcGallery.mcMask.x;
//				if(mcGallery.mcAllItems.x + item.x + item.width / 2 > mcGallery.mcMask.x + mcGallery.mcMask.width) goToX = - (item.x + item.width / 2) + mcGallery.mcMask.x + mcGallery.mcMask.width;

				// make the movement
				Tweener.addTween(mcGallery.mcAllItems, {x : goToX, time : makeItemVisibleTime, transition : "easeOutQuad", onUpdate : function() : void
				{
					mcController.mcScroller.updateScrub(NaN, 0);
				}, onComplete : function() : void
				{
					item.featured = true;
				}});
			}
		}
		
		/*
		 * to do on click a featured item
		 */
		public function selectItemAction(mc : MovieClip) : void
		{
			// call the function
			if(extSelectItemFunction != null)
			{
				if(extSelectItemFunction.length) extSelectItemFunction(mc.index);
				else extSelectItemFunction();					
			}
			// link
			else
			{
				if(mc.link != "") URLNavigator.ChangePage(mc.link, mc.target);					
			}
		}			
		
		/*
		 * shows the image when an item is pressed
		 * flag = true goes prev item
		 */
		public function iterateAndSelect(flag : Boolean = true) : void
		{
			// prev
			if(flag) prevItem(true);
			// next
			else nextItem(true);
		}
		public function iterate(flag : Boolean = true) : void
		{
			// prev
			if(flag) prevItem();
			// next
			else nextItem();
		}		
		
		/*
		 * goes to prev item
		 */
		public function prevItem(selectFlag : Boolean = false) : void
		{
			// calculate and select the next item
			selectItemNo((selectedItemNo > 0) ? (selectedItemNo-1) : (itemsNo-1), selectFlag);
		}		
		
		/*
		 * goes to next item
		 */
		public function nextItem(selectFlag : Boolean = false) : void
		{
			// calculate and select the next item
			selectItemNo((selectedItemNo < itemsNo-1) ? (selectedItemNo+1) : 0, selectFlag);
		}		
		
		/************************************************************
		 *
		 *					EVENT HANDLERS
		 * 
		 *************************************************************/
		/**
		 * ROLL OVER event handler
		 */
		public function overHandler(event : MouseEvent) : void
		{
			var mc : MovieClip = event.currentTarget as MovieClip;
	        
			// if an item then stop floating if is the case
			if( (mc.name.indexOf(itemsName) != -1 || mc == mcGallery.mcBack) && mcController.mcPauseBt.mcSign.mcPauseSign.visible) 
			{
				//trace("mcPauseSign.visible:", mcController.mcPauseBt.mcPauseSign.visible);
				mcController.wasFloating = true;
				toggleFloat(false);
			}
			
			// make over function
			if(mc != mcGallery.mcBack) overFunction(mc);
		}

		/**
		 * ROLL OUT event handler
		 */
		public function outHandler(event : MouseEvent) : void
		{
			var mc : MovieClip = event.currentTarget as MovieClip; //trace(mc.name + " " + event.target.name);
			
			// if an item or the back of the gallery then resume floating if it was before
			if(mc.name.indexOf(itemsName) != -1 || mc == mcGallery.mcBack)
			{
//				if(mc.name.indexOf(itemsName) != -1) trace(mcGallery.mcBack.hitTestPoint(stage.mouseX, stage.mouseY));
				if(!mcGallery.mcBack.hitTestPoint(stage.mouseX, stage.mouseY) && mcController.wasFloating)
				{
					mcController.wasFloating = false;
					toggleFloat(true);
				}
			}			
			
			// make the out function
			if(mc != currentPressedObject && mc != currReleasedItem && mc != mcGallery.mcBack) overFunction(mc, false);
			if(mc.name.indexOf(itemsName) != -1) mcTooltip.togglePosition(this, false);
		}
		public function overFunction(mc : MovieClip, flag : Boolean = true) : void
		{
			// if is an item
			if(mc.name.indexOf(itemsName) != -1) 
			{
				// change the alpha
				mc.fadeAlpha((flag ? itemOverAlpha : itemNormalAlpha), controlsOverTweenTime, "easeOutQuad", null, (mc.reflection ? mc.reflection.update : null));
				
				// change the back's color
				mc.mcBack.setColor((flag ? itemsBackOverColor : itemsBackNormalColor), controlsOverTweenTime, "easeOutQuad");
				
				// show the tooltip
				if(mc.hitTestPoint(stage.mouseX, stage.mouseY))
				{
					// write the text in the tooltip
					if(flag) mcTooltip.writeTooltip(mc.text);
								 
					// show/hide the tooltip
					mcTooltip.togglePosition(this, flag);
				}
			}
			// if is a button
			else 
			{
				mc.fadeAlpha((flag ? controlsOverAlpha : controlsNormalAlpha), controlsOverTweenTime, "easeOutQuad");
				//Tweener.addTween(mc, {alpha: (!flag ? controlsNormalAlpha : controlsOverAlpha), time: controlsOverTweenTime, transition: "easeOutQuad"});
			}
		}
		
		/*
		 * tooltip functions
		 */		
		public function checkTooltip() : void
		{
			// make sure the tooltip is not outside on the left
			if(mcTooltip.x < 0) mcTooltip.x = 0;
			
			// make sure the tooltip is not outside on the right
			if(mcTooltip.x + mcTooltip.mcBack.width > mcBack.width) mcTooltip.x = Math.round(- mcTooltip.mcBack.width + mcBack.width);
			
			// make sure the tooltip is not outside on top
			if(mcTooltip.y < 0) mcTooltip.y = 0;
			
			// make sure the tooltip is not outside on the right
			if(mcTooltip.y + mcTooltip.height > mcBack.height) mcTooltip.y = Math.round(-mcTooltip.height + mcBack.height);			
		}


		/**
		 * PRESS event handler
		 */
		public function pressHandler(event : MouseEvent) : void
		{
			// set pressed this item
			currentPressedObject = event.currentTarget as MovieClip;
			
			// set the interaction status 
			interaction = true;			
	        
			// add the release outside event handlers
			stage.addEventListener(MouseEvent.MOUSE_UP, releaseOutsideHandler);
			stage.addEventListener(Event.MOUSE_LEAVE, releaseOutsideHandler);	        
		}
		
		

		/**
		 * RELEASE OUTSIDE EVENT HANDLER FOR
		 */
		public function releaseOutsideHandler(event : Event) : void 
		{
			stage.removeEventListener(MouseEvent.MOUSE_UP, releaseOutsideHandler);
			stage.removeEventListener(Event.MOUSE_LEAVE, releaseOutsideHandler);

			// make out handler
			if(!currentPressedObject.hitTestPoint(stage.mouseX, stage.mouseY)) overFunction(currentPressedObject, false);					
			
			// hide the controller after a time
			releaseHandlerHideController();
			
			// reset the current pressed object
			currentPressedObject = null;
		}



		/**
		 * RELEASE event handler 
		 */
		public function releaseHandler(event : MouseEvent) : void
		{
			var mc : MovieClip = event.currentTarget as MovieClip; 
			
			// call the specific function
			if(mc == currentPressedObject) releaseFunction(mc);
		}
		public function releaseHandlerHideController() : void
		{
			// set the interaction status
			interaction = false;
			
			// hide the controller if out	
			if(!mcBack.hitTestPoint(stage.mouseX, stage.mouseY)) hideController();
			
			// start autohide
			hideCPAfterTime();				
		}
		/*
		 * RELEASE FUNCTION 
		 */
		public function releaseFunction(mc : *) : void
		{
			// if is an item
			if(mc.name.indexOf(itemsName) != -1) 
			{
				// call external select function or link
				if(isVisible(mc)) selectItemAction(mc);
				
				// make this item visible and select it
				selectItem(mc); 
			}
			// if is a button
			else
				switch(mc)
				{
					case mcController.mcNextBt:
					case mcController.mcPrevBt:
						iterate(mc==mcController.mcPrevBt);
						break;				
					case mcController.mcPauseBt:
						toggleFloat(mcController.mcPauseBt.mcSign.mcPlaySign.visible);
						break;
					case mcController.mcFullBt:
						changeScreenState();
						break;
				}
		}
		
		/*
		 * TOGGLE AUTOPLAY function
		 */
		private function toggleFloat(flag : Boolean = true) : void 
		{
			// call the scroller float toogle
			mcController.mcScroller.floatScrubToggle(flag, autoPlayStep);
			
			// change the sign
			mcController.mcPauseBt.mcSign.mcPlaySign.visible = !flag;
			mcController.mcPauseBt.mcSign.mcPauseSign.visible = flag;
		}
		
		/*
		 * FULL SCREEN TOGGLE function
		 */
		private function changeScreenState() : void 
		{
			if(stage.displayState == StageDisplayState.FULL_SCREEN)
			{
				stage.displayState = StageDisplayState.NORMAL;
				normalResize();
			} 
			else 
			{
				stage.displayState = StageDisplayState.FULL_SCREEN;
			}
		}
		
		/**
		 * ENTER FRAME event handler
		 */
		private function enterFrameHandler(event : Event) : void
		{
		}

		/**
		 * MOUSE MOVE event handler
		 */
		private function mouseMoveHandler(event : MouseEvent) : void
		{
		}
		
		
		
		/**
		 * COMPONENT MOVE OVER HANDLER
		 */
		private function componentMoveOverHandler(event : Event) : void
		{
			// show the controller
			if(mcBack.hitTestPoint(stage.mouseX, stage.mouseY)) showController();
			// hide the controller
			else hideController();
		}	
		
		/**
		 * STAGE LEAVE HANDLER
		 */
		private function stageOutHandler(event : Event = null) : void 
		{
			// hide the controller
			hideController();
		}
		
		/*
		 * shows / hides the controller depending on the flag
		 */
		public function showController(flag : Boolean = true) : void
		{
			if(controllerAutohideTime > 0)
			{
				// move the controller
				var property : String = (controllerPosition == "left" || controllerPosition == "right") ? "x" : "y";
				var controllerPosObject : Object = detectControllerPosition(!flag);
				//
				var tweenObject : Object = new Object();
				tweenObject.time = controllerShowTime;
				tweenObject.transition = "easeOutQuad";
				tweenObject[property] = controllerPosObject[property];
				Tweener.addTween(mcController, tweenObject);
				
				// mouse hide / show
				if(flag) 
				{
					//mcBack.ttrace("SHOW:", controllerAutohideTime);
					//Mouse.show();
					
					// after a time hide it again if is the case to show
					if(flag) hideCPAfterTime();					
				}
				else 
				{
					//if(mcBack.hitTestPoint(stage.mouseX, stage.mouseY)) Mouse.hide();
				}
			}
		}
		/*
		 * hides the controller after the time has pased if is the case
		 */
		public function hideCPAfterTime() : void
		{
			if(controllerAutohideTime > 0)
			{
				clearTimeout(autoHideTimeOutId);
				autoHideTimeOutId = setTimeout(function() : void 
				{
					if(!mcController.hitTestPoint(stage.mouseX, stage.mouseY)) hideController();
				}, controllerAutohideTime * 1000);
			}
		}
		// hides the controller 
		public function hideController() : void					
		{
			//if(!mcController.hitTestPoint(stage.mouseX, stage.mouseY, true) && mcController.isPlaying)
			//trace(!mcController.hitTestPoint(stage.mouseX, stage.mouseY)); 
			if(!interaction && !mcController.mcScroller.interaction) showController(false);
		}



		/**
		 * RESIZE EVENT HANDLER
		 */
		private function resizeHandler(event : Event) : void 
		{
			// make invisible the others and reposition the player
			if(stage.displayState == StageDisplayState.FULL_SCREEN || autoResize)
			{
				// reposition recursively to (0, 0) coods
				fullPlayerXPos = this.x;
				fullPlayerYPos = this.y;
				fullPosition(this);
				this.x = fullPlayerXPos; 
				this.y = fullPlayerYPos;
				
				// resize dimensions
				resize(stage.stageWidth, stage.stageHeight);				
			}
			// NORMAL STATE 
			else 
			{
				// resize dimensions
				//normalResize(autoResize);				
				normalResize();				
			}
			
			// show the controller
			showController();
		}
		
		/*
		 * resize function in normal state
		 */
		public function normalResize(autoResizeFlag : Boolean = true) : void
		{
			// reposition the player to the initial coords
			this.x = initPlayerXPos; 
			this.y = initPlayerYPos;
			
			// make the resize depending on the new dimensions
			if(autoResizeFlag) resize(componentWidth, componentHeight);			
		}
		
		/*
		 * calculates recursively the position of the component in full state
		 */
		private function fullPosition(mc : Object) : void
		{
			if(mc.parent != null)
			{
				fullPlayerXPos -= mc.x;
				fullPlayerYPos -= mc.y;
				fullPosition(mc.parent);
			}
		}		
			
		/*
		 * resizes everything when changing to full / normal screen
		 */
		public function resize(pWidth : Number, pHeight : Number) : void
	    {
			// RESIZE BACKGROUND
			mcBack.width = mcControllerMask.width = pWidth; //trace(mcBack.width);
			mcBack.height = mcControllerMask.height = pHeight;
			
			// GALLERY
			// resize mask
			mcGallery.mcMask.width = (controllerIsVertical ? (mcBack.height - 2 * itemsListMarginY) : (mcBack.width - 2 * itemsListMarginX));
			mcGallery.mcMask.height = (controllerIsVertical ? itemsWidth : itemsHeight + (showReflections ? reflectionDistance + reflectionHeight : 0));
			// resize back
			mcGallery.mcBack.width = mcGallery.mcMask.width - 2; 
			mcGallery.mcBack.height = mcGallery.mcMask.height - 2; 
			// position gallery
			mcGallery.x = (controllerIsVertical ? mcGallery.mcMask.height : 0) + itemsListMarginX;
			mcGallery.y = itemsListMarginY;			
			// centrate the gallery if is the case				
			if(mcGallery.mcMask[controllerIsVertical ? "height" : "width"] < mcBack.width) mcGallery.x = (controllerPosition != "left" || controllerAutohideTime > 0 ? 0 : controllerHeight) + Math.round((mcBack.width - (controllerAutohideTime > 0 ? 0 : controllerHeight) - mcGallery.mcMask[controllerIsVertical ? "height" : "width"]) / 2) + (controllerIsVertical ? mcGallery.mcMask.height : 0);
			if(mcGallery.mcMask[controllerIsVertical ? "width" : "height"] < mcBack.height) mcGallery.y = (controllerPosition != "top" || controllerAutohideTime > 0 ? 0 : controllerHeight) + Math.round((mcBack.height - (controllerAutohideTime > 0 ? 0 : controllerHeight) - mcGallery.mcMask[controllerIsVertical ? "width" : "height"]) / 2);
			// centrate the content inside if is the case
			checkContent();
			
			// CENTER THE LOADER
			mcLoader.centerOnClip(mcBack);
			
			
			// reposition and resize the CONTROLLER
			// back
			mcController.mcBack.width = Math.round((controllerIsVertical ? pHeight : pWidth) - 2 * controllerDistFromBottom);
			mcController.mcBack.height = controllerHeight;
			// prev next buttons
			mcController.mcPrevBt.x = controlsDistanceBetween;
			mcController.mcPrevBt.centerOn(NaN, mcController.mcBack.height);
			//
			mcController.mcNextBt.x = mcController.mcPrevBt.x + mcController.mcPrevBt.width + controlsDistanceBetween;
			mcController.mcNextBt.centerOn(NaN, mcController.mcBack.height);
			// full bt
			mcController.mcFullBt.x = Math.round(mcController.mcBack.x + mcController.mcBack.width - (!disableFullBt ? (mcController.mcFullBt.width + controlsDistanceBetween) : 0));
			mcController.mcFullBt.centerOn(NaN, mcController.mcBack.height);
			// play / pause bt
			mcController.mcPauseBt.x = Math.round(mcController.mcFullBt.x - (!disablePlayBt ? (mcController.mcPauseBt.width + controlsDistanceBetween) : 0));
			mcController.mcPauseBt.centerOn(NaN, mcController.mcBack.height);
			//
			mcController.mcScroller.x = (!disablePrevNextItemBts ? mcController.mcNextBt.x + mcController.mcNextBt.width : 0) + controlsDistanceBetween;
			mcController.mcScroller.resize(mcController.mcPauseBt.x - controlsDistanceBetween - mcController.mcScroller.x);//, mcController.mcBack.height);
			mcController.mcScroller.centerOn(NaN, mcController.mcBack.height);
			// visible
			checkControllerVisible();
			//trace("resize:", mcController.visible);				

			// position
			var controllerPosObject : Object = detectControllerPosition();
			Tweener.removeTweens(mcController);
			mcController.x = controllerPosObject.x;				
			mcController.y = controllerPosObject.y;					
		}
		
		/*
		 * detects the coords of the controller depending on the position(left, right, top, bottom) 
		 */
		private function detectControllerPosition(hideFlag : Boolean = false) : Object
		{
			var controllerPosObject : Object = new Object();
			
			// left / right
			if(controllerIsVertical)
			{
				// x
				// left
				if(controllerPosition == "left") controllerPosObject.x = (hideFlag ? 0 : (mcController.width + controllerDistFromBottom));
				// right
				else controllerPosObject.x = mcBack.width + (hideFlag ? mcController.width : - controllerDistFromBottom);
				
				// y
				controllerPosObject.y = controllerDistFromBottom;
			}
			
			// top / bottom
			else
			{
				// x
				controllerPosObject.x = Math.round( (mcBack.width - mcController.mcBack.width) / 2 );
				
				// y
				// bottom
				if(controllerPosition == "bottom") controllerPosObject.y = Math.round(mcBack.height - (hideFlag ? 0 : (mcController.mcBack.height + controllerDistFromBottom)) );
				// top
				else controllerPosObject.y = (hideFlag ? -mcController.height : controllerDistFromBottom);
			}		
			
			// return	
			return controllerPosObject;
		}		
		
		
		
		
		/**
		 * KEY UP LISTNER
		 */
		public function keyUpListener(e : KeyboardEvent) : void
		{
			// prev
			var left : uint = 37;
			var up : uint = 38;
			// next 
			var right : uint = 39;
			var down : uint = 40;
			// play / pause toggle
			var space : uint = 32; 
			// full screen
			var f : uint = 70;
			// info
			var i : uint = 73;						 

//			mcBack.ttrace("SPACE KEY:", e.keyCode, mcVideoPlayer.isFullScreen);				
//			trace("KEY:", e.keyCode);
			
			// make the action if this class is visible
			if(this.visible && this.alpha>=1)
			{
				// PREV BUTTON
				if((e.keyCode == left || e.keyCode == up) && !disablePrevNextItemBts)
				{
					releaseFunction(mcController.mcPrevBt);
				}
				
				// NEXT button
				if((e.keyCode == right || e.keyCode == down) && !disablePrevNextItemBts)
				{
					releaseFunction(mcController.mcNextBt);
				}
					
				// PLAY / PAUSE button
				if(e.keyCode == space)
				{
					releaseFunction(mcController.mcPauseBt);
				}
				
				// FULL SCREEN button
				if(e.keyCode == f && !disableFullBt)
				{
					releaseFunction(mcController.mcFullBt);
				}	
			}		
		}		
		
		
		
		/************************************************************
		 *
		 *					AUXILIAR FUNCTIONS
		 * 
		 *************************************************************/
		/*--------------------------------
		 * prepares the loader for loading
		 *-------------------------------*/
		public function prepareLoad() : void
		{	
			// HIDE EVERYTHING
			show(false, true);

			// CENTER THE LOADER
			mcLoader.centerOn(!isNaN(componentWidth) ? componentWidth : stage.stageWidth, !isNaN(componentHeight) ? componentHeight : stage.stageHeight);				
		}


		/*---------------------------
		 * shows the application
		 *---------------------------*/
		public function set setExtSelectItemFunction(value : Function) : void
		{
			extSelectItemFunction = value; 
		}
		public function show(flag : Boolean, loaderFlag : Boolean = false) : void 
		{
			// show / hide the loader
			mcLoader.visible = loaderFlag ? flag : !flag;
			
			// show / hide the content components
			mcController.visible = flag;
			mcBack.visible = flag;
		}
				
	} // FROM CLASS
} // FROM PACKAGE