﻿/**
* Scrolling List, November 2009
* @author Vuzum Media, LLC.
* http://www.vuzum.com
* email: office@vuzum.com
*/


 package com.vuzum.list 
{
	import com.vuzum.mp3gallery.mp3player.Track;

	import flash.external.ExternalInterface;
	import com.zorked.URLNavigator;

	import flash.events.MouseEvent;
	import flash.display.*;
	import com.vuzum.utils.*;
	import flash.events.Event;
	
	import caurina.transitions.Tweener;
	import caurina.transitions.properties.ColorShortcuts;
	import caurina.transitions.properties.FilterShortcuts;
	
	public class List extends MovieClip
	{
		// COMPONENTS INSIDE
		public var mcMask : MovieClip;
		public var mcAllItems : MovieClip;
		public var mcScroller : Scroller;
		public var objParent : *;
		
		// COMPONENT'S VARS
		public var componentWidth : Number;
		public var componentHeight : Number;
		//
		public var pathToFiles : String = "";
		//
		public var externalReleaseFunction : Function;
		public var extEndListFunction : Function;
		public var extBeginListFunction : Function;
		
		// HANDLERS EVENTS
		private var currPressedObject : MovieClip;
		
		// INTERNAL MEMBERS
		// array of items
		public var itemsArray : Array;
		var noItems : Number;
		// random array of stars
		public var randomArray : Array;
		public var random : Boolean = false;
		public var hasToRepeat : Boolean = false;
		//
		public var currSelectedItem : MovieClip;
		//
		private var trackWidth : Number;
		private var trackHeight : Number;
		
		// SETTINGS VARS(comming from outside)
		// general settings		
		private var nrColumns : Number = 1;
		private var nrLines : Number;
		private var itemDimension : Number;
		private var distanceX : Number = 0;
		private var distanceY : Number = 0;			

		// scroll bar settings
		public var scrollDimension : Number = 5;
		public var scrollOfsset : Number = -2;
		public var scrollBarColor : Number;
		public var scrollScrubColor : Number;
		
		// items settings
		public var itemsContentDistX : Number = 10;
		public var itemsTextMargin : Number = 2;
		//
		public var titleColor : Number;
		public var titleOverColor : Number;
		//
		public var numberColor : Number;
		public var numberOverColor : Number;
		public var numberBackgroundColor : Number;
		//
		public var buyBtColor : Number;
		public var buyBtOverColor : Number;
		public var buyBtBackgroundColor : Number;
		public var buyBtBackgroundOverColor : Number;
		//
		public var durationColor : Number;
		public var durationOverColor : Number;
		public var durationBackgroundColor : Number;
		//
		public var itemFillColor : Number;
		private var itemOverFillColor : Number;
		//
		public var itemStrokeColor : Number;
		public var itemStrokeOverColor : Number;
		private var itemOverStrokeColor : Number;
		private var itemOverTime : Number = 0.5;
		//
		public var floatTextStep : Number = 0.5;
		//
		private var ratingXMLObjet : XML;
		private var currency : String = "$";
		private var textRightToLeft : Boolean;

		//CONSTRUCTOR
		public function List()
		{
			// Prototypes			
			new Prototypes();
			
			ColorShortcuts.init();
			FilterShortcuts.init();
			
//			mcAllItems.mask = mcMask;
			mcAllItems.mcItem.visible = false;
			mcAllItems.cacheasBitmap = true;
			mcScroller.visible = false;
		}
		
		public function setRatingOncurrentItem(totalVotes : Number = NaN, rating : Number = NaN) : void 
		{
		}

		public function setCurrency(pCurrency : String = "") : void
		{
			currency = pCurrency;
		} 
		public function setPathTo(pPathToFiles : String = "") : void 
		{
			pathToFiles = pPathToFiles; 
		}

		public function initWithXMLAndArray(pComponentWidth : Number = NaN, pComponentHeight : Number = NaN, 
									  ppathToFiles : String = "",
									  settingsObject : XMLList = null, pArray : Array = null, 
									  pReleaseFunction : Function = null, pExtBeginListFunction : Function = null, pExtEndListFunction : Function = null) : void
		{
			// RESET EVERYTHING
			reset();			
			
			// READ THE PARAMS
			// dimensions of the component 
			componentWidth = pComponentWidth;
			componentHeight = pComponentHeight;
			// path to giles
			pathToFiles = ppathToFiles;
						
			// general settings
			nrColumns = Prototypes.readNumberVar(settingsObject.nrColumns, nrColumns);
			nrLines = Prototypes.readNumberVar(settingsObject.nrLines, nrLines);
			distanceX = Prototypes.readNumberVar(settingsObject.distanceX, distanceX);
			distanceY = Prototypes.readNumberVar(settingsObject.distanceY, distanceY);
			//
			itemDimension = Prototypes.readNumberVar(settingsObject.itemDimension, !isNaN(nrColumns) ? mcAllItems.mcItem.height : mcAllItems.mcItem.width);
			itemsContentDistX = Prototypes.readNumberVar(settingsObject.itemContentDistX, itemsContentDistX);						
			
			// scroll settings
			scrollDimension = Prototypes.readNumberVar(settingsObject.scrollDimension, scrollDimension);
			scrollOfsset = Prototypes.readNumberVar(settingsObject.scrollOfsset, scrollOfsset);
			scrollBarColor = Prototypes.readNumberVar(settingsObject.scrollBarColor, scrollBarColor);
			scrollScrubColor = Prototypes.readNumberVar(settingsObject.scrollScrubColor, scrollScrubColor);
			
			// items content settings
			numberColor = Prototypes.readNumberVar(settingsObject.numberTextColor);
			numberOverColor = Prototypes.readNumberVar(settingsObject.numberTextColor.@over);
			numberBackgroundColor = Prototypes.readNumberVar(settingsObject.numberBackgroundColor);
			//
			titleColor = Prototypes.readNumberVar(settingsObject.titleColor);
			titleOverColor = Prototypes.readNumberVar(settingsObject.titleColor.@over);
			//
			buyBtColor = Prototypes.readNumberVar(settingsObject.buyBtText.@normalColor);
			buyBtOverColor = Prototypes.readNumberVar(settingsObject.buyBtText.@overColor);
			buyBtBackgroundColor = Prototypes.readNumberVar(settingsObject.buyBtBackgroundColor);
			buyBtBackgroundOverColor = Prototypes.readNumberVar(settingsObject.buyBtBackgroundColor.@over);
			//
			durationColor = Prototypes.readNumberVar(settingsObject.durationTextColor);
			durationOverColor = Prototypes.readNumberVar(settingsObject.durationTextColor.@over);
			durationBackgroundColor = Prototypes.readNumberVar(settingsObject.durationBackgroundColor);
			//
			itemFillColor = Prototypes.readNumberVar(settingsObject.itemFillColor);
			itemOverFillColor = Prototypes.readNumberVar(settingsObject.itemFillOverColor); //trace("itemOverFillColor:", itemOverFillColor);
			//
			itemStrokeColor = Prototypes.readNumberVar(settingsObject.itemStrokeColor);
			itemOverStrokeColor = Prototypes.readNumberVar(settingsObject.itemOverStrokeColor);
			
			
			// OTHER PARAMS
			externalReleaseFunction = pReleaseFunction;
			extBeginListFunction = pExtBeginListFunction;	
			extEndListFunction = pExtEndListFunction;	
			
			
			// CALCULATE ITEMS DIMENSIONS
			if(!isNaN(nrColumns)) trackWidth = (componentWidth - (scrollDimension - (scrollOfsset < 0 ? 2 * scrollOfsset : 0)) - (nrColumns * distanceX - distanceX)) / nrColumns;
			if(!isNaN(nrLines))  trackHeight = (componentHeight - (scrollDimension - (scrollOfsset < 0 ? 2 * scrollOfsset : 0)) - (nrLines * distanceY - distanceY)) / nrLines;					
		
			
			// RESIZE the component for the first time
			resize(componentWidth, componentHeight);		
			
			
			// LOAD LIST
			if(pArray != null && pArray.length > 0) loadList(pArray);
			
			// show scroller
			mcScroller.init(scrollDimension, mcMask.height, mcAllItems, mcMask, scrollOfsset, true, true, "none", 0, true, 2, scrollBarColor, -1, scrollBarColor, -1, scrollScrubColor, -1, -1);
			mcScroller.visible = true;
		}
		
		public function loadList(pArray : Array, randomStart : Boolean = false) : void	
		{
			// clear everything
			reset();
			
			// CREATE THE LIST of items
			createList(pArray);	
			
			// set random
			setRandom(randomStart);
			
			// select the first item
			var startItem : Number = (randomStart ? Prototypes.randomBetween(0, (itemsArray ? itemsArray.length-1 : 0)) : 0); //trace("list startItem:", startItem);
			selectItemNo(startItem);
		} 
		
		/**
		 * CREATE LIST
		 */
		public function createList(objectsArray : Array) : void
		{
			// create the list of items if is the case
			if(objectsArray)
			{
				itemsArray = new Array();
				noItems = objectsArray.length;
				var maxDurationWidth : Number = 0;
				var maxBuyWidth : Number = 0;
				var mc : MovieClip;
				for(var i : uint = 0; i < noItems; i++)
				{
					// CLIENT ITEM
					mc = mcAllItems.duplicateMovieClip(new mcListItem(), "mcItem" + i);
					
					// retain data
					mc.track = objectsArray[i];
					mc.index = i;
					
					// set background
					mc.mcBack.width = trackWidth;
					mc.mcBack.height = itemDimension;
					mc.mcBack.setColor(itemFillColor);
					mc.mcBack.mouseEnabled = false;
					mc.mcBack.mouseChildren = false;
					//
					mc.mcStroke.width = mc.mcBack.width - 1;
					mc.mcStroke.height = itemDimension - 1;
					//mc.mcStroke.x = 0.5;
					mc.mcStroke.y = 0.5;
					if(itemStrokeColor >= 0) mc.mcStroke.setColor(itemStrokeColor);
					else mc.mcStroke.visible = false;
					mc.mcStroke.mouseEnabled = false;
					mc.mcStroke.mouseChildren = false;									
					
					// set number
					mc.mcNumber.mcText.x = itemsTextMargin;
					mc.mcNumber.mcText.txt.initText( ((i + 1) < 10 ? (noItems > 99 ? "00" : "0") : (noItems > 99 ? "0" : "")) + (i + 1) + ".");
					mc.mcNumber.mcText.setColor(numberColor);
					mc.mcNumber.mcText.mcMask.visible = false;
					//
					if(numberBackgroundColor >= 0) mc.mcNumber.mcBack.setColor(numberBackgroundColor);
					else mc.mcNumber.mcBack.alpha = 0;
					mc.mcNumber.mcBack.width = Math.round(mc.mcNumber.mcText.width + 2 * itemsTextMargin); //trace(mc.mcNumber.mcBack.width);
					mc.mcNumber.mcText.centerOnClip(mc.mcNumber.mcBack);
					//
					mc.mcNumber.x = itemsContentDistX;
					mc.mcNumber.y = Math.round((itemDimension - mc.mcNumber.mcBack.height)/2);
					//
					mc.mcNumber.mouseEnabled = false;
					mc.mcNumber.mouseChildren = false;
									
					// add track title
					mc.mcText.txt.initText(objectsArray[i].getTitle);
					mc.mcText.setColor(titleColor);
					//
					mc.mcText.x = mc.mcNumber.x + mc.mcNumber.mcBack.width + 2 * itemsContentDistX;
					mc.mcText.centerOn(NaN, itemDimension);
					//
					mc.mcText.mcMask.height = mc.mcText.txt.height;
					mc.mcText.txt.mask = mc.mcText.mcMask;				
					//
					mc.mcText.mouseEnabled = false;
					mc.mcText.mouseChildren = false;				
					
					// add duration
					mc.mcDuration.visible = (objectsArray[i].getDuration != ""); //trace("duration: >" + objectsArray[i].getDuration + "<" + mc.mcDuration.visible);
					//			
					mc.mcDuration.mcText.txt.initText(objectsArray[i].getDuration);
					mc.mcDuration.mcText.setColor(durationColor);
					mc.mcDuration.mcText.x = itemsTextMargin;
					mc.mcDuration.mcText.centerOnClip(mc.mcDuration.mcBack);
					mc.mcDuration.mcText.mcMask.visible = false;
					//
					if(durationBackgroundColor >= 0) mc.mcDuration.mcBack.setColor(durationBackgroundColor);
					else mc.mcDuration.mcBack.alpha = 0;
					mc.mcDuration.mcBack.width = Math.round(mc.mcDuration.mcText.width + 2 * itemsTextMargin); //trace(mc.mcNumber.mcBack.width);
					if(maxDurationWidth < mc.mcDuration.mcBack.width) maxDurationWidth = mc.mcDuration.mcBack.width;				
					//
	//				mc.mcDuration.x = mc.mcBack.width - (mc.mcDuration.visible ? (mc.mcDuration.mcBack.width + itemsContentDistX) : 0);
					mc.mcDuration.y = Math.round((itemDimension - mc.mcDuration.mcBack.height)/2);
					//
					mc.mcDuration.mouseEnabled = mc.mcDuration.mouseChildren = false;
					
					// buy bt		
					mc.mcBuyBt.visible = (objectsArray[i].getBuyLink != "");
					//			
					mc.mcBuyBt.mcText.txt.initText(objectsArray[i].getBuy + (objectsArray[i].getPrice > 0 ? (" (" + currency + objectsArray[i].getPrice + ")") : ""));
					mc.mcBuyBt.mcText.setColor(buyBtColor);
					mc.mcBuyBt.mcText.x = itemsTextMargin;
					mc.mcBuyBt.mcText.centerOnClip(mc.mcBuyBt.mcBack);
					//
					if(buyBtBackgroundColor >= 0) mc.mcBuyBt.mcBack.setColor(buyBtBackgroundColor);
					else mc.mcBuyBt.mcBack.alpha = 0;
					mc.mcBuyBt.mcBack.width = Math.round(mc.mcBuyBt.mcText.width + 2 * itemsTextMargin); //trace(mc.mcNumber.mcBack.width);
					if(maxBuyWidth < mc.mcBuyBt.mcBack.width) maxBuyWidth = mc.mcBuyBt.mcBack.width;
					//
					mc.mcBuyBt.y = Math.round((itemDimension - mc.mcBuyBt.mcBack.height)/2);
					//
					mc.mcBuyBt.addEvents(this);
					mc.mcBuyBt.mouseChildren = false;				
					
					// separators
					mc.mcLeftSeparator.height = mc.mcRightSeparator.height = itemDimension;
					if(itemStrokeColor >= 0) 
					{
						mc.mcLeftSeparator.setColor(itemStrokeColor);	
						mc.mcRightSeparator.setColor(itemStrokeColor);
					}
					else mc.mcLeftSeparator.visible = mc.mcRightSeparator.visible = false;
					mc.mcLeftSeparator.x = mc.mcText.x - itemsContentDistX; 	
					mc.mcRightSeparator.visible = mc.mcDuration.visible; //trace(mc.mcRightSeparator.visible, mc.mcDuration.visible);
					
					// add events
					mc.addEvents(this);
					mc.addEventListener(MouseEvent.MOUSE_MOVE, itemMouseMoveHandler); 
					
					// position based on columns
					if(!isNaN(nrColumns))
					{
						mc.x = (trackWidth + distanceX) * (i % nrColumns);
						mc.y = (itemDimension + distanceY) * (int(i / nrColumns));
					}
					else
					{
						mc.x = (itemDimension + distanceX) * (i / nrLines);
						mc.y = (trackHeight + distanceY) * (int(i % nrLines));
					}				
					
					// add the item in the array
					itemsArray[i] = mc;
				}
				
				// resize the background of the buy buttons based on the longest one
				for(i = 0; i < noItems; i++)
				{
					mc = itemsArray[i];
					
					// resize duration to max
					mc.mcDuration.mcBack.width = maxDurationWidth;
					mc.mcDuration.mcText.centerOn(mc.mcDuration.mcBack.width);
					
					// resize buy bt to max
					mc.mcBuyBt.mcBack.width = maxBuyWidth;
					mc.mcBuyBt.mcText.centerOn(mc.mcBuyBt.mcBack.width);					
					
					// resize and reposition elements inside
					resizeItem(i);					
				}
			}
			
			// reset the scroller
//			if(mcAllItems.height > mcMask.height) 
			mcScroller.updateScrub(0, 0);			
		}
		
		// resize an item
		public function resizeItem(i : Number) : void
		{
			var mc : MovieClip = mcAllItems["mcItem" + i];
			
			// resize background
			mc.mcBack.width = trackWidth;	
			mc.mcStroke.width = mc.mcBack.width - 1;
			
			// position duration
			mc.mcDuration.x = mc.mcBack.width - (mc.mcDuration.visible ? (mc.mcDuration.mcBack.width) : 0) - itemsContentDistX;
			
			// position right separator
			mc.mcRightSeparator.x = mc.mcDuration.x;
			
			// position buy bt
			mc.mcBuyBt.x = mc.mcDuration.x - (mc.mcBuyBt.visible ? mc.mcBuyBt.mcBack.width : 0);
			
			// resize text
			mc.mcText.mcMask.width = mc.mcBuyBt.x - mc.mcText.x - itemsContentDistX;
			
			if(textRightToLeft)
			{
				mc.mcText.txt.x = mc.mcText.mcMask.width - mc.mcText.txt.width;
			}
			
			mc.mcText.checkFloat(floatTextStep); //trace("list:", floatTextStep);			
		}
		
		// remove the programs before creating a new set
		public function reset() : void
		{
			// clear items list
			if(itemsArray)
			{
				for(var i : uint = 0; i < itemsArray.length; i++)
				{
					if(itemsArray[i] != null && mcAllItems.contains(itemsArray[i])) mcAllItems.removeChild(itemsArray[i]);
				}
			}
			itemsArray = null;
			
			// reset current selected item
			currSelectedItem = null;	
			
			// move the content to 0
			mcAllItems.y = mcMask.y;		
		}	
		
		/**
		 * RESIZE FUNCTION
		 */		
		public function resize(w: Number, h : Number) : void
		{
			// mask dimensions
			mcMask.width = w - scrollDimension;
			mcMask.height = h;
			
			// resize list elements
			trackWidth = (mcMask.width - (scrollDimension - (scrollOfsset < 0 ? 2 * scrollOfsset : 0)) - (nrColumns * distanceX - distanceX)) / nrColumns;
			for(var i : Number = 0; i < noItems; i++) resizeItem(i);
			
			// scroll bar
			mcScroller.x = w - scrollDimension + (scrollOfsset < 0 ? scrollOfsset : 0);
			mcScroller.y = mcMask.y;
			mcScroller.resize(scrollDimension, mcMask.height);
		}

		/**
		 * PREV ITEM in list
		 */
		public function prev(loop : Boolean = true) : void
		{
			// read the current item's index
			var id : Number = currSelectedItem != null ? (!random ? currSelectedItem.index : randomArray.indexOf(currSelectedItem)) : 1;	
			
			// go next if is the case
			if(random) goPrev(id);
			else
			{
				// if begin of list
				if(id == 0)
				{
					if(loop) 
					{
//						trace("GO BACK TO LAST SONG");
						goPrev(id);
					}
					else
					{
//						trace("PREV ALBUM"); 
						extBeginListFunction();
					}
				}
				else 
				{
//					trace("PREV SONG");
					goPrev(id);
				}
			}						
		}
		public function goPrev(id : Number) : void
		{
			// decrease the id
			id--;
			if(id == -1) id = itemsArray.length - 1;
			
			// call the select item function
			releaseFunction(!random ? itemsArray[id] : randomArray[id]);			
		}
		
		/**
		 * NEXT ITEM in list
		 */				
		public function next(loop : Boolean = true) : void
		{
			// read the current item's index
			var id : Number = currSelectedItem != null ? (!random ? currSelectedItem.index : randomArray.indexOf(currSelectedItem)) : -1;	
			
			// go next if is the case
			if(random) goNext(id);
			else
			{
				// if end of list
				if(id == itemsArray.length-1)
				{
					if(loop) 
					{
//						trace("GO BACK FIRST SONG");
						goNext(id);
					}
					else
					{
//						trace("NEXT ALBUM"); 
						extEndListFunction();
					}
				}
				else 
				{
//					trace("NEXT SONG");
					goNext(id);
				}
			}
		}
		public function goNext(id : Number) : void
		{
			// increase the id
			id++;
			if(id == itemsArray.length)
			{
				if(hasToRepeat)
				{
					id = 0;
					// call the select item function
					releaseFunction(!random ? itemsArray[id] : randomArray[id]);
				}
				else
				{
					dispatchEvent(new Event("reachedEndOfTheList", true));
				}
			}
			else
			{
				// call the select item function
				releaseFunction(!random ? itemsArray[id] : randomArray[id]);
			}
		}
		
		/*************************************
		 * 
		 * 			AUX FUNCTIONS
		 * 
		 *************************************/
		public function setRandom(flag : Boolean = true) : void
		{
			random = flag;
			if(flag && itemsArray) 
			{
				randomArray = Prototypes.randomize(itemsArray);
				
//				trace("\RANDOM:", random);
//				Prototypes.traceArray(itemsArray, "index");
//				Prototypes.traceArray(randomArray, "index");
			}
			else randomArray = null;
		}		
		
		public function setRatingXMLObjet(pXMLObjet : XML) : void
		{
			ratingXMLObjet = pXMLObjet;
		}
		
		/************************************************************
		 *
		 *					EVENT HANDLERS
		 * 
		 *************************************************************/				
		
		/**
		 * OVER EVENT HANDLER
		 */
		public function overHandler(event : MouseEvent) : void
		{
			var mc : MovieClip = event.currentTarget as MovieClip;
			
			//if(event.target.name == "mcBuyBt") mc = mc.mcBuyBt;
			
			// if is an item
			overToggle(mc);
		}

		/**
		 * OUT HANDLER
		 */
		public function outHandler(event : MouseEvent) : void
		{
			var mc : MovieClip = event.currentTarget as MovieClip;
			
			//if(event.target.name == "mcBuyBt") mc = mc.mcBuyBt;
			
			// if is an item
			if(mc.parent == mcAllItems) 
				if(mc != currSelectedItem) overToggle(mc, false);
		}
		
		public function overToggle(mc : MovieClip, flag : Boolean = true) : void
		{
			if(mc)
			{
				// if is an item
				var mcParent : MovieClip = mc.parent as MovieClip;
				if(mcParent == mcAllItems)
				{
					// item number
					mc.mcNumber.mcText.setColor(flag ? numberOverColor : numberColor, itemOverTime, "easeOutExpo", true); 
					
					// item title
					mc.mcText.setColor(flag ? titleOverColor : titleColor, itemOverTime, "easeOutExpo", true);
					
					// item buy bt text
					if(!flag) overToggle(mc.mcBuyBt, flag);
					
					// item duration
					mc.mcDuration.mcText.setColor(flag ? durationOverColor : durationColor, itemOverTime, "easeOutExpo", true);
					
					// item background 
					mc.mcBack.setColor(flag ? itemOverFillColor : itemFillColor, itemOverTime, "easeOutExpo", true);
					//mc.mcStroke.setColor(flag ? itemStrokeOverColor : itemStrokeColor, itemOverTime, "easeOutExpo", true);
				}
				
				// an item's buy bt
				if(mc.name == "mcBuyBt") 
				{
					mc.mcText.setColor(flag ? buyBtOverColor : buyBtColor, itemOverTime, "easeOutExpo");
					mc.mcBack.setColor(flag ? buyBtBackgroundOverColor : buyBtBackgroundColor, itemOverTime, "easeOutExpo", true);
				}
			}
		}		
		
		// item mouse move handler
		private function itemMouseMoveHandler(e : MouseEvent) : void
		{
			var mcItem : MovieClip = e.currentTarget as MovieClip;
			overToggle(mcItem.mcBuyBt, e.target.name == "mcBuyBt");
		}		

		/**
		 * PRESS EVENT HANDLER
		 */
		public function pressHandler(event : MouseEvent) : void
		{
			var mc : MovieClip = event.currentTarget as MovieClip; 
			//trace("Event.target press..." + event.target);
			
			// set pressed the new item
			currPressedObject = mc;
			if(event.target.name == "mcBuyBt") currPressedObject = mc.mcBuyBt;
		
			// add the release event on stage
			stage.addEventListener(MouseEvent.MOUSE_UP, releaseOutsideHandler);
			stage.addEventListener(Event.MOUSE_LEAVE, releaseOutsideHandler);
		}

		/**
		 * RELEASE OUTSIDE EVENT HANDLER
		 */
		public function releaseOutsideHandler(e : Event) : void 
		{
			stage.removeEventListener(MouseEvent.MOUSE_UP, releaseOutsideHandler);
			stage.removeEventListener(Event.MOUSE_LEAVE, releaseOutsideHandler);
		}


		/**
		 * RELEASE event handler 
		 */
		public function releaseHandler(event : MouseEvent) : void
		{
			var mc :  MovieClip = event.currentTarget as MovieClip; 
			
			// call the specific function
			if(mc == currPressedObject) 
			{
				releaseFunction(mc);
				currPressedObject = null;
			}
		}
		

		/**
		 * RELEASE FUNCTION 
		 */
		public function selectItemNo(pNo : Number = 0) : void
		{
			if(itemsArray && itemsArray[pNo]) releaseFunction(itemsArray[pNo]);
		}
		public function releaseFunction(mc : MovieClip) : void
		{
			if(mc.parent == mcAllItems && mc != currSelectedItem)
			{
				// deselct current item
				overToggle(currSelectedItem, false);
				
				// select this item
				currSelectedItem = mc;
				overToggle(currSelectedItem);
				
				// make sure the new selected item is visible
				var gotPos : Number = mcAllItems.y;
				if(gotPos + mc.y < 0) gotPos = - mc.y;
				if(gotPos + mc.y + mc.mcBack.height > mcMask.y + mcMask.height) gotPos = - (mc.y + mc.mcBack.height) + mcMask.y + mcMask.height;
				Tweener.addTween(mcAllItems, {y : gotPos, time : 0.5, transition : "easeOutExpo", onUpdate : function() : void
				{
					// update scrub after content
					mcScroller.updateScrub(NaN, 0);
				}});
				
				// call external release function
				externalReleaseFunction(mc.track);
			}
			
			// buy button on an item
			if(mc.name == "mcBuyBt")
			{
				var track : Track = (mc.parent as MovieClip).track;
				var link : String = track.getBuyLink; //trace("link:", objectsArray[index].getBuyLink);
				//
				var codeStr : String = "code:";
				var codeStrIndex : Number = link.indexOf(codeStr);
				var code : String = link.substring(codeStrIndex + codeStr.length, link.length);
				
				if(codeStrIndex >= 0)
				{
					if(ExternalInterface.available) ExternalInterface.call("addTrackToCart", code);
				}
				else URLNavigator.ChangePage(link, track.getBuyTarget);
			}
		}
		
		public function setTextOrientation(rightToLeft : Boolean) : void
		{
			textRightToLeft = rightToLeft;
		}
		
		/****************************************************
		 * 
		 * 				AUX FUNCTIONS
		 * 
		 ****************************************************/
		public function get getScope() : List
		{
			return this;
		}
		
		
	} // class
} // package
