﻿/**
 * Copyright (c) 2009 Vuzum LLC <http://www.vuzum.com/>
 */
 package com.vuzum.list 
{
	import flash.text.StyleSheet;
	import flash.text.TextField;
	import flash.events.MouseEvent;
	import flash.display.*;
	import com.vuzum.utils.*;
	import flash.events.Event;
	import flash.display.Shape;	
	
	// OTHER IMPORTS
	import caurina.transitions.properties.ColorShortcuts;
	import caurina.transitions.properties.FilterShortcuts;
	//
	import com.zorked.URLNavigator;

	public class Playlist extends MovieClip
	{
		// COMPONENTS INSIDE
		public var mcTitleAlbum : MovieClip;
		//
		public var mcMask : MovieClip;
		public var mcCaption : MovieClip;
		public var mcScroller : Scroller;
		//
		public var mcList : List;
		//
		public var mcBack : MovieClip;
		
		// HANDLERS EVENTS
		private var currPressedObject : MovieClip;
		
		// INTERNAL MEMBERS
		private var distBetweenComponentsX : Number = 7;
		private var distBetweenComponentsY : Number = 5;
		private var maxCaptionHeight : Number = 45;
		
		// scroll bar settings
		public var scrollDimension : Number = 5;
		public var scrollOfsset : Number = -2;
		public var scrollBarColor : Number;
		public var scrollScrubColor : Number;
		
		public var textRightToLeft : Boolean;		

		//CONSTRUCTOR
		public function Playlist()
		{
			// Prototypes			
			new Prototypes();
			
			// TWEENER			
			ColorShortcuts.init();
			FilterShortcuts.init();
			
			// INIT ELEMENTS
			mcTitleAlbum.txt.initText("");
			//
			mcCaption.mask = mcMask;
//TextField.prototype.initTextEmbed = function(str : String = "", pFontName : String = "", 
//										pMultiline : Boolean = false, pType : String = "dynamic", 
//										pFontSize : Number = NaN, pFontColor : Number = NaN, 
//										pAutoSize : String = "left", pAlign : String = "left", 
//										pMouseEnabled : Boolean = false, pSelectable : Boolean = false, pMouseWheelEnabled : Boolean = false) : void			
			
			mcCaption.txt.mouseWheelEnabled = false;
//			mcCaption.txt.border = true;
			//
			distBetweenComponentsX = mcCaption.x;
			//maxCaptionHeight = mcLine.y - mcTitleAlbum.y; //trace(maxCaptionHeight);
		}
		
		public function init(pWidth : Number = NaN, pHeight : Number = NaN, 
							 pName : String = "", pNameInList : Boolean = false, pCaption : String = "", pTextRightToLeft : Boolean = false,
							 settingsObject : * = null) : void 
		{
			textRightToLeft = pTextRightToLeft;
			
			if(textRightToLeft)
			{
				mcCaption.txt.initText("", true, "dynamic", NaN, NaN, "right", "right");
			}
			else
			{
				mcCaption.txt.initText("", true);
			}
			
			// position the title
			distBetweenComponentsX = Prototypes.readNumberVar(settingsObject.@marginX, distBetweenComponentsX);
			distBetweenComponentsY = Prototypes.readNumberVar(settingsObject.@marginY, distBetweenComponentsY);
			
			// settings
			mcBack.setColor(Prototypes.readNumberVar(settingsObject.backColor));
			mcBack.alpha = Prototypes.readNumberVar(settingsObject.backColor.@opacity, 100) / 100;
			
			// scroll settings
			scrollDimension = Prototypes.readNumberVar(settingsObject.scrollDimension, scrollDimension);
			scrollOfsset = Prototypes.readNumberVar(settingsObject.scrollOfsset, scrollOfsset);
			scrollBarColor = Prototypes.readNumberVar(settingsObject.scrollBarColor, scrollBarColor);
			scrollScrubColor = Prototypes.readNumberVar(settingsObject.scrollScrubColor, scrollScrubColor);
			
			// init scroller
			mcScroller.init(scrollDimension, mcMask.height, 
							mcCaption, mcMask, 
							scrollOfsset, true, true, "none", 0, true, 2, 
							scrollBarColor, -1, scrollBarColor, -1, scrollScrubColor, -1, -1);
//			mcCaption.mask = null;							
			
			// WRITE ALBUM TITLE AND DESCRIPTION
			loadInfo(pName, pNameInList, pCaption);
			
			// RESIZE
			resize(pWidth, pHeight);
			
			mcCaption.txt.mouseEnabled = true;
			mcCaption.mouseChildren = true;
			mcCaption.mouseEnabled = true;
		}
		
		public function loadInfo(pName : String="", pNameInList : Boolean = true, pCaption : String = "", parray : Array = null, randomStart : Boolean = false) : void 
		{
			// write album title
			mcTitleAlbum.txt.htmlText = pName;
			if(!pNameInList || pName == "") 
			{
				mcTitleAlbum.visible = false;
				mcCaption.y = mcMask.y = mcTitleAlbum.y;
			}
			else
			{
				mcTitleAlbum.visible = true;
				mcCaption.y = mcMask.y = mcTitleAlbum.y + mcTitleAlbum.height;
			}
			
			// write album description
			mcCaption.txt.htmlText = pCaption;
			mcMask.height = (pCaption == "" ? 0 : Math.min(mcCaption.height, maxCaptionHeight));
			
			// set up scroller
			mcScroller.x = mcBack.width - mcCaption.x - scrollDimension + (scrollOfsset < 0 ? scrollOfsset : 0);
			mcScroller.y = mcMask.y;
			mcScroller.updateScrub(NaN, 0);			
			mcScroller.visible = false;
							
			
			// load ALBUM LIST and start first item inside
			mcList.loadList(parray, randomStart);
			
			// resize to new dimensions
			resize(mcBack.width, mcBack.height);
		}		
		
		/************************************************************
		 *
		 *					EVENT HANDLERS
		 * 
		 *************************************************************/				
		
		/**
		 * OVER EVENT HANDLER
		 */
		public function overHandler(event : MouseEvent) : void
		{
			var mc : Object = event.currentTarget;
		}

		/**
		 * OUT HANDLER
		 */
		public function outHandler(event : MouseEvent) : void
		{
			var mc : Object = event.currentTarget;
		}
		

		/**
		 * PRESS EVENT HANDLER
		 */
		public function pressHandler(event : MouseEvent) : void
		{
			var mc : MovieClip = MovieClip(event.currentTarget); 
			//trace("Event.target press..." + event.target);
			
			// set pressed the new item
			this.currPressedObject = mc;
		
			// add the release event on stage
			stage.addEventListener(MouseEvent.MOUSE_UP, releaseOutsideHandler);
			stage.addEventListener(Event.MOUSE_LEAVE, releaseOutsideHandler);
		}

		/**
		 * RELEASE OUTSIDE EVENT HANDLER
		 */
		public function releaseOutsideHandler(e : Event) : void 
		{
			stage.removeEventListener(MouseEvent.MOUSE_UP, releaseOutsideHandler);
			stage.removeEventListener(Event.MOUSE_LEAVE, releaseOutsideHandler);
		}

		/**
		 * RELEASE event handler 
		 */
		public function releaseHandler(event : MouseEvent) : void
		{
			var mc : Object = event.currentTarget; 
			
			// call the specific function
			if(mc == currPressedObject) releaseFunction(mc);
		}

		/**
		 * RELEASE FUNCTION 
		 */
		public function releaseFunction(mc : Object) : void
		{
			switch(mc)
			{
//				case mcLogo:
//					URLNavigator.ChangePage(logoURL, "_blank");
//				break;
			}
		}
		
		public function resize(w : Number, h : Number) : void
		{
			// background
			mcBack.width = w;
			mcBack.height = h;
			
			// title
			if(textRightToLeft)
			{
				mcTitleAlbum.x = w - distBetweenComponentsX - mcTitleAlbum.width - mcScroller.width;
			}
			else
			{
				mcTitleAlbum.x = distBetweenComponentsX;
			}
			
			mcTitleAlbum.y = distBetweenComponentsY;
			//mcTitleAlbum.y = (mcTitleAlbum.txt.text == "" ? 0 : distBetweenComponentsY);
			
			// caption
			mcCaption.x = distBetweenComponentsX;
			mcCaption.txt.width = mcMask.width = mcBack.width - 2 * mcCaption.x;
			
			// scroller
			if(mcCaption.height > mcMask.height && mcMask.height > 0) 
			{
				// show scroller
				mcScroller.resize(scrollDimension, mcMask.height);
				mcScroller.visible = true;
				
				// resize content and mask
				mcCaption.txt.width = mcMask.width = mcScroller.x - mcCaption.x;// - (scrollOfsset < 0 ? scrollOfsset : 0);
			}
			else mcScroller.visible = false;
			
			// position the list
			mcList.x = distBetweenComponentsX;
			mcList.y = mcMask.y + mcMask.height + (mcCaption.txt.text == "" ? 0 : distBetweenComponentsY);
			mcList.resize(mcBack.width - 2 * mcList.x, mcBack.height - mcList.y - distBetweenComponentsY);
		}
		

		/****************************************************
		 * 
		 * 				AUX FUNCTIONS
		 * 
		 ****************************************************/
		public function get getScope() : Playlist
		{
			return this;
		}
		
		
	} // class
} // package
