﻿/****************************************
 *  Controller class (AS3) 
 *  by Andrei Neamtu
 *  2009 Vuzum Media, LLC. www.vuzum.com
 ***************************************/
package com.vuzum.mediaplayer
{
	// FLASH IMPORTS
	import com.vuzum.mediaplayer.VolumeControl;

	import flash.text.TextField;
	import flash.text.TextFormat;
	import flash.events.MouseEvent;	
	import flash.display.MovieClip;
	import flash.events.Event;
	import flash.utils.*;
	//
	import flash.display.StageDisplayState;
	import flash.utils.setInterval;

	// OTHER'S IMPORTS
	import caurina.transitions.Tweener;	

	// VUZUM IMPORTS
	import com.vuzum.utils.Prototypes;

	/**
	 * @author Andrei
	 */
	public class Controller extends MovieClip 
	{
		// STATIC MEMBERS
				
		// COMPONENTS INSIDE
		public var mcStopBt : MovieClip;
		//
		public var mcPlayBt : MovieClip;
		public var mcPauseBt : MovieClip;
		//
		public var mcRewindBt : MovieClip;
		public var mcForwardBt : MovieClip;
		//
		public var mcPlayBar : MovieClip;
		//
		public var mcThumbsBt : MovieClip;
		//
		public var mcTimer : MovieClip;
		//
		public var mcVolumeCt : VolumeControl;
		//
		public var mcHdtoggleBt : MovieClip;
		//
		public var mcEmbedBt : MovieClip;
		public var mcShuffleBt : MovieClip;
		public var mcRepeatBt : MovieClip;
		//
		public var mcFullBt : MovieClip;
		//
		public var mcBack : MovieClip;

		// HANDLERS VARS
		public var currPressedObject : MovieClip = new MovieClip();
		public var currentReleasedObject : MovieClip = new MovieClip();		

		// INTERNAL MEMBERS
		public var mcVideoPlayer : MediaPlayer;
		public var tracking : Boolean = false;
		public var firstFinish : Boolean = true;
		//

		// AUX VARS
		private var barPlusArea : Number = 3;

		// CONSTRUCTOR
		function Controller()
		{
			//trace("CONTROLLER CONSTRUCTOR");
			new Prototypes();
			
			mcPlayBar.mcPassedBar.mouseEnabled = mcPlayBar.mcPassedBar.mouseChildren = false;
			mcPlayBar.mcScrub.dimRatio = mcPlayBar.mcScrub.width / mcPlayBar.mcScrub.height;
			//
			mcFullBt.mcSign.percentX = 0.5;
			mcFullBt.mcSign.dimRatio = mcFullBt.mcSign.height / mcFullBt.mcSign.width;
			//
			mcEmbedBt.mcSign.percentY = 0.45; // percent from back
			mcEmbedBt.mcSign.dimRatio = mcEmbedBt.mcSign.mcDownload.width / mcEmbedBt.mcSign.mcDownload.height; // download ratio
			mcEmbedBt.mcSign.dimERatio = mcEmbedBt.mcSign.mcSign.width / mcEmbedBt.mcSign.mcSign.height;// embed ratio
			mcEmbedBt.mcSign.mcText.txt.initText(mcEmbedBt.mcSign.mcText.txt.text);			
			//
			mcRewindBt.mcSign.percentX = mcRewindBt.mcSign.width / mcRewindBt.mcBack.width; 
			mcRewindBt.mcSign.dimRatio = mcRewindBt.mcSign.height / mcRewindBt.mcSign.width;
			//
			mcForwardBt.mcSign.percentX = mcForwardBt.mcSign.width / mcForwardBt.mcBack.width; 
			mcForwardBt.mcSign.dimRatio = mcForwardBt.mcSign.height / mcForwardBt.mcSign.width;			
			//
			mcRepeatBt.mcSign.percentX = mcRepeatBt.mcSign.width / mcRepeatBt.mcBack.width; 
			mcRepeatBt.mcSign.dimRatio = mcRepeatBt.mcSign.height / mcRepeatBt.mcSign.width;			
			//
			mcShuffleBt.mcSign.percentX = mcShuffleBt.mcSign.width / mcShuffleBt.mcBack.width; //trace("mcShuffleBt.mcSign.percentX:", mcRepeatBt.mcSign.percentX); 
			mcShuffleBt.mcSign.dimRatio = mcShuffleBt.mcSign.height / mcShuffleBt.mcSign.width;						
			//
			mcHdtoggleBt.mcSign.txt.initText("");
			mcHdtoggleBt.mcSign.txtOff.initText("");
			//
			mcThumbsBt.mcSign.percentX = 0.5;
			mcThumbsBt.mcSign.dimRatio = mcThumbsBt.mcSign.height / mcThumbsBt.mcSign.width;			
		}
		
		public function writeHdBtText(pText : String = "") : void
		{
			mcHdtoggleBt.mcSign.txt.text = pText;
			mcHdtoggleBt.mcSign.txt.setSize(mcVideoPlayer.hdToggleTextSize, true);
			mcHdtoggleBt.mcSign.x = Math.round((mcHdtoggleBt.mcBack.width - mcHdtoggleBt.mcSign.width) / 2);
		}

		/**
		 * INIT COMPONENT
		 */
		public function init(pWidth : Number, pHeight : Number, pMcVideoPlayer : MediaPlayer) : void
		{
			// internal members
			mcVideoPlayer = pMcVideoPlayer;
			
			// background
			mcBack.addEvents(this);
			mcBack.buttonMode = false;
			
			// CENTER PLAY BUTTON
			mcVideoPlayer.mcCenterPlayBt.alpha = mcVideoPlayer.normalCenterBtAlpha;
			mcVideoPlayer.mcCenterPlayBt.addEvents(this);
			
			// VIDEO BUTTON
			mcVideoPlayer.mcVideoButton.mouseEnabled = false;
			mcVideoPlayer.mcVideoButton.addEvents(this);
			
			// STOP BUTTON
			mcStopBt.x = mcVideoPlayer.controlsDistanceBetween;
			//
			mcStopBt.mcBack.width = mcStopBt.mcBack.height = mcVideoPlayer.controlsDimension;
			//
			mcStopBt.mcOver.width = mcStopBt.mcOver.height = mcStopBt.mcBack.width;
			mcStopBt.mcOver.visible = false;
			//
			mcStopBt.mcSign.width = Math.round(mcStopBt.mcBack.width / 2);
			mcStopBt.mcSign.height = Math.round(mcStopBt.mcBack.height / 2);			
			mcStopBt.mcSign.centerOnClip(mcStopBt.mcBack);				
			//
			if(!mcVideoPlayer.disableStopBt)
			{
				mcStopBt.addEvents(this);
				mcStopBt.mouseEnabled = false;
			}
			else
			{
				mcStopBt.visible = false;
				mcStopBt.scaleX = mcStopBt.scaleY = 0;
			}	
			
			// REWIND BT
			mcRewindBt.x = mcStopBt.x + (!mcVideoPlayer.disableStopBt ? mcStopBt.width + mcVideoPlayer.controlsDistanceBetween : 0);				
			
			// PLAY BUTTON (repostion and resize the width and height)
			mcPlayBt.x = mcRewindBt.x + mcVideoPlayer.controlsDimension + mcVideoPlayer.controlsDistanceBetween;
			//
			mcPlayBt.mcBack.width = mcPlayBt.mcBack.height = mcVideoPlayer.controlsDimension;
			//
			mcPlayBt.mcOver.width = mcPlayBt.mcOver.height = mcPlayBt.mcBack.width;
			mcPlayBt.mcOver.visible = false;
			//
			mcPlayBt.mcSign.width = Math.round(0.45 * mcPlayBt.mcBack.width);
			mcPlayBt.mcSign.height = Math.round(0.5 * mcPlayBt.mcBack.height);
			mcPlayBt.mcSign.centerOnClip(mcPlayBt.mcBack);
			mcPlayBt.mcSign.x++;
			//
			mcPlayBt.mouseChildren = false;
			mcPlayBt.addEvents(this);
			
			
			// PAUSE BUTTON
			mcPauseBt.x = mcPlayBt.x;
			//
			mcPauseBt.mcBack.width = mcPauseBt.mcBack.height = mcPlayBt.mcBack.width;
			//
			mcPauseBt.mcOver.width = mcPauseBt.mcOver.height = mcPauseBt.mcBack.width;
			mcPauseBt.mcOver.visible = false;
			//
			mcPauseBt.mcSign.width = Math.round(mcPauseBt.mcBack.width / 2);
			mcPauseBt.mcSign.height = Math.round(mcPauseBt.mcBack.height / 2);			
			mcPauseBt.mcSign.centerOnClip(mcPauseBt.mcBack);
			//
			mcPauseBt.mouseEnabled = mcPauseBt.mouseChildren = false;
			mcPauseBt.addEvents(this);
			//
			mcPauseBt.visible = false; // in general to begin
			
			
			// REWIND BT
			mcForwardBt.x = mcPlayBt.x + mcPlayBt.width + mcVideoPlayer.controlsDistanceBetween;			
				
			
			// PLAYING BAR
			// back
			mcPlayBar.mcBack.height = mcPlayBar.mcBackBar.height + 2 * mcPlayBar.mcBackBar.x;
			// back bar
			mcPlayBar.mcBackBar.y = mcPlayBar.mcBackBar.x; 
			mcPlayBar.mcBackBar.centerOn(NaN, mcPlayBar.mcBack.height);
			// download
			mcPlayBar.mcDownloadBar.mouseChildren = false;
			mcPlayBar.mcDownloadBar.mcShape.height = mcPlayBar.mcBackBar.height;
			mcPlayBar.mcDownloadBar.mcHit.height = mcPlayBar.mcDownloadBar.mcShape.height + 2 * barPlusArea;
			mcPlayBar.mcDownloadBar.mcHit.y = (-1) * barPlusArea;
			mcPlayBar.mcDownloadBar.mcHit.alpha = 0; 
			mcPlayBar.mcDownloadBar.x = mcPlayBar.mcDownloadBar.y = mcPlayBar.mcBackBar.x;
			// progress bar
			mcPlayBar.mcPassedBar.height = mcPlayBar.mcBackBar.height;
			mcPlayBar.mcPassedBar.x = mcPlayBar.mcPassedBar.y = mcPlayBar.mcBackBar.x;
			// scrub
//			mcPlayBar.mcScrub.width = mcPlayBar.mcScrub.dimRatio * mcPlayBar.mcScrub.height;
			mcPlayBar.mcScrub.y = mcPlayBar.mcBackBar.y + Math.round((mcPlayBar.mcBackBar.height - mcPlayBar.mcScrub.height) / 2);
			// position
			mcPlayBar.x = mcForwardBt.x + mcVideoPlayer.controlsDimension + mcVideoPlayer.controlsDistanceBetween;
			
			// scrub bar event
			mcPlayBar.mcScrub.mouseChildren = false;
			mcPlayBar.mcScrub.addEvents(this);
			// download bar event
			mcPlayBar.mcDownloadBar.mouseChildren = false;
			mcPlayBar.mcDownloadBar.addEvents(this);
			// init the bars inside as stop
			initBars(true);


			// THUMBS BUTTON
			mcThumbsBt.pressed = false;
			//
			mcThumbsBt.mcBack.width = mcThumbsBt.mcBack.height = mcVideoPlayer.controlsDimension;
			//
			mcThumbsBt.mcOver.width = mcThumbsBt.mcOver.height = mcThumbsBt.mcBack.width;
			mcThumbsBt.mcOver.visible = false;
			//
			mcThumbsBt.mcSign.width = mcThumbsBt.mcSign.percentX * mcThumbsBt.mcBack.width;
			mcThumbsBt.mcSign.height = mcThumbsBt.mcSign.dimRatio * mcThumbsBt.mcSign.width;
			mcThumbsBt.mcSign.centerOnClip(mcThumbsBt.mcBack);			
			//
			if(!mcVideoPlayer.disableThumbsBt) mcThumbsBt.addEvents(this);
			else mcThumbsBt.visible = false;


			// FULL SCREEN BUTTON
			mcFullBt.mcBack.width = mcFullBt.mcBack.height = mcVideoPlayer.controlsDimension;
			//
			mcFullBt.mcOver.width = mcFullBt.mcOver.height = mcFullBt.mcBack.width;
			mcFullBt.mcOver.visible = false;
			//
			mcFullBt.mcSign.width = mcFullBt.mcSign.percentX * mcFullBt.mcBack.width;
			mcFullBt.mcSign.height = mcFullBt.mcSign.dimRatio * mcFullBt.mcSign.width;
			mcFullBt.mcSign.centerOnClip(mcFullBt.mcBack);			
			//
			if(!mcVideoPlayer.disableFullBt) mcFullBt.addEvents(this);
			else mcFullBt.visible = false;

			
			// SHARE BUTTON
			mcEmbedBt.mcBack.width = mcEmbedBt.mcBack.height = mcVideoPlayer.controlsDimension;
			// over
			mcEmbedBt.mcOver.width = mcEmbedBt.mcOver.height = mcEmbedBt.mcBack.width;
			mcEmbedBt.mcOver.visible = false;			
			// download sign
			mcEmbedBt.mcSign.mcDownload.visible = mcVideoPlayer.useEmbedBtAsDownloadBt;
			mcEmbedBt.mcSign.mcDownload.scaleX = mcEmbedBt.mcSign.mcDownload.scaleY = (mcEmbedBt.mcSign.mcDownload.visible ? 1 : 0);
			// text / sign
			mcEmbedBt.mcSign.mcText.txt.mouseEnabled = false;
			mcEmbedBt.mcSign.mcText.visible = mcEmbedBt.mcSign.mcSign.visible = !mcEmbedBt.mcSign.mcDownload.visible;
			// if download
			if(mcEmbedBt.mcSign.mcDownload.visible) 
			{
				mcEmbedBt.mcSign.mcText.scaleX = mcEmbedBt.mcSign.mcText.scaleY = 0;
				mcEmbedBt.mcSign.mcSign.scaleX = mcEmbedBt.mcSign.mcSign.scaleY = 0;
				//
				mcEmbedBt.mcSign.height = mcEmbedBt.mcSign.percentY * mcEmbedBt.mcBack.height;
				mcEmbedBt.mcSign.width =  mcEmbedBt.mcSign.dimRatio * mcEmbedBt.mcSign.height,
				mcEmbedBt.mcSign.centerOnClip(mcEmbedBt.mcBack);
			}
			// if embed text/sign
			else
			{
				// embed text
				mcEmbedBt.mcSign.mcText.scaleX = mcEmbedBt.mcSign.mcText.scaleY = (mcVideoPlayer.embedBtText != "");
				// embed sign
				mcEmbedBt.mcSign.mcSign.scaleX = mcEmbedBt.mcSign.mcSign.scaleY = !(mcVideoPlayer.embedBtText != "");				
				
				// embed text
				if(mcVideoPlayer.embedBtText != "")
				{
					mcEmbedBt.mcSign.mcText.txt.htmlText = mcVideoPlayer.embedBtText;
					mcEmbedBt.mcSign.mcText.txt.setSize(mcVideoPlayer.embedBtTextSize);
					mcEmbedBt.mcSign.mcText.y = Math.round((mcEmbedBt.mcBack.height - mcEmbedBt.mcSign.mcText.txt.textHeight) / 2);
					mcEmbedBt.mcSign.mcText.x = mcEmbedBt.mcSign.mcText.y;
					//
					mcEmbedBt.mcSign.mcText.txt.setSize(mcVideoPlayer.embedBtTextSize, true);
					//
					mcEmbedBt.mcBack.width = 2 * mcEmbedBt.mcSign.mcText.x + mcEmbedBt.mcSign.mcText.txt.width;
					mcEmbedBt.mcOver.width = mcEmbedBt.mcBack.width;
				}
				// embed sign
				else 
				{		
					mcEmbedBt.mcSign.height = mcEmbedBt.mcSign.percentY * mcEmbedBt.mcBack.height;
					mcEmbedBt.mcSign.width =  mcEmbedBt.mcSign.dimERatio * mcEmbedBt.mcSign.height,
					//
					mcEmbedBt.mcSign.centerOnClip(mcEmbedBt.mcBack);
				}
			}
			//
			if(mcVideoPlayer.disableEmbedBt) // hide the button
			{
				// move the other controllers
//				mcHdtoggleBt.x += mcEmbedBt.width;
//				mcVolume.x += mcEmbedBt.width;
				
				// hide it
				mcEmbedBt.visible = false;
			}
			// show the button
			else
			{
				mcEmbedBt.mouseChildren = false;
				mcEmbedBt.addEvents(this);
				mcEmbedBt.hidden = true;
			}
			
			
			// REWIND BUTTON
			mcRewindBt.mcBack.width = mcRewindBt.mcBack.height = mcVideoPlayer.controlsDimension;
			mcRewindBt.mcSign.width = mcRewindBt.mcSign.percentX * mcRewindBt.mcBack.width;
			mcRewindBt.mcSign.height = mcRewindBt.mcSign.dimRatio * mcRewindBt.mcSign.width;
			mcRewindBt.mcSign.centerOnClip(mcRewindBt.mcBack);	
			mcRewindBt.addEvents(this);			
			
			// FORWARD BUTTON
			mcForwardBt.mcBack.width = mcForwardBt.mcBack.height = mcVideoPlayer.controlsDimension;
			mcForwardBt.mcSign.width = mcForwardBt.mcSign.percentX * mcForwardBt.mcBack.width;
			mcForwardBt.mcSign.height = mcForwardBt.mcSign.dimRatio * mcForwardBt.mcSign.width;
			mcForwardBt.mcSign.centerOnClip(mcForwardBt.mcBack);	
			mcForwardBt.addEvents(this);						
			
			
			// REPEAT BUTTON
			mcRepeatBt.mcBack.width = mcRepeatBt.mcBack.height = mcVideoPlayer.controlsDimension;
			mcRepeatBt.mcSign.width = mcRepeatBt.mcSign.percentX * mcRepeatBt.mcBack.width;
			mcRepeatBt.mcSign.height = mcRepeatBt.mcSign.dimRatio * mcRepeatBt.mcSign.width;
			mcRepeatBt.mcSign.centerOnClip(mcRepeatBt.mcBack);	
			mcRepeatBt.addEvents(this);
			

			// SHUFFLE BUTTON
			mcShuffleBt.mcBack.width = mcShuffleBt.mcBack.height = mcVideoPlayer.controlsDimension;
			mcShuffleBt.mcSign.width = mcShuffleBt.mcSign.percentX * mcShuffleBt.mcBack.width;
			mcShuffleBt.mcSign.height = mcShuffleBt.mcSign.dimRatio * mcShuffleBt.mcSign.width;
			mcShuffleBt.mcSign.centerOnClip(mcShuffleBt.mcBack);
			if(mcVideoPlayer.disableRandomBt) mcShuffleBt.visible = false;	
			else mcShuffleBt.addEvents(this);		
			
			
			// HD BUTTON
			mcHdtoggleBt.mcBack.width = mcHdtoggleBt.mcBack.height = mcVideoPlayer.controlsDimension;
			//
			mcHdtoggleBt.mcOver.width = mcHdtoggleBt.mcOver.height = mcHdtoggleBt.mcBack.height;
			//
			mcHdtoggleBt.mcSign.txt.mouseEnabled = false;
			mcHdtoggleBt.mcSign.txt.text = mcVideoPlayer.hdToggleSDText;
			mcHdtoggleBt.mcSign.txt.setSize(mcVideoPlayer.hdToggleTextSize);
			//
			mcHdtoggleBt.mcSign.y = Math.round((mcHdtoggleBt.mcBack.height - mcHdtoggleBt.mcSign.txt.textHeight) / 2);
			mcHdtoggleBt.mcSign.x = mcHdtoggleBt.mcSign.y;
			//
			mcHdtoggleBt.mcSign.txt.setSize(mcVideoPlayer.hdToggleTextSize, true);
			//
			mcHdtoggleBt.mcBack.width = mcHdtoggleBt.mcOver.width = 2 * mcHdtoggleBt.mcSign.x + mcHdtoggleBt.mcSign.txt.width;
			//			
			if(mcVideoPlayer.disableHdBt)
			{
				// move the other controllers
//				mcVolume.x += mcHdtoggleBt.mcBack.width;
				
				// hide it
				mcHdtoggleBt.visible = false;
			}
			else
			{
				mcHdtoggleBt.mcOver.visible = false;
				mcHdtoggleBt.addEvents(this);
			}
			disableHD();						
			
						
			
			/*
			 * VOLUME CONTROL
			 */
			// VOLUME BUTTON
			mcVolumeCt.initWithXMLObject(mcVideoPlayer.controlsDimension, mcVideoPlayer.setVolume, mcVideoPlayer.verticalVolume, mcVideoPlayer.startVolume, mcVideoPlayer.volumeXMLObject);
			// level bar
//			mcVolume.mcHVolumeBar.mcLevelBar.width = mcVideoPlayer.volumeBarWidth;
//			mcVolume.mcHVolumeBar.mcLevelBar.height = mcVideoPlayer.volumeBarHeight;
//			// back bar
//			mcVolume.mcHVolumeBar.mcBackBar.width = mcVideoPlayer.volumeBarWidth;
//			mcVolume.mcHVolumeBar.mcBackBar.height = mcVideoPlayer.volumeBarHeight;
//			// mask
//			mcVolume.mcHVolumeBar.mcMaskBar.width = mcVideoPlayer.volumeBarWidth;
//			mcVolume.mcHVolumeBar.mcMaskBar.height = mcVideoPlayer.volumeBarHeight;
//			// back
//			mcVolume.mcHVolumeBar.mcBack.width = mcVideoPlayer.volumeBarWidth;
//			mcVolume.mcHVolumeBar.mcBack.height = mcVideoPlayer.volumeBarHeight;
//			mcVolume.mcHVolumeBar.x = (mcVolume.mcVolumeBt.visible ? mcVolume.mcVolumeBt.width + mcVideoPlayer.controlsDistanceBetween : 0);
			// visibility
			mcVolumeCt.visible = !mcVideoPlayer.disableVolumeCt;
			
			
			// SHUFFLE BT
			
			
			// TIMER
			mcTimer.mouseEnabled = mcTimer.mouseChildren = false;
			mcTimer.visible = !mcVideoPlayer.disableTimer;
			//
			mcTimer.mcSign.tPassedTime.initText("00:00");
			mcTimer.mcSign.tPassedTime.setSize(mcVideoPlayer.timerTextSize);
			//
			mcTimer.mcSign.tSeparator.initText("/");
			mcTimer.mcSign.tSeparator.setSize(mcVideoPlayer.timerTextSize);
			mcTimer.mcSign.tSeparator.x = mcTimer.mcSign.tPassedTime.x + Math.ceil(mcTimer.mcSign.tPassedTime.textWidth);
			//
			mcTimer.mcSign.tTotalTime.initText("00:00");
			mcTimer.mcSign.tTotalTime.setSize(mcVideoPlayer.timerTextSize);
			mcTimer.mcSign.tTotalTime.x = mcTimer.mcSign.tSeparator.x + mcTimer.mcSign.tSeparator.textWidth;
			//			
//			mcTimer.mcSign.tPassedTime.embedFonts = mcTimer.mcSign.tTotalTime.embedFonts = mcTimer.mcSign.tSeparator.embedFonts = true;				
//			mcTimer.mcSign.tPassedTime.border = mcTimer.mcSign.tTotalTime.border = mcTimer.mcSign.tSeparator.border = true; //mcTimer.mcSign.tPassedTime.text = "VALUE";				
			//
			mcTimer.mcBack.height = mcVideoPlayer.controlsDimension;
			mcTimer.mcSign.x = mcTimer.mcSign.y = Math.round((mcTimer.mcBack.height - mcTimer.mcSign.tPassedTime.textHeight) / 2);
			mcTimer.mcSign.y = Math.round((mcTimer.mcBack.height - mcTimer.mcSign.tTotalTime.textHeight) / 2);
			mcTimer.mcBack.width = 2 * mcTimer.mcSign.x + mcTimer.mcSign.width;
						
			

			// RESIZE the controller
			resize(pWidth, pHeight);			
		}

		/*
		 * (de)activate the controls depending on the video / image mode
		 */
		public function activateControls(flag : Boolean = true) : void
		{
			mcVideoPlayer.mcVideoButton.mouseEnabled = flag;
			//
			mcStopBt.alpha = (flag ? 1 : 0.5);
			//
			mcPlayBt.alpha = (flag ? 1 : 0.5);
			mcPlayBt.mouseEnabled = flag;
			//
			mcPauseBt.alpha = (flag ? 1 : 0.5);
			mcPauseBt.mouseEnabled = flag;
			//
			mcVolumeCt.alpha = (flag ? 1 : 0.5);
			mcVolumeCt.mouseEnabled = mcVolumeCt.mouseChildren = flag;
			//
			mcPlayBar.alpha = (flag ? 1 : 0.5);
			mcPlayBar.mcDownloadBar.mouseEnabled = flag;
			mcPlayBar.mcScrub.mouseEnabled = flag;
			//
			mcTimer.alpha = (flag ? 1 : 0.5);
			//
			mcVideoPlayer.showPlayFlag = flag;
		}		

		public function disableHD(flag : Boolean = true) : void
		{
			if(flag) 
			{
				mcHdtoggleBt.alpha = 0.5;
				mcHdtoggleBt.removeEvents(this);
			}			
			else 
			{
				mcHdtoggleBt.alpha = 1;
				mcHdtoggleBt.addEvents(this);
			}			
		}
		
		public function resetSkipBts(flag : Boolean = true) : void
		{
			mcRewindBt.visible = mcForwardBt.visible = flag;
			
			resize();
		}

		/*****************************************************
		 * 
		 * 					EVENT HANDLERS
		 * 					
		 *****************************************************/
		
		/*
		 * resizes the controller
		 */
		public function resize(pWidth : Number = NaN, pHeight : Number = NaN) : void
		{
			// BACKGROUND
			mcBack.width = pWidth;
			mcBack.height = pHeight;
//			mcBack.mcFill.width = pWidth; //trace(mcBack.width);
//			mcBack.mcFill.height = pHeight; //trace(mcBack.height);
//			mcBack.mcBright.width = pWidth;
//			mcBack.mcBright.height = pHeight / 2;
			
			// STOP BT
//			mcStopBt.x = (mcVideoPlayer.disableStopBt ? 0 : mcVideoPlayer.controlsDistanceBetween);
			mcStopBt.centerOn(NaN, mcBack.height);
			
			// PLAY BUTTON (repostion and resize the width and height)
			mcPlayBt.x = mcRewindBt.x + (!mcRewindBt.visible ? 0 : mcVideoPlayer.controlsDimension + mcVideoPlayer.controlsDistanceBetween);
			mcPlayBt.centerOn(NaN, mcBack.height);
			
			// PAUSE BUTTON
			mcPauseBt.x = mcPlayBt.x;
			mcPauseBt.y = mcPlayBt.y;
			
			// STOP BUTTON
			//mcStopBt.x = pWidth - mcStopBt.initX;
			mcStopBt.y = mcPlayBt.y;
			
			// Rewind BUTTON
			mcRewindBt.y = mcForwardBt.y = mcPlayBt.y;			
			
			
			//--------------- from here reposition ------------------
			// FULL SCREEN BUTTON
			mcFullBt.x = mcBack.x + mcBack.width - (mcVideoPlayer.disableFullBt ? 0 : mcFullBt.width + mcVideoPlayer.controlsDistanceBetween);
			mcFullBt.centerOn(NaN, mcBack.height);
			
			// EMBED BUTTON
			mcEmbedBt.x = mcFullBt.x - (mcVideoPlayer.disableEmbedBt ? 0 : mcEmbedBt.width + mcVideoPlayer.controlsDistanceBetween);
			mcEmbedBt.centerOn(NaN, mcBack.height);
			
			// REPEAT BUTTON
			mcRepeatBt.x = mcEmbedBt.x - (mcRepeatBt.width + mcVideoPlayer.controlsDistanceBetween);
			mcRepeatBt.centerOn(NaN, mcBack.height);
			
			// SHUFFLE BUTTON 
			mcShuffleBt.x = mcRepeatBt.x - (mcVideoPlayer.disableRandomBt ? 0 : mcShuffleBt.width + mcVideoPlayer.controlsDistanceBetween);
			mcShuffleBt.centerOn(NaN, mcBack.height);
			
			// VOLUME CONTROL
			mcVolumeCt.x = mcShuffleBt.x - (mcVideoPlayer.disableVolumeCt ? 0 : mcVolumeCt.mcBack.width + mcVideoPlayer.controlsDistanceBetween);
			mcVolumeCt.y = Math.round((mcBack.height - mcVideoPlayer.controlsDimension) / 2);
			
			
			// HD BUTTON
			mcHdtoggleBt.x = mcVolumeCt.x - (mcVideoPlayer.disableHdBt ? 0 : mcHdtoggleBt.width + mcVideoPlayer.controlsDistanceBetween);
			mcHdtoggleBt.y = Math.round((mcBack.height - mcHdtoggleBt.mcBack.height) / 2);						
			
			// THUMBS BUTTON
			mcThumbsBt.x = mcHdtoggleBt.x - (mcVideoPlayer.disableThumbsBt ? 0 : mcThumbsBt.width + mcVideoPlayer.controlsDistanceBetween);
			mcThumbsBt.centerOn(NaN, mcBack.height);
			
			// TIMER
			mcTimer.x = mcThumbsBt.x - (!mcVideoPlayer.disableTimer ? mcTimer.width + mcVideoPlayer.controlsDistanceBetween : 0);
			mcTimer.centerOn(NaN, mcBack.height);		
			
			// PLAYING BAR
			// background width
			mcPlayBar.x = (mcForwardBt.visible ? mcForwardBt.x : mcPlayBt.x) + mcVideoPlayer.controlsDimension + mcVideoPlayer.controlsDistanceBetween;
			var avWidth : Number = mcTimer.x - mcPlayBar.x - mcVideoPlayer.controlsDistanceBetween;
			mcPlayBar.mcBack.width = avWidth;
			// back bar width
			avWidth = mcPlayBar.mcBack.width - 2 * mcPlayBar.mcBackBar.x;
			mcPlayBar.mcBackBar.width = avWidth;
			// position
			mcPlayBar.y = Math.round((mcBack.height - mcPlayBar.mcBack.height) / 2);
			// download and progress bar width
//			mcVideoPlayer.setProgress();// shouldn't first time
		}
		



		/**
		 * ROLL OVER event handler
		 */
		public function overHandler(event : MouseEvent) : void
		{
			var mc : MovieClip = event.currentTarget as MovieClip; //trace("OVER: " + mc.name + " " + event.target.name);
			overToggle(mc);
		}

		
		/**
		 * ROLL OUT event handler
		 */
		public function outHandler(event : MouseEvent) : void
		{
			var mc : MovieClip = event.currentTarget as MovieClip; //trace("OUT: " + mc.name + " " + event.target.name);
			overToggle(mc, false);
		}
		
		public function overToggle(mc : MovieClip = null, flag : Boolean = true) : void
		{
			switch(mc)
			{
				case mcThumbsBt:
					if(flag || (!flag && !mcThumbsBt.pressed)) defaultOverToggle(mc, flag);
				break;
				case mcVideoPlayer.mcCenterPlayBt:
					mc.fadeAlpha(flag ? mcVideoPlayer.overCenterBtAlpha : mcVideoPlayer.normalCenterBtAlpha);
					break;
					
				case mcPlayBar.mcScrub:
				case mcPlayBar.mcDownloadBar:
					break;
					
				// any other control
				default:
					defaultOverToggle(mc, flag);
					break;
			}
		}	
		private function defaultOverToggle(mc : MovieClip, flag : Boolean = true) : void
		{
			if(mc.mcOver) mc.mcOver.visible = flag;
			
			if(mc.mcSign) 
				if(flag || (!flag && !mc.pressed && !mc.selected))
					(mc.mcSign.mcFill ? mc.mcSign.mcFill : mc.mcSign).setColor(flag ? mcVideoPlayer.controlsSignFillOverColor : mcVideoPlayer.controlsSignFillColor);
		}


		/**
		 * PRESS event handler
		 */
		public function pressHandler(event : MouseEvent) : void
		{
			var mc : MovieClip = event.currentTarget as MovieClip; //trace("PRESSED: " + mc.name);
			
			// set pressed this item
			currPressedObject = mc; //trace("PRESSED ITEM: " + event.target.name);

			// if is the progress download Bar - start the seeking interval
			if(mc == mcPlayBar.mcDownloadBar || mc == mcPlayBar.mcScrub)
			{
				// change the status of tracking
				tracking = true;
				
				// pause the video and stop progress interval
				mcVideoPlayer.toggleProgress(false);
				
				// start seeking bar
				adjustProgressBar();
				clearInterval(mcPlayBar.mcDownloadBar.intervalId);
				mcPlayBar.mcDownloadBar.intervalId = setInterval(adjustProgressBar, 10);
			}
			
			// add the releaseoutside event handler
			stage.addEventListener(MouseEvent.MOUSE_UP, releaseOutsideHandler);
			stage.addEventListener(Event.MOUSE_LEAVE, releaseOutsideHandler);			
		}

		
		/**
		 * RELEASE OUTSIDE and RELEASE OUTSIDE SCENE event handler
		 */
		public function releaseOutsideHandler(event : Event) : void 
		{
			// remove the release outside event handler
			stage.removeEventListener(MouseEvent.MOUSE_UP, releaseOutsideHandler);
			stage.removeEventListener(Event.MOUSE_LEAVE, releaseOutsideHandler);

			// here add the action for the clips that need realease outside action
			if(currPressedObject)// && (currentReleasedObject != currPressedObject))
			switch(currPressedObject)
			{
				case mcPlayBar.mcDownloadBar:
				case mcPlayBar.mcScrub:
					releaseFunction(currPressedObject);
					break;
				default:
					break;	        	
			}
		}

		/**
		 * RELEASE event handler 
		 */
		public function releaseHandler(event : MouseEvent) : void
		{
			var mc : Object = event.currentTarget;
			// change the current released object
			currentReleasedObject = MovieClip(mc);
			
			// if is the last pressed object then call the release function
			if(currentReleasedObject == this.currPressedObject)
			{
				releaseFunction(MovieClip(mc));
			}			
		}

		/*
		 * to do on release a button 
		 */
		public function releaseFunction(mc : MovieClip) : void
		{
			switch(mc)
			{
				case mcStopBt:
//					trace("S-a apasat STOP");
					
					// stop video
					mcVideoPlayer.stopVideo();					
					
					// show the preview
					mcVideoPlayer.mcImageHolder.showObject();					
					
					// disable stop button
					mcStopBt.mouseEnabled = false;
					
					// show play buttons
					if(!mcVideoPlayer.disableCenterPlayBt) mcVideoPlayer.mcCenterPlayBt.visible = true;
					mcPlayBt.visible = true;
					
					// hide the pause bt
					mcPauseBt.visible = false;
					
					// move progress bar to 0
					initBars(false);

					// go to normal state if it was in fullscreen mode
//					if(mcVideoPlayer.isFullScreen) releaseFunction(this.mcFullBt);					

					break;				
				
				
				case mcVideoPlayer.mcVideoButton:
					if(!mcVideoPlayer.isPlaying) releaseFunction(mcPlayBt);
					else releaseFunction(mcPauseBt);
					break;
					
				case mcPlayBt:
				case mcVideoPlayer.mcCenterPlayBt:
					// hide the preview instantly
					if(!mcVideoPlayer.isPlayingAudio) mcVideoPlayer.showFastPreview(false);
					
					// start first time / resume media
					mcVideoPlayer.playVideo();							    
						           	
					// deactivate the stop button
					mcStopBt.mouseEnabled = true;
	           		
					// change play buttons
					mcPlayBt.visible = false; 
					mcVideoPlayer.mcCenterPlayBt.visible = false;
					
					// show the pause button
					mcPauseBt.visible = true;
					
					// enable the progress bar
//					initBars(false);					
//					mcPlayBar.mcDownloadBar.mouseEnabled = true;
//					mcPlayBar.mcScrub.mouseEnabled = true;
					break;
					 		            	
				case mcPauseBt:
					// pause the video
					mcVideoPlayer.pauseVideo();
						            	
					// show play buttons
					mcPlayBt.visible = true; 
					if(!mcVideoPlayer.disableCenterPlayBt) mcVideoPlayer.mcCenterPlayBt.visible = true;
					
					// hide the pause bt
					mcPauseBt.visible = false;
					break;
	                
				case mcPlayBar.mcScrub:
				case mcPlayBar.mcDownloadBar:
	            	
					// stop scrubbing the passed bar
					clearInterval(mcPlayBar.mcDownloadBar.intervalId);
					adjustProgressBar();
	        		
					// change the tracking status	
					tracking = false;	        		
	        		
					// seek the video to the mouse position
//					var wasPlaying : Boolean = mcVideoPlayer.isPlaying;
//					mcVideoPlayer.pauseVideo();
					mcVideoPlayer.seekVideoToProcent(mcPlayBar.mcPassedBar.width / mcPlayBar.mcBackBar.width);
//					if(wasPlaying) mcVideoPlayer.playVideo();
	        		
					// stop the video if the progress bar reached the end
					checkEnd();
					break;	
	            
				case mcHdtoggleBt:
					// load the oposite video
					if(mcHdtoggleBt.mcSign.txt.text == mcVideoPlayer.hdToggleSDText) mcVideoPlayer.loadHQVideo();
					else mcVideoPlayer.loadLQVideo();
					break;
					
				case mcThumbsBt:
					mcThumbsBt.pressed = !mcThumbsBt.pressed;
					mcVideoPlayer.toggleList(mcThumbsBt.pressed);
					if(mcThumbsBt.pressed) defaultOverToggle(mcThumbsBt);
				break;
				case mcFullBt:
					stageStateToggle();
					break;	            	
					            	
				case mcEmbedBt:
//	            	if(mcEmbedBt.mcSign.mcDownload.visible)
//	            	{
//						mcVideoPlayer.downloadMedia();
//					}
//	            	else
//	            	{
//						// was hidden show it
//						if(mcEmbedBt.hidden)
//						{
//							// retain if the video was playing and pause it if is the case
//							if(mcVideoPlayer.isPlaying)
//							{
//								mcEmbedBt.wasPlaying = true;
//								releaseFunction(mcPauseBt);
//							}
//							else
//							{
//								mcEmbedBt.wasPlaying = false;
//							}	
//								
//							// show the share box
//							mcVideoPlayer.mcEmbed.hideShare(false);
//						}
//						else // was visible hide it
//						{
//							// unpause the video if is the case
//							if(mcEmbedBt.wasPlaying) releaseFunction(mcPlayBt);
//			            		
//							// show the share box
//							mcVideoPlayer.mcEmbed.hideShare(true);
//						}
//			            	
//						// stop after show image function
//						if(mcVideoPlayer.afterImageIsShown != null) mcVideoPlayer.afterImageIsShown(!mcEmbedBt.hidden);	            	
//			            	
//						// change the status	
//						mcEmbedBt.hidden = !mcEmbedBt.hidden;
//	            	}
	            	break;
			}
		}	

		
		/**
		 * changes the state of the stage and the buttons
		 */
		public function stageStateToggle() : void 
		{
			if(stage.displayState == StageDisplayState.FULL_SCREEN)
			{
				stage.displayState = StageDisplayState.NORMAL;
			} 
			else 
			{
				stage.displayState = StageDisplayState.FULL_SCREEN;
			}
		}

		public function changeFullBt() : void 
		{
//			if(stage.displayState == StageDisplayState.FULL_SCREEN)
//			{
//				mcFullBt.mcSign.mcBig.visible = true;
//			} 
//			else 
//			{
//				mcFullBt.mcSign.mcBig.visible = false;
//			}
		}

		
		/*****************************************************
		 * 
		 * 				PROGRESS FUNCTIONS
		 * 					
		 *****************************************************/
		/*
		 * inits the progress and download bar of the video on stop
		 */
		public function initBars(flag : Boolean = true) : void 
		{
			if(flag) mcPlayBar.mcDownloadBar.width = 0;
			//
			mcPlayBar.mcDownloadBar.mouseEnabled = false;
			mcPlayBar.mcScrub.mouseEnabled = false;
			//
			movePosition(0);
		}

		/*
		 * called with interval to adjust the passed time bar and the video time when the user drags the cursor
		 */
		public function adjustProgressBar() : void
		{
			// adjust the progress bar
			var pos : Number = mcPlayBar.mouseX - mcPlayBar.mcDownloadBar.x; 
			//trace(mcPlayBar.mouseX); //trace(mcPlayBar.mcPassedBar.width);
			
			// move the playhead to the mouseX pos
			movePosition(pos);
			
			// seek the video / sound
			//mcVideoPlayer.seekVideoToProcent(mcPlayBar.mcPassedBar.width / mcPlayBar[mcVideoPlayer.isPlayingAudio ?  "mcDownloadBar" :  "mcBackBar"].width);
		}

		
		/*
		 * sets the passed bar width and scrub postion depending on the video progress
		 * called with interval durring playing 
		 */
		public function setProgress(procent : Number) : void
		{
			// THE PASSED BAR and SCRUB
			movePosition(procent * mcPlayBar[mcVideoPlayer.isPlayingAudio ?  "mcDownloadBar" :  "mcBackBar"].width);
		}

		/**
		 * sets the download bar width depending on the download progress
		 * called with interval during the download process
		 */
		public function setDownload(procent : Number) : void
		{
			mcPlayBar.mcDownloadBar.width = mcPlayBar.mcDownloadBar.width = procent * mcPlayBar.mcBackBar.width;
			
			// adjust the played time in controller
			mcVideoPlayer.setTotalTime();			
		}
		
		/*
		 * move the progress bar position and timer to a specific time
		 */
		public function movePosition(pos : Number) : void
		{	
			// passed bar width		
			if(pos < 0) pos = 0;
			if(pos > mcPlayBar.mcDownloadBar.width) pos = mcPlayBar.mcDownloadBar.width;
			mcPlayBar.mcPassedBar.width = pos;
			
			// scrub position
			pos = mcPlayBar.mcPassedBar.x + mcPlayBar.mcPassedBar.width;
			if(pos > mcPlayBar.mcDownloadBar.x + mcPlayBar.mcDownloadBar.width - mcPlayBar.mcScrub.width) pos = mcPlayBar.mcDownloadBar.x + mcPlayBar.mcDownloadBar.width - mcPlayBar.mcScrub.width;
			if(pos < mcPlayBar.mcPassedBar.x) pos = mcPlayBar.mcPassedBar.x;
			//
			mcPlayBar.mcScrub.x = pos;
			
			
			// adjust the played time in controller
			mcVideoPlayer.setPlayedTime(mcPlayBar.mcPassedBar.width / mcPlayBar[mcVideoPlayer.isPlayingAudio ?  "mcDownloadBar" :  "mcBackBar"].width);
		}		

		/**
		 * check if the bar has reached the end
		 */
		public function checkEnd() : void
		{		
			// test if is the end of the video to stop
			if(!tracking && (Math.ceil(mcPlayBar.mcPassedBar.width) >= Math.floor(mcPlayBar.mcBackBar.width)))
			{
				releaseFunction(mcStopBt);
				mcVideoPlayer.toggleProgress(false);
			}		
		}


		/*****************************************************
		 * 
		 * 				VOLUME FUNCTIONS
		 * 					
		 *****************************************************/

		/**
		 * GET volume level from the volume bar
		 */
		public function get getVolume() : Number 
		{
			return mcVolumeCt.getVolume;
		}		

	} // FROM CLASS
} // FROM PACKAGE