﻿/****************************************
 *  Embed class (AS3) 
 *  by Andrei Neamtu
 *  2009 Vuzum Media, LLC. www.vuzum.com
 ***************************************/
package com.vuzum.mediaplayer
{
	// FLASH IMPORTS
	import caurina.transitions.Tweener;

	import com.vuzum.utils.*;

	import flash.display.MovieClip;
	import flash.events.MouseEvent;
	import flash.external.ExternalInterface;
	import flash.system.System;
	import flash.text.TextField;

	// OTHER'S IMPORTS
	
	
	// MY IMPORTS
		

	// CLASS
	public class Embed extends MovieClip 
	{
		// COMPONENTS INSIDE
		public var mcBack : MovieClip;
		public var mcBox : MovieClip;

		// INTERNAL MEMBERS
		public var mcVideoPlayer : MediaPlayer = null;
		// handlers vars	    
		private var currPressedObject : MovieClip;		

		// SETTINGS
		private var componentWidth : Number;
		private var componentHeight  : Number;
		//
		private var contentMargin : Number = 10;
		private var distBetweenX : Number = 5;
		private var distBetweenY : Number = 5;
		//
		private var linkTextSize : Number;
		private var linkTextColor : Number;
		//
		private var embedTextSize : Number;
		private var embedTextColor : Number;

		// AUX VARS
		private var showItemTweenTime : Number = 0.7;
		private var overColor : Number = 0xF5ED40;
		private var currPressedTextField : TextField;

		public var hide : Boolean = false;
		private var tempVar : *;
		private var textErMargin : Number = 1;

		/**
		 * CONSTRUCTOR
		 */
		function Embed() 
		{
			//trace("EMBED CONSTRUCTOR");
	    	
			// init the prototypes
			new Prototypes();

			// SET UP THE ELEMENTS
			// close bt
			mcBox.mcCloseBt.mcText.txt.initText(mcBox.mcCloseBt.mcText.txt.text);
			
			// link label
			mcBox.mcLinkLabel.txt.initText();
//			mcBox.mcLinkLabel.txt.embedFonts = true; mcBox.mcLinkLabel.txt.text = "";
			// link text
//			mcBox.linkText.initText("", true, "", NaN, NaN, "", "", true, true, true);
			mcBox.linkText.embedFonts = true;
			// link copy bt
			mcBox.mcLCopyBt.mcText.txt.initText(mcBox.mcLCopyBt.mcText.txt.text);
			
			// embed label
			mcBox.mcEmbedLabel.txt.initText(mcBox.mcEmbedLabel.txt.text);
//			mcBox.mcEmbedLabel.txt.embedFonts = true;
			// embed text
//			mcBox.embedTxt.initText("", true, "", NaN, NaN, "", "", true, true, true);
			mcBox.embedTxt.embedFonts = true;
			// embed copy bt
			mcBox.mcECopyBt.mcText.txt.initText(mcBox.mcECopyBt.mcText.txt.text);
	        
			// set the tab indexes
			mcBox.mcCloseBt.tabIndex = 0;
			mcBox.linkText.tabIndex = 1;
			mcBox.mcLCopyBt.tabIndex = 2;
			mcBox.embedTxt.tabIndex = 3;
			mcBox.mcECopyBt.tabIndex = 4;
			
			// hide this
			this.visible = false;			
		}

		/**
		 * inits the share
		 */
		public function init(pWidth : Number, pHeight : Number, pMcVideoplayer : MediaPlayer, xmlObject : * = null) : void    
		{
			// VIDEO PLAYER
			mcVideoPlayer = pMcVideoplayer;
			
			// read box dimensions
			componentWidth = Prototypes.readNumberVar(xmlObject.@width, mcBox.mcBack.width);
			componentHeight = Prototypes.readNumberVar(xmlObject.@height, mcBox.mcBack.height);

			// BACK LAYER
			mcBack.setColor(Prototypes.readNumberVar(xmlObject.backLayerColor));
			mcBack.alpha = Prototypes.readNumberVar(xmlObject.backLayerColor.@opacity, 100) / 100;
			
			// BACK
			mcBox.mcBack.setColor(Prototypes.readNumberVar(xmlObject.backColor));
			mcBox.mcBack.alpha = Prototypes.readNumberVar(xmlObject.backColor.@opacity, 100) / 100;
			
			
			// CLOSE button
			mcBox.mcCloseBt.mcText.txt.text = Prototypes.readStringVar(xmlObject.closeBt, mcBox.mcCloseBt.mcText.txt.text);
			mcBox.mcCloseBt.mcText.txt.setSize(Prototypes.readNumberVar(xmlObject.closeBt.@textSize));
			mcBox.mcCloseBt.setColor(Prototypes.readNumberVar(xmlObject.closeBt.@color));
			mcBox.mcCloseBt.mcText.x = 0;
			//
			mcBox.mcCloseBt.mcSign.width = mcBox.mcCloseBt.mcSign.height = (Prototypes.readNumberVar(xmlObject.closeBt.@signSize, mcBox.mcCloseBt.mcSign.width));
			mcBox.mcCloseBt.mcSign.x = mcBox.mcCloseBt.mcText.x + mcBox.mcCloseBt.mcText.width + 3;
			if(mcBox.mcCloseBt.mcSign.height >= mcBox.mcCloseBt.mcText.txt.textHeight) 
			{
//				trace("sign:", mcBox.mcCloseBt.mcSign.height, mcBox.mcCloseBt.mcText.txt.textHeight);
				mcBox.mcCloseBt.mcSign.y = 0;
				mcBox.mcCloseBt.mcText.y = Math.round((mcBox.mcCloseBt.mcSign.height - mcBox.mcCloseBt.mcText.txt.textHeight) / 2);
			}
			else
			{
//				trace("text:", mcBox.mcCloseBt.mcSign.height, mcBox.mcCloseBt.mcText.txt.textHeight);
				mcBox.mcCloseBt.mcText.y = 0;
				mcBox.mcCloseBt.mcSign.y = Math.round((mcBox.mcCloseBt.mcText.txt.textHeight - mcBox.mcCloseBt.mcSign.height) / 2);				
			}
			//
			mcBox.mcCloseBt.mcBack.width = mcBox.mcCloseBt.mcSign.x + mcBox.mcCloseBt.mcSign.width;
			mcBox.mcCloseBt.mcBack.height = Math.max(mcBox.mcCloseBt.mcSign.height, mcBox.mcCloseBt.mcText.txt.textHeight);
			//
			mcBox.mcCloseBt.addEvents(this);	
					
							
			// LINK SHARE
//			trace("link:>" + (Prototypes.readStringVar(xmlObject.linkShare)=="") + "<");
			mcBox.mcLinkLabel.txt.text = (Prototypes.readStringVar(xmlObject.linkShare) == "" ? "" : Prototypes.readStringVar(xmlObject.linkShare.title)); //trace("link:>" + mcBox.mcLinkLabel.txt.text + "<");
			if(mcBox.mcLinkLabel.txt.text != "")
			{
				// label
				mcBox.mcLinkLabel.txt.setSize(Prototypes.readNumberVar(xmlObject.linkShare.title.@textSize));
				mcBox.mcLinkLabel.txt.setTextColor(Prototypes.readNumberVar(xmlObject.linkShare.title.@textColor));
				
				// text
				linkTextSize = Prototypes.readNumberVar(xmlObject.linkShare.text.@textSize); 
				linkTextColor = Prototypes.readNumberVar(xmlObject.linkShare.text.@textColor);
				mcBox.linkText.borderColor = tempVar = Prototypes.readNumberVar(xmlObject.linkShare.text.@borderColor, 0);
				mcBox.linkText.border = (tempVar >= 0);
				//
				writeLinkText("Argh");
				mcBox.linkText.height = mcBox.linkText.textHeight;
				mcBox.linkText.text = "";
				//
				tempVar = Prototypes.readNumberVar(xmlObject.linkShare.text.@backColor);
				if(!isNaN(tempVar)) mcBox.linkText.backgroundColor = tempVar;
				//
				mcBox.linkText.addEventListener(MouseEvent.MOUSE_DOWN, pressHandler);
				mcBox.linkText.addEventListener(MouseEvent.MOUSE_UP, releaseHandler);

				// copy button
				tempVar = xmlObject.linkShare.copyBt;
				setCopyBt(mcBox.mcLCopyBt, Prototypes.readStringVar(tempVar, mcBox.mcLCopyBt.mcText.txt.text), 
						  Prototypes.readNumberVar(tempVar.@textSize), Prototypes.readNumberVar(tempVar.@textColor), 
						  Prototypes.readNumberVar(tempVar.@backFillColor), Prototypes.readNumberVar(tempVar.@backStrokeColor));
				//
				mcBox.mcLCopyBt.mcBack.width = mcBox.mcLCopyBt.mcOver.width = 2 * mcBox.mcLCopyBt.mcText.x + mcBox.mcLCopyBt.mcText.width;
				mcBox.mcLCopyBt.mcBack.height = mcBox.mcLCopyBt.mcOver.height = 2 * mcBox.mcLCopyBt.mcText.y + mcBox.mcLCopyBt.mcText.txt.textHeight;
				//
				mcBox.mcLCopyBt.addEvents(this);
				mcBox.mcLCopyBt.mcOver.visible = false;				
			}
			else
			{
				mcBox.mcLinkLabel.visible = false;
				mcBox.linkText.visible = false;
				mcBox.mcLCopyBt.visible = false;				
			}


			// EMBED CODE text
			// label
			mcBox.mcEmbedLabel.txt.text = (Prototypes.readStringVar(xmlObject.embedCode) == "" ? mcBox.mcEmbedLabel.txt.text : Prototypes.readStringVar(xmlObject.embedCode.title, mcBox.mcEmbedLabel.txt.text));
			mcBox.mcEmbedLabel.txt.setSize(Prototypes.readNumberVar(xmlObject.embedCode.title.@textSize));
			mcBox.mcEmbedLabel.txt.setTextColor(Prototypes.readNumberVar(xmlObject.embedCode.title.@textColor));			
			// text
			embedTextSize = Prototypes.readNumberVar(xmlObject.embedCode.text.@textSize); 
			embedTextColor = Prototypes.readNumberVar(xmlObject.embedCode.text.@textColor);
			mcBox.embedTxt.borderColor = tempVar = Prototypes.readNumberVar(xmlObject.embedCode.text.@borderColor, 0);
			mcBox.embedTxt.border = (tempVar >= 0);			
			//			
			tempVar = Prototypes.readNumberVar(xmlObject.embedCode.text.@backColor);
			if(!isNaN(tempVar)) mcBox.embedTxt.backgroundColor = tempVar;
			//
			mcBox.embedTxt.addEventListener(MouseEvent.MOUSE_DOWN, pressHandler);
			mcBox.embedTxt.addEventListener(MouseEvent.MOUSE_UP, releaseHandler);
			// copy button
			tempVar = xmlObject.embedCode.copyBt;
			setCopyBt(mcBox.mcECopyBt, Prototypes.readStringVar(tempVar, mcBox.mcLCopyBt.mcText.txt.text), 
					  Prototypes.readNumberVar(tempVar.@textSize), Prototypes.readNumberVar(tempVar.@textColor), 
					  Prototypes.readNumberVar(tempVar.@backFillColor), Prototypes.readNumberVar(tempVar.@backStrokeColor));			


			// HIDE it for the first time
			this.visible = false;
			scaleY = 0;
			
			// RESIZE
			resize(pWidth, pHeight);			
		}
		
		private function setCopyBt(mcCopyBt : MovieClip = null, str : String = "", 
								   size : Number = NaN, color : Number = NaN, 
								   fillColor : Number = NaN, strokeColor : Number = NaN) : void
		{
			mcCopyBt.mcText.txt.initText(str);
			mcCopyBt.mcText.txt.setSize(size);
			mcCopyBt.mcText.txt.setTextColor(color);
			//
			mcCopyBt.mcBack.width = mcCopyBt.mcOver.width = 2 * mcCopyBt.mcText.x + mcCopyBt.mcText.width + textErMargin;
			mcCopyBt.mcBack.height = mcCopyBt.mcOver.height = 2 * mcCopyBt.mcText.y + mcCopyBt.mcText.txt.textHeight + textErMargin;
			mcCopyBt.mcBack.mcStroke.setColor(strokeColor);
			mcCopyBt.mcBack.mcFill.setColor(fillColor);
			//
			mcCopyBt.mcOver.visible = false;
			mcCopyBt.addEvents(this);
		}

		/**
		 * writes the embed code in the textfield
		 */
		public function writeEmbed() : void
		{
			// WRITE THE EMBED CODE
			if(mcVideoPlayer.embedObject != null)
			{
				// get the actual URL of the page where the SWF file is embedded
				var swfUrl : String = stage.loaderInfo.url;
				// path to files
				var pathToFiles : String = mcVideoPlayer.pathToFiles;
				var pozLastSlash : uint = swfUrl.lastIndexOf("/");
				if(pathToFiles.indexOf("http://") < 0) pathToFiles = swfUrl.substring(0, pozLastSlash + 1) + pathToFiles;
				// start with item no
				var currentPlayningItemNo : Number = mcVideoPlayer.mcList.selectedItem + 1;					

				// write the EMBED CODE
				mcBox.embedTxt.text = '<embed id="flashmediaplayer"\n';
				//
				mcBox.embedTxt.text += '	src="' + swfUrl + '"\n';
				mcBox.embedTxt.text += '	bgColor = "#000000"\n';
				mcBox.embedTxt.text += '	width="' + mcVideoPlayer.componentWidth + '"\n';
				mcBox.embedTxt.text += '	height="' + mcVideoPlayer.componentHeight + '"\n';
				mcBox.embedTxt.text += '	allowfullscreen="true"\n';
				mcBox.embedTxt.text += '	allowScriptAccess="always"\n';
				//
				mcBox.embedTxt.text += '	flashVars="';
				mcBox.embedTxt.text += 'pathToFiles=' + pathToFiles;
				//
				mcBox.embedTxt.text += '&componentWidth=' + mcVideoPlayer.componentWidth;
				mcBox.embedTxt.text += '&componentHeight=' + mcVideoPlayer.componentHeight;
				//
				mcBox.embedTxt.text += '&xmlPath=' + mcVideoPlayer.embedObject.xmlPath;
				// single video mode vars
				if(mcVideoPlayer.embedObject.videoPath != "")
				{
					mcBox.embedTxt.text += '&videoPath=' + mcVideoPlayer.embedObject.lqVideoPath;
					if(mcVideoPlayer.embedObject.streamer != null) mcBox.embedTxt.text += '&streamer=' + mcVideoPlayer.embedObject.streamer;
					//
					if(mcVideoPlayer.embedObject.videoHDPath != "") mcBox.embedTxt.text += '&videoHDPath=' + mcVideoPlayer.embedObject.videoHDPath;
					if(mcVideoPlayer.embedObject.streamerHD != null) mcBox.embedTxt.text += '&streamerHD=' + mcVideoPlayer.embedObject.streamerHD;
					//
					if(mcVideoPlayer.embedObject.previewPath != "") mcBox.embedTxt.text += '&previewPath=' + mcVideoPlayer.embedObject.previewPath;
				}
				// content xml vars
				else
				{
					if(mcVideoPlayer.embedObject.contentXMLPath != "") mcBox.embedTxt.text += '&contentXMLPath=' + mcVideoPlayer.embedObject.contentXMLPath;
					mcBox.embedTxt.text += '&startWithItemNo=' + currentPlayningItemNo;
				}
				// download script path
				if(mcVideoPlayer.embedObject.downloadScript != "") mcBox.embedTxt.text += '&downloadScript=' + mcVideoPlayer.embedObject.downloadScript;
				// logo vars
				if(mcVideoPlayer.embedObject.logoPath != "")
				{
					mcBox.embedTxt.text += '&logoPath=' + mcVideoPlayer.embedObject.logoPath;
					if(mcVideoPlayer.embedObject.logoURL != "") mcBox.embedTxt.text += '&logoURL=' + mcVideoPlayer.embedObject.logoURL;
					if(mcVideoPlayer.embedObject.logoPosition != "") mcBox.embedTxt.text += '&logoPosition=' + mcVideoPlayer.embedObject.logoPosition;
					if(!isNaN(mcVideoPlayer.embedObject.logoMargin)) mcBox.embedTxt.text += '&logoMargin=' + mcVideoPlayer.embedObject.logoMargin;
				}				
				//
				mcBox.embedTxt.text += '"></embed>';
				// set size & color
				mcBox.embedTxt.setSize(embedTextSize); 
				mcBox.embedTxt.setTextColor(embedTextColor);				
				
				
				// write LINK TEXT for the current playing item
				// if our variable is already in the URL, we'll remove it and then introduce another one
				var paramName : String = "startWithItemNo";
				//
				if(ExternalInterface.available) swfUrl = String(ExternalInterface.call("window.location.href.toString"));
				var poz : Number = swfUrl.indexOf(paramName + "=");
				var auxSubString : String = swfUrl.substring(poz, swfUrl.length);
				if(poz != -1)
				{
					//if the URL has other GET variables we must add them too
					if(auxSubString.indexOf("&") != -1) swfUrl = swfUrl.substring(0, poz) + auxSubString.substring(auxSubString.indexOf("&"), auxSubString.length);						
					else swfUrl = swfUrl.substring(0, poz);
				}
				// write link
				var linkText : String = "";
				if(swfUrl.indexOf("?") == -1) linkText = swfUrl + "?" + paramName + "=" + currentPlayningItemNo;
				else linkText = swfUrl + (swfUrl.indexOf("?") == (swfUrl.length - 1) ? "" : "&") + paramName + "=" + currentPlayningItemNo;
				writeLinkText(linkText);				
			}
		}
		
		private function writeLinkText(str : String = "") : void
		{
			mcBox.linkText.text = str;
			mcBox.linkText.setSize(linkTextSize); 
			mcBox.linkText.setTextColor(linkTextColor);		
		}

		
		/****************************************************************************
		 *
		 *							EVENT HANDLERS
		 * 
		 *****************************************************************************/	        
		/**
		 * Repositions and resizes the STAF window
		 */
		public function resize(pWidth : Number, pHeight : Number) : void
		{
			if(mcVideoPlayer != null)
			{
				// LAYER back
				mcBack.width = pWidth;
				mcBack.height = pHeight;
		        
				// BACK
				mcBox.mcBack.width = Math.min(mcBack.width, componentWidth);
				mcBox.mcBack.height = Math.min(mcBack.height, componentHeight);
//				mcBox.mcBack.height = pHeight - mcVideoPlayer.controllerHeight - 2 * mcVideoPlayer.controllerMargin - 40;
				
				// CLOSE bt
				mcBox.mcCloseBt.x = mcBox.mcBack.width - mcBox.mcCloseBt.width - contentMargin;
				mcBox.mcCloseBt.y = contentMargin;
				
				
				// LINK SHARE
				mcBox.mcLinkLabel.x = contentMargin;
				mcBox.mcLinkLabel.y = mcBox.mcCloseBt.y + mcBox.mcCloseBt.height;
				
				mcBox.linkText.x = contentMargin;
				mcBox.linkText.y = mcBox.mcLinkLabel.y + mcBox.mcLinkLabel.height + distBetweenY;
				
				mcBox.mcLCopyBt.x = mcBox.mcBack.width - mcBox.mcLCopyBt.width - contentMargin;
				mcBox.mcLCopyBt.y = mcBox.linkText.y;
//				mcBox.linkText.y = (mcBox.mcLCopyBt.height > mcBox.linkText.height ? (Math.round(() / 2)) : mcBox.linkText.y);
				mcBox.linkText.width = mcBox.mcLCopyBt.x - mcBox.linkText.x - distBetweenX; 
				
				
				// EMBED CODE
				mcBox.mcECopyBt.x = mcBox.mcBack.width - Math.round(mcBox.mcECopyBt.width) - contentMargin;
				mcBox.mcECopyBt.y = mcBox.mcBack.height - Math.round(mcBox.mcECopyBt.height) - contentMargin;
				//
				mcBox.mcEmbedLabel.x = contentMargin;
				mcBox.mcEmbedLabel.y = (!mcBox.mcLinkLabel.visible ? mcBox.mcLinkLabel.y : mcBox.linkText.y + mcBox.linkText.height + 2 * distBetweenY);
				//
				mcBox.embedTxt.x = contentMargin;
				mcBox.embedTxt.y = mcBox.mcEmbedLabel.y + mcBox.mcEmbedLabel.height + distBetweenY;					
				mcBox.embedTxt.width = mcBox.mcBack.width - 2 * contentMargin;
				mcBox.embedTxt.height = mcBox.mcECopyBt.y - distBetweenY - mcBox.embedTxt.y;
				
				//fa deocamdata cont antoniei acolo cu cardul ei si apoi vedem cum facem si pe numele unuia dintre noi				
				
				// POSITION
				mcBox.centerOn(mcBack.width, mcBack.height);// - mcVideoPlayer.controllerHeight - 2 * mcVideoPlayer.controllerMargin);
				// check controller margin
//				if(mcBox.y + mcBox.mcBack.height > mcVideoPlayer.mcController.y) mcBox.y = 0;
			}
		}
		
		/*
		 * over button event handler
		 */
		public function overHandler(event : MouseEvent) : void
		{
			var mc : Object = event.currentTarget; //trace(mc.name + " " + event.target.name);
			
			// if is the copy button
			if(mc == mcBox.mcECopyBt || mc == mcBox.mcLCopyBt) 
			{
				// show the over clip
				mc.mcOver.visible = true;
					
				// change the color of the background			
//				mc.mcBack.mcFill.setColor(mcVideoPlayer.controlsSignFillColor - 20);
			}			
		}

		/*
		 * out button event handler
		 */
		public function outHandler(event : MouseEvent) : void
		{
			var mc : Object = event.currentTarget; //trace(mc.name + " " + event.target.name);
			
			// if is the copy button
			if(mc == mcBox.mcECopyBt || mc == mcBox.mcLCopyBt)
			{
				// hide the over clip
				mc.mcOver.visible = false;
				
				// change the color of the background	
//				mc.mcBack.mcFill.setColor(mcVideoPlayer.controlsSignFillColor);
			}
		}

		/*
		 * press button event handler
		 */
		public function pressHandler(event : MouseEvent) : void
		{
			var mc : Object = event.currentTarget; //trace("PRESSED: " + mc.name);
			
			// set pressed this item
			if(mc is MovieClip)
			{				
				currPressedObject = MovieClip(mc);
			} else if(mc is TextField)
			{				
				currPressedTextField = TextField(mc);
			}
		}

		/*
		 * release button event handler 
		 */
		public function releaseHandler(event : MouseEvent) : void
		{
			var mc : Object = event.currentTarget; //trace("RELEASED: " + mc.name);

			if(mc is MovieClip && mc == currPressedObject)
			{
				releaseFunction(MovieClip(mc));
			}			
			else// TO DO ON RELEASE THE SCENE:
			{
				//trace("SCENE RELEASED - releaseoutside");
				//trace(currPressedObject.name);
			}
			
			if(mc is TextField && mc == currPressedTextField)
			{
				releaseFunctionTxt(mc as TextField);
			}
		}	

		/*
		 * release button function 
		 */
		public function releaseFunction(mc : MovieClip) : void
		{
			switch(mc)
			{
				case mcBox.mcCloseBt:
					mcVideoPlayer.mcController.releaseFunction(mcVideoPlayer.mcController.mcEmbedBt);
					break;
				case mcBox.mcECopyBt:
					embedRelease();
					break;
				case mcBox.mcLCopyBt:
					linkShareRelease();
			}
		}

		public function releaseFunctionTxt(mc : TextField) : void
		{
			switch(mc)
			{
				case mcBox.embedTxt:
					{
					(mcBox.linkText as TextField).setSelection(0, 0);
					(mcBox.embedTxt as TextField).setSelection(0, (mcBox.embedTxt as TextField).length);
					break;
					}
				case mcBox.linkText:
					{
					(mcBox.embedTxt as TextField).setSelection(0, 0);
					(mcBox.linkText as TextField).setSelection(0, (mcBox.linkText as TextField).text.length);
					break;
					}
			}
		}

		
		
		
		
		/****************************************************************************
		 *
		 *							AUX FUNCTIONS
		 * 
		 *****************************************************************************/
		/**
		 * Called when the Copy button for embed is released
		 */
		private function embedRelease() : void 
		{
			//trace("embed");
			System.setClipboard(mcBox.embedTxt.text);
			stage.focus = mcBox.embedTxt;
			(mcBox.linkText as TextField).setSelection(0, 0);
			(mcBox.embedTxt as TextField).setSelection(0, (mcBox.embedTxt as TextField).length);
		}

		private function linkShareRelease() : void
		{
			System.setClipboard(mcBox.linkText.text);
			stage.focus = mcBox.linkText;
			(mcBox.embedTxt as TextField).setSelection(0, 0);
			(mcBox.linkText as TextField).setSelection(0, (mcBox.linkText as TextField).length);
		}

		/*
		 * shows or hides the share window 
		 */
		public function hideShare(flag : Boolean) : void
		{
			var endY : Number;
			var endYScale : Number;
			
			if(flag) // hide
			{
				hide = false;
				endY = mcBack.height;
				endYScale = 0;
			}
			else // show
			{
				// write the embed code
				writeEmbed();

				// calculate the tween vars
				hide = visible = true;
				endY = 0;
				endYScale = 1;
			}
			
			// move on y
			//			if(hide){				
			//				Tweener.addTween(this, {y : endY, time : showItemTweenTime, transition : "easeOutExpo"});
			//				
			//				// scale on y				
			//				Tweener.addTween(this, {scaleY : endYScale, time : showItemTweenTime, transition : "easeOutExpo", onComplete : function () :void 
			//				{ 
			//					shareMotionFinished(hide);
			//				} });
			//			}else{
			//				Tweener.addTween(this, {y : endY, time : showItemTweenTime, transition : "easeInExpo"});
			//				// scale on y				
			//				Tweener.addTween(this, {scaleY : endYScale, time : showItemTweenTime, transition : "easeInExpo", onComplete : function () :void 
			//				{ 
			//					shareMotionFinished(hide); 
			//				} });
			//			}

			Tweener.addTween(this, {y : endY, time : showItemTweenTime, transition : "easeOutExpo"});
			// scale on y				
			Tweener.addTween(this, {scaleY : endYScale, time : showItemTweenTime, transition : "easeOutExpo", onComplete : function () :void 
			{ 
				shareMotionFinished(hide); 
			} });
		}

		//private function shareMotionFinished(event : TweenEvent) : void
		private function shareMotionFinished(hide : Boolean) : void
		{
			this.visible = hide;
		}
	} // FROM CLASS
} // FROM PACKAGE