﻿/****************************************
 *  ThumbsScroller class (AS3) 
 *  by Andrei Neamtu
 *  2009 Vuzum Media, LLC. www.vuzum.com
 ***************************************/
package com.vuzum.mediaplayer
{
	import flash.display.MovieClip;	
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.display.Stage;
	import flash.net.URLLoader;
	import flash.net.URLRequest;		
	import com.zorked.URLNavigator;		
	import flash.net.URLVariables;
	import flash.net.URLRequestMethod;
	import flash.events.IOErrorEvent;
	import flash.display.Bitmap;
	
	/*
	 * OTHER IMPORTS
	 */
	import caurina.transitions.*;
	
	// MY IMPORTS
	import com.vuzum.utils.*;
	
	// CLASS
	public class ThumbsGallery extends MovieClip
	{
		// static members
		public static var noInstances : uint = 0;
		
		// COMPONENTS INSIDE
		public var mcMask : MovieClip;	
		public var mcAllItems : MovieClip;	
		public var mcScroller : ThumbsListScroller;
		//
		public var mcRightArrow : MovieClip;
		public var mcLeftArrow : MovieClip;
		//
		public var mcBack : MovieClip;
		
		// COMPONENT'S VARS
		public var componentWidth : Number;
		public var componentHeight : Number;		
		public var pathToFiles : String;
		
		// HANDLERS VARS
		private var currPressedObject : MovieClip;
			
		// INTERNAL MEMBERS
		// back settings
		private var backColor : Number;
		private var backOpacity : Number;
		// items settings
		private var itemsArray : Array;
		private var itemReleaseFunction : Function;
		//
		private var marginX : Number = 15;
		private var marginY : Number = 0;
		//
		private var arrowsWidth : Number = 8;
		private var arrowsColor : Number = 0;
		private var arrowsOverColor : Number = 0;
		//
		private var itemsWidth : Number = 114;
		private var itemsHeight : Number = 79;
		private var itemsMargin : Number = 2;
		public var loopList : Boolean = false;
		//
		private var itemsBackColor : Number = 0x333333;
		private var itemsBackOverColor : Number;
		private var itemsLoaderColor : Number;
		//
		private var itemsPlayBtBackColor : Number;
		private var itemsPlayBtSignColor : Number;
		private var playSignsDist : Number = 5;
		//
		private var thumbsMinAlpha : Number = 1;
		private var distBetween : Number = 5;
		//
		private var timeToStay : Number = 3;
		public var selectedItem : Number = 1;
		// scroller settings
		private var scrollerHeight : Number = 13;
		private var scrollerScrubColor : Number;
		private var scrollerBackColor : Number;
		private var scrollerTrackColor : Number;
		
		
		// AUXILIAR VARS
		public var xmlIsLoaded : Boolean = false;
		public var initialX : uint;
		private var currentImage : Number = 0;

		/*
		 * CONSTRUCTOR
		 */
		function ThumbsGallery()
		{
			// Prototypes			
			new Prototypes();
			
			// INIT ELEMENTS
			mcAllItems.mask = mcMask;
			mcAllItems.mcItem.visible = false;
			initialX = mcAllItems.x;
			itemsArray = new Array();
			
			// hide everything
			mcAllItems.visible = false;
			mcScroller.visible = false;
		}
		
		/*
		 * RESET the COMPONENT
		 */
		public function reset() : void
		{
			// here we set all the variables to default, and delete all children
			mcAllItems.x = initialX;
			currentImage = 0;
			
			// clear items from stage
			for(var i : uint = 0; i < itemsArray.length; i++)
				if(mcAllItems["mcItem" + i] && mcAllItems.contains(mcAllItems["mcItem" + i])) 
					mcAllItems.removeChild(mcAllItems["mcItem" + i]);
			itemsArray = new Array();
		}		
		
		// init component
		public function init(pWidth : Number, pHeight : Number, pPathTo : String, xmlPath : String, pItemReleaseFunction : Function) : void
		{
			// READ PARAMS
			// read the dimensions
			componentWidth = pWidth;
			componentHeight = pHeight;
			// path to files
			pathToFiles = pPathTo;
			// read the release function
			itemReleaseFunction = pItemReleaseFunction;
			
			// HIDE AND INIT everything
			mcAllItems.visible = false; 
			mcScroller.visible = false;
			mcAllItems.x = mcMask.x;
			
			// RESIZE everything for the first time			
			resize(pWidth, pHeight);
			
			
			// LOAD THE XML and then construct the list
			if(xmlPath != "") Prototypes.loadXML(xmlPath, xmlLoadedHandler);
			else xmlLoadedHandler();
		}
		
		// init component with xml object
		public function initWithXMLObject(pWidth : Number = NaN, pHeight : Number= NaN, pPathTo : String = "", xmlObject : * = null, pItemReleaseFunction : Function = null) : void
		{
			// READ PARAMS
			// read the dimensions
			componentWidth = pWidth;
			componentHeight = pHeight;
			// path to files
			pathToFiles = pPathTo;
			// read the release function
			itemReleaseFunction = pItemReleaseFunction;
			
			// HIDE AND INIT everything
			mcAllItems.visible = false; 
			mcScroller.visible = false;
			mcAllItems.x = mcMask.x;
			mcAllItems.y = mcMask.y;
			
			// RESIZE everything for the first time	to centrate the loader		
			resize(pWidth, pHeight);
			
			
			// LOAD THE XML and then construct the list
			xmlLoadedHandler(xmlObject);			
		}		
		
		/**
		 * content XML loaded and starts the component
		 */
		public function xmlLoadedHandler(mainXml : * = null) : void
		{
			if(mainXml)
			{
				if(isNaN(componentWidth)) componentWidth = Prototypes.readNumberVar(mainXml.@width, mcBack.width);
				if(isNaN(componentHeight)) componentHeight = Prototypes.readNumberVar(mainXml.@height, mcBack.height);
				
				// BACK settings
				backColor = Prototypes.readNumberVar(mainXml.@backColor);
				backOpacity = Prototypes.readNumberVar(mainXml.@backOpacity, 100) / 100;
				
				// general
				marginX = Prototypes.readNumberVar(mainXml.@marginX, marginX);
				marginY = Prototypes.readNumberVar(mainXml.@marginY, marginY);
				
				// ARROWS
				arrowsColor = Prototypes.readNumberVar(mainXml.@arrowsColor);
				arrowsOverColor = Prototypes.readNumberVar(mainXml.@arrowsOverColor);
				
				// ITEMS settings
				// read the dimensions of the items
				itemsWidth = Prototypes.readNumberVar(mainXml.@itemsWidth, itemsWidth);
				itemsHeight = Prototypes.readNumberVar(mainXml.@itemsHeight, itemsHeight);
				
				// read the playlist settings
				itemsBackColor = Prototypes.readNumberVar(mainXml.@itemsBackColor, itemsBackColor);
				itemsBackOverColor = Prototypes.readNumberVar(mainXml.@itemsBackOverColor);
				itemsLoaderColor = Prototypes.readNumberVar(mainXml.@itemsLoaderColor);
				itemsPlayBtBackColor = Prototypes.readNumberVar(mainXml.@itemsPlayBtBackColor);
				itemsPlayBtSignColor = Prototypes.readNumberVar(mainXml.@itemsPlayBtSignColor);
				//
				itemsMargin = Prototypes.readNumberVar(mainXml.@itemsMargin, itemsMargin);
				distBetween = Prototypes.readNumberVar(mainXml.@distBetween, distBetween);
				//
				selectedItem = Prototypes.readNumberVar(mainXml.@selectedItem, selectedItem) - 1; //trace("selectedItem:", selectedItem);
				timeToStay = Prototypes.readNumberVar(mainXml.@defaultTimeToStay, timeToStay);
				//				
				loopList = Prototypes.readBooleanVar(mainXml.@loopList , false);
				
				// read the SCROLLER settings
				scrollerHeight = Prototypes.readNumberVar(mainXml.@scrollerHeight, mcScroller.mcBack.height);
				scrollerScrubColor = Prototypes.readNumberVar(mainXml.@scrollerScrubColor);
				scrollerTrackColor = Prototypes.readNumberVar(mainXml.@scrollerTrackColor);
				scrollerBackColor = Prototypes.readNumberVar(mainXml.@scrollerBackColor);
				
				
				// read the PLAYLIST from the same xml if is the case
				var itemsNodeArray : XMLList = mainXml.item;
				var noItems : Number = itemsNodeArray.length();
				itemsArray = new Array();
				for(var i : uint = 0; i < noItems; i++)
				{
					// read the playlist item
					itemsArray[i] = new Object();
					itemsArray[i].startWithHD = Prototypes.readBooleanVar(itemsNodeArray[i].@startWithHD, false); //trace("startWithHD", itemsArray[i].startWithHD);
					itemsArray[i].videoPath = Prototypes.readAssetPath(itemsNodeArray[i].@videoPath, pathToFiles); //trace("videoPath", itemsArray[i].videoPath);
					itemsArray[i].videoHDPath = Prototypes.readAssetPath(itemsNodeArray[i].@videoHDPath, pathToFiles);
					itemsArray[i].streamer = Prototypes.readStringVar(itemsNodeArray[i].@streamer, null);
					itemsArray[i].previewPath = Prototypes.readAssetPath(itemsNodeArray[i].@previewPath, pathToFiles);
					itemsArray[i].thumbPath = Prototypes.readAssetPath(itemsNodeArray[i].@thumbPath, pathToFiles); //trace("itemsArray[i].thumbPath:", itemsArray[i].thumbPath);
					itemsArray[i].timeToStay = Prototypes.readNumberVar(itemsNodeArray[i].@timeToStay, timeToStay); //trace("itemsArray[i].timeToStay:", itemsArray[i].timeToStay);
				}
			}
			
			
			// set BACKGROUND
			mcBack.setColor(backColor);
			mcBack.alpha = backOpacity;
			
			// arrows
			mcLeftArrow.dimRatio = mcLeftArrow.height / mcLeftArrow.width;
			mcLeftArrow.width = arrowsWidth; 
			mcLeftArrow.height = mcLeftArrow.dimRatio * mcLeftArrow.width; 
			mcLeftArrow.setColor(arrowsColor);
			mcLeftArrow.addEvents(this);
			//
			mcRightArrow.dimRatio = mcRightArrow.height / mcRightArrow.width;
			mcRightArrow.width = arrowsWidth; 
			mcRightArrow.height = mcRightArrow.dimRatio * mcRightArrow.width;			
			mcRightArrow.setColor(arrowsColor);
			mcRightArrow.addEvents(this);
			
			// set up SCROLLER
			mcScroller.init(componentWidth, scrollerHeight, mcAllItems, mcMask, 4, false, true, "none", 0, true, 2, 
							scrollerBackColor, -1, 
							scrollerTrackColor, -1, 
							scrollerScrubColor, -1, -1);	
			mcScroller.visible = false;		
			
			// resize for the first time
			resize(componentWidth, componentHeight);
			
			// init the component after the data has been loaded
			loadArray(itemsArray);
		}		
		
		
		// makes the elements of the section visible
		public function loadArray(pArray : Array = null) : void
		{
			// clear
			reset();
			
			// read array
			itemsArray = pArray;
			var noItems : Number = itemsArray.length;
			
			// create the LIST OF ITEMS
			var mc : MovieClip;
			if(itemsArray && noItems > 0)
			for(var i : uint = 0; i < noItems; i++)
			{
				// CREATE THE ITEM
				mc = mcAllItems.duplicateMovieClip(new mcThumbItem(), "mcItem" + i); //trace("create:", mc.name);
				//
				mc.index = i;
				mc.isSelected = false;
				mc.cacheAsBitmap = true;
				
				// RESIZE the item depending on the dimensions read form XML
				// background
				mc.mcBack.setColor(itemsBackColor); 
				mc.mcBack.width = itemsWidth; 
				mc.mcBack.height = itemsHeight;
				// holder
				mc.mcHolder.alpha = 0; 
				// mask
				mc.mcHolder.x = mc.mcMask.x = itemsMargin;
				mc.mcHolder.y = mc.mcMask.y = itemsMargin;
				mc.mcMask.width = itemsWidth - 2 * itemsMargin; 
				mc.mcMask.height = itemsHeight - 2 * itemsMargin; 
				// loader
				mc.mcLoader.setColor(itemsLoaderColor);
				mc.mcLoader.centerOnClip(mc.mcBack);
//				mc.mcLoader.x = Math.round((mc.mcBack.width - mc.mcLoader.width) / 2) + mc.mcLoader.width / 2;
//				mc.mcLoader.y = Math.round((mc.mcBack.height - mc.mcLoader.height) / 2) + mc.mcLoader.height / 2;
				// mcPlaySign
				mc.mcPlaySign.mcBack.setColor(itemsPlayBtBackColor);
				mc.mcPlaySign.mcSign.setColor(itemsPlayBtSignColor);
				mc.mcPlaySign.x = Math.round(mc.mcBack.width - mc.mcPlaySign.width - playSignsDist);
				mc.mcPlaySign.y = Math.round(mc.mcBack.height - mc.mcPlaySign.height - playSignsDist);				
				mc.mcPlaySign.visible = !(itemsArray[i].videoPath == "" && itemsArray[i].videoHDPath == "");				
				
				// add the EVENTS HANDLERS
				mc.mouseChildren = false;
				mc.addEvents(this);

				// POSITION THE ITEM
				if(i != 0) mc.x = mcAllItems["mcItem" + (i-1)].x + mcAllItems["mcItem" + (i-1)].width + distBetween;				
			}
			
			// RESIZE EVERYTHING
			resize(componentWidth, componentHeight);
			
			// SHOW CONTENT
			mcAllItems.visible = true;
			
			
			// START LOADING the images with the first one
			currentImage = 0;
			if(itemsArray.length > 0) 
			{
				// load the current image	
				loadImage();
				
				// select the first item
				//releaseFunction(mcAllItems["mcItem" + 0]);				
			}
			else
			{
//				itemReleaseFunction(null);
			}
		}
		
		/*
		 * LOAD ITEM IMAGE
		 */
		public function loadImage() : void
		{
			var mc : MovieClip = mcAllItems["mcItem" + currentImage];
			
			// load the current item
			mc.isLoaded = false;
			if(itemsArray[currentImage].thumbPath != "")
			{
				mc.mcHolder.onIOErrorFunction = loadNextItem;
				mc.mcHolder.loadContent(itemsArray[currentImage].thumbPath, completeListener, mc.mcLoader, false);
			}
			else
			{
				loadNextItem();
			}
		}
		
		public function completeListener(pTarget : MovieClip) : void
		{
			var mcParent : MovieClip = pTarget.parent as MovieClip;
			
			// resize image to fit into mask
			pTarget.fitToRect(mcParent.mcMask.width, mcParent.mcMask.height, false, false);
			
			// show this item
			pTarget.fadeAlpha(mcParent.index == selectedItem ? 1 : thumbsMinAlpha);
			
			// change the status
			mcParent.isLoaded = true;
			
			// go next item if is the case
			loadNextItem();
		}
		
		private function loadNextItem() : void
		{	
			// centrate the holder in the middle if is the case or show scroller
			checkContentSize();				
			
			if(currentImage < itemsArray.length - 1)
			{
				// load the next item
				currentImage++;
				loadImage();
			}
			// action to execute when all images are loaded
			else
			{
				
			}
		}
		
		/*
		 * SELECT PREVIOUS item
		 */
		public function prev() : void
		{
			// calculate the next item number
			var tempSelectedImage : Number = selectedItem;
			tempSelectedImage--;
			if(tempSelectedImage < 0) tempSelectedImage = itemsArray.length - 1;
			
			// select the item
			releaseFunction(mcAllItems["mcItem" + tempSelectedImage]);
		}

		/*
		 * SELECT NEXT item
		 */
		public function next() : void
		{
			// calculate the next item number
			var tempSelectedImage : Number = selectedItem;
			tempSelectedImage++;
			if(tempSelectedImage > itemsArray.length - 1) tempSelectedImage = 0;
			
			// select the item
			releaseFunction(mcAllItems["mcItem" + tempSelectedImage]);
		}		
		
//		public function displayElements(flag : Boolean = true) : void
//		{
//			mcAllItems.visible = flag;
//			mcScroller.visible = flag;
//		}
		
		
		
		/************************************************************************
		 * 
		 * 							EVENT HANDLERS
		 * 
		 *************************************************************************/		
		/**
		 * RESIZE function
		 */
		public function resize(pWidth : Number = NaN, pHeight : Number = NaN) : void
		{
			// resize the background
			mcBack.width = pWidth;
			mcBack.height = pHeight;
			
			// arrows
			mcLeftArrow.x = 5;
			mcLeftArrow.centerOn(NaN, mcBack.height);
			//
			mcRightArrow.centerOn(NaN, mcBack.height);
			mcRightArrow.x = mcBack.width - mcRightArrow.width - 5;
			
			// resize and reposition the scroller
			mcScroller.resize(mcBack.width, scrollerHeight);
			mcScroller.y = mcBack.height - scrollerHeight;
			
			// resize the mask
			mcMask.x = marginX;
			mcAllItems.y = mcMask.y = marginY;
			mcMask.width = mcBack.width	- 2 * mcMask.x;
			mcMask.height = (mcScroller.visible ? mcScroller.y : mcBack.height) - mcMask.y;
			
			// update scroller
			mcScroller.update();
			
			// centrate the holder in the middle if is the case
			checkContentSize();
		}
		public function checkContentSize() : void
		{
			// centrate the content and hide the scroller
			if(mcAllItems.width <= mcMask.width) 
			{
				mcAllItems.x = mcMask.x + Math.round( (mcMask.width - mcAllItems.width) / 2 );
				mcScroller.visible = false;
			}
			// show the scroller			
			else
			{
				mcScroller.toggleEnable();
				mcScroller.visible = false;
			}			
		}		
		
		/**
		 * OVER EVENT HANDLER
		 */
		public function overHandler(event : MouseEvent) : void
		{
			var mc : MovieClip = event.currentTarget as MovieClip; 
			overToggle(mc);
		}

		/**
		 * OUT EVENT HANDLER
		 */
		public function outHandler(event : MouseEvent) : void
		{
			var mc : MovieClip = event.currentTarget as MovieClip; 
			overToggle(mc, false);
		}
		
		public function overToggle(mc : MovieClip, flag : Boolean = true) : void
		{
			// if an item
			if(mc.name.lastIndexOf("mcItem") != -1) 
			{
				//mc.mcHolder.fadeAlpha(flag ? 1 : thumbsMinAlpha);
				if(flag || (!flag && !mc.isSelected)) mc.mcBack.setColor(flag ? itemsBackOverColor : itemsBackColor);
			}
			// anything else
			else
			switch(mc)
		    {
				case mcLeftArrow:
				case mcRightArrow:
					mc.setColor(flag ? arrowsOverColor : arrowsColor);
	        	break;
	        	case mcBack:
	            	//Tweener.addTween(mc.mcTitle, {_color : Main.getInstance().mcContent.mcMenu.normalItemColor, time : .5, transition : "easeOutExpo"});	
				break;
	        }
		}		
		
				
		/**
		 * PRESS EVENT HANDLER
		 */
		public function pressHandler(event : MouseEvent) : void
		{
			var mc : MovieClip = MovieClip(event.currentTarget); //trace(item.name);
			
			// set pressed the new item
			this.currPressedObject = mc;
			
			// add the release event on stage
			stage.addEventListener(MouseEvent.MOUSE_UP, releaseOutsideHandler);
			stage.addEventListener(Event.MOUSE_LEAVE, releaseOutsideHandler);
		}
		
		/**
		 * RELEASE OUTSIDE EVENT HANDLER
		 */
		public function releaseOutsideHandler(e : Event) : void 
		{
	        stage.removeEventListener(MouseEvent.MOUSE_UP, releaseOutsideHandler);
	        stage.removeEventListener(MouseEvent.MOUSE_UP, releaseOutsideHandler);
	        
	        // here release outside for the items where release outside is the same with release
	        //if(this.currPressedObject == someMovieClip)
	        {
	        	//
	        }
		}
		
		/**
		 * RELEASE EVENT HANDLER
		 */
		public function releaseHandler(event : MouseEvent) : void
		{
			var mc : MovieClip = MovieClip(event.currentTarget); //trace(item.name);
			
			// test if the releasse event comes from the same item that was pressed
			if(mc == this.currPressedObject)
			{
		        // if is an item
		        if(mc.name.lastIndexOf("mcItem") != -1) 
		        {
		        	releaseFunction(mc); 
		        }
		        else			
					switch(mc)
			        {
						case mcLeftArrow:
						case mcRightArrow:
							if(mc == mcLeftArrow) prev(); 
							else next();
						break;			        	
			        	case mcBack:
							break;
			        }
			}
		}
		/*
		 * RELEASE function
		 */
		public function releaseFunction(mc : MovieClip) : void
		{
			// DESELECT THE CURRENT SELECTED ITEM
			selectItem(selectedItem, false);
			
			// SELECT THE NEW ONE
			selectedItem = mc.index;
			selectItem(selectedItem);
			
			// change the BIG HOLDER POSITION to make the new item visible
			var gotoX : Number = mcAllItems.x + mc.x;
			if(gotoX < mcMask.x)
			{ 
				//trace("nu e visibila ci la stanga");
				gotoX = mcMask.x - mc.x;
			}
			else
			{
				if(mcAllItems.x + mc.x + mc.width > mcMask.x + mcMask.width) 
				{
					//trace("nu e visibila ci la dreapta"); 
					gotoX = mcMask.x + mcMask.width - (mc.x + mc.width);
				}
			}
			//trace(gotoX, mcAllItems.x + mc.x)
			if(gotoX != mcAllItems.x + mc.x)
			{
				// move the content
				Tweener.addTween(mcAllItems, {x : gotoX, time : .5, transition : "easeOutExpo"});
				
				// update the scroller position
				mcScroller.updateScrub(gotoX);
			}
			
			
			// CALL THE RELEASE FUNCTION
			if(itemReleaseFunction != null) itemReleaseFunction(itemsArray[selectedItem]);
		}		
	
	
		/**
		 * simulate the click on an item
		 */
		public function clickItem(no : Number = 0) : void
		{
			if(no < 0) no = 0;
			if(no > itemsArray.length-1) no = 0;
			releaseFunction(mcAllItems["mcItem" + no]);			
		}	
		
		/*
		 * change the state of an item: (un)selected
		 */
		public function selectItem(id : Number = NaN, isSelected : Boolean = true) : void
		{
			if(isNaN(id)) id = selectedItem;
			var mc : MovieClip = mcAllItems["mcItem" + id];
//			trace(id, mc);
			
			if(mc != null)
			{
				// change STATE
//				mc.mcHolder.fadeAlpha(isSelected ? 1 : thumbsMinAlpha);
				mc.mcBack.setColor(isSelected ? itemsBackOverColor : itemsBackColor);
				
				
				// CHANGE SELECTION
				// change status
				mc.isSelected = isSelected;
				
				// add / remove events
				mc.mouseEnabled = !isSelected;				
				
				// change the selected item no
				if(isSelected) selectedItem = id;
			}
		}
	
	} // FROM CLASS
}// FROM PACKAGE
