﻿package com.vuzum.mediaplayer
{
	import flash.events.IOErrorEvent;
	import flash.net.URLRequest;
	import flash.display.Loader;
	import flash.system.Security;

	import com.vuzum.utils.Prototypes;
	import flash.events.Event;
	import flash.text.TextField;	
	import flash.events.NetStatusEvent;	
	
//	import fl.transitions.*;
//	import fl.transitions.easing.*;

	import flash.display.MovieClip;
	import flash.net.NetConnection;
	import flash.net.NetStream;
	import flash.net.ObjectEncoding;
	import flash.media.Video;
	import flash.media.SoundTransform;
	import flash.utils.*;
	import flash.display.DisplayObject;

	import flash.events.AsyncErrorEvent;
	import flash.events.SecurityErrorEvent;
	
	import caurina.transitions.Tweener;
	
	public class VideoManager extends MovieClip 
	{
		// COMPONENTS INSIDE
	    public var videoObject : Video;
	    public var mcBack : MovieClip;
	    //
		// This will hold the YouTube API player instance once it is initialized.	    
	    private var ytPlayer : * = null;
	    var loader : Loader;
	    private var ytPlayerInitialized : Boolean = false;
	    private var ytPlayerLoaded : Boolean = false;
	    
	    // INTERNAL MEMBERS
	    private var mcVideoPlayer : MediaPlayer;
	    // video object
	    private var nConnection : NetConnection;
	    public var netStream : NetStream;
	    private var metaDataObject : Object = new Object();
	    private var st : SoundTransform = new SoundTransform();
		public var totalTime : Number = 0;
		private var bufferTime : Number = 0;
		//
		public var fadeSoundTime : Number = 0;
		public var currentVolume : Number = 0;
		//
		private var currVideoServer : String = null;
		public var currVideoPath : String; // without server
		
		// AUX VARS
		private var showVideoId : uint;
		//
		var autoStart : Boolean;
		//
		public var isPlaying : Boolean = false;
		private var videoPlayedFirstTime : Boolean = false;
		private var MediaLoaded : Boolean = false;
		private var medataFlag : Boolean;



		// VIDEO MANAGER CONSTRUCTOR
	    function VideoManager() 
	    {
	    	//trace("VIDEO DISPLAY CONSTRUCTOR");
	    	
			// The player SWF file on www.youtube.com needs to communicate with your host
			// SWF file. Your code must call Security.allowDomain() to allow this
			// communication.			
			Security.allowDomain("www.youtube.com");	    	
	    	//System.security.allowDomain("gdata.youtube.com");
	        //System.security.allowInsecureDomain("gdata.youtube.com");
	    	
	    	/* 
			* ADDS for RTMP
			*/
			NetConnection.prototype.onBWDone = function() : void
			{
				//trace("onBWDone: " + typeof(p_bw));
			};

			// metadata object for netstream
			metaDataObject.onMetaData = nsMetadataHandler; //function(info : Object) : void { onMetadataHandler(info); };			
			metaDataObject.onCuePoint = nsCuePointHandler; //function(info : Object) : void { onMetadataHandler(info); };			
		}
		
		/**
	     * Initializes the Video Display
	     * @param pController the Movieclip container for Controll Bar
	     * @param pMcPreloader the Movieclip container for Preloader
	     * @param pXMLManager the class that handle the main XML
	     */
	    public function init(pWidth : Number, pHeight : Number, pMcVideoPlayer : MediaPlayer) : void 
	    {
			// internal members
			mcVideoPlayer = pMcVideoPlayer;
			
			// resize everything	        
	        resize(pWidth, pHeight);
	    }
	    
	    /**
	     * Repositionates and resizes the video container based on the new sizes
	     * called on full / normal screen changes
	     * @param pWidth the new maximum width for video container
	     * @param pHeight the new maximum height for video container
	     */
	    public function resize(pWidth : Number, pHeight : Number) : void 
	    {
	    	// Background
			mcBack.width = pWidth;
			mcBack.height = pHeight;
			
			// video object
			if(videoObject) resizeVideoObject(mcBack.width, mcBack.height);
			
			// yt player
			if(ytPlayerInitialized) ytPlayer.setSize(mcBack.width, mcBack.height);
	    }
	    
	    /**
	     * Repositionates and resizes the video object based on the new sizes
	     * called on full / normal screen changes and also on metadata
	     * @param pWidth the new maximum width for video container
	     * @param pHeight the new maximum height for video container
	     */
	    public function resizeVideoObject(pWidth : Number, pHeight : Number) : void 
	    {
            var proc1 : Number = pWidth / videoObject.width;
            var proc2 : Number = pHeight / videoObject.height;
            
            if (proc1 >= proc2) 
            {
                videoObject.height = pHeight;
                videoObject.width = proc2 * videoObject.width;
            }else 
            {
                videoObject.width = pWidth;
                videoObject.height = proc1 * videoObject.height;
            }
            // reposition
            videoObject.x = Math.floor((pWidth - videoObject.width) / 2); //trace(videoObject.x);
            videoObject.y = Math.floor((pHeight - videoObject.height) / 2);
	    }
	    

	    
	    /**
	     * Starts loading a new video in the player
	     * @param pVideoPath
	     */
	    public function clearVideo() : void 
	    {
	    	// STOP CURRENT VIDEO IF THERE WAS ONE
		    if(netStream) 
			{
				// clear netstream
				netStream.pause();
				netStream.close();

				netStream.removeEventListener(NetStatusEvent.NET_STATUS, nsStatusHandler);
				netStream.removeEventListener(AsyncErrorEvent.ASYNC_ERROR, asyncErrorHandler);
				netStream = null;
				
				nConnection.removeEventListener(NetStatusEvent.NET_STATUS, ncNetStatusHandler);
				nConnection = null;
			}
			// clear VIDEO OBJECT
	    	if(videoObject)
	    	{
				this.removeChild(videoObject);
				videoObject = null;
	    	}
	    	
	    	// stop YT PLAYER if is the case
			if(ytPlayerInitialized) 
			{
				ytPlayer.visible = false;
				ytPlayer.stopVideo();
			}
	    	
	    	// clear the total time
	    	totalTime = 0;
	    			
			// change status
			videoPlayedFirstTime = false;
			MediaLoaded = false;
			
			
	    	// hide this module
	    	this.visible = false;				    			
	    }
	    
	    /**
	     * Starts loading a new video in the player if is set to autostart
	     * @param pVideoPath
	     */
	    public function loadNewVideo(pVideoPath : String, pStreamer : String = null, pautoStart : Boolean = false) : void 
	    {
	    	// CHANGE THE CURRENT PATH
			currVideoPath = pVideoPath; //trace("currVideoPath: " + currVideoPath);
			
	    	// CHANGE THE CURRENT STREAMER
	    	currVideoServer = pStreamer; //trace("currVideoServer: " + currVideoServer);
	    	
			// show the buttons as if the video has to start playing
			autoStart = pautoStart;
			
			// STOP CURRENT VIDEO and CLEAR IT
			clearVideo();			
			
			// show loader
//			mcVideoPlayer.mcLoader.visible = true;
			
			// LOAD YouTube VIDEO and then start video if is the case
	    	if(playingYT) loadYouTube();
	    	// CREATE NET CONNECTION and then start video if is the case
	    	else loadVideo();
	    }
	    
		/********************************************
		 * 			
		 * 			YouTube module functions
		 * 			
		 ********************************************/	    	    
		/**
		 * load YouTube module inside the player or video inside the module
		 */
		function loadYouTube() : void
		{
			// reset path
			currVideoPath = currVideoPath.replace("watch?v=", "v/"); //			trace("currVideoPath after:", currVideoPath);
//			trace("mcVideoPlayer.mcLoader.visible:", mcVideoPlayer.mcLoader.visible, mcVideoPlayer.mcLoader.alpha);
			
    		// load youtube player inside if not yet / or wait untill loads and load the video
    		if(!ytPlayerLoaded)
    		{
    			// change status
    			ytPlayerLoaded = true;
    			
				// init loader and start loading again the module
				loader = new Loader();
				loader.contentLoaderInfo.addEventListener(IOErrorEvent.IO_ERROR, onLoaderError);
				function onLoaderError(event:IOErrorEvent) : void 
				{
					trace("Could not load YouTube player!");
				}
				loader.contentLoaderInfo.addEventListener(Event.INIT, onLoaderInit);
				function onLoaderInit(event:Event) : void 
				{
					// add the loader to scene
				    addChild(loader);
				    
				    // add listeners
					toggleYouTubeListeners();
				}
				loader.load(new URLRequest("http://www.youtube.com/apiplayer?version=3"));
    		}
    		// load the video inside the yt player that was already initialized if is the case
    		else
    		{
    			if(ytPlayerInitialized) startYouTube();
    		}					
		}
		
		private function toggleYouTubeListeners(flag : Boolean = true) : void
		{
    		if(loader != null) 
    		{
    			// remove listeners
    			if(!flag)
    			{
//	    			trace("stop loading youtube");
					try
					{
						loader.content.removeEventListener("onReady", onPlayerReady);
						loader.content.removeEventListener("onStateChange", onPlayerStateChange);
						loader.content.removeEventListener("onStateChange", onPlayerStateChange);
						loader.content.removeEventListener("onPlaybackQualityChange", onVideoPlaybackQualityChange);	    			
						//
//						loader.close();
					}catch(e:Error){}
    			}
    			// add listeners
    			else
    			{
				    loader.content.addEventListener("onReady", onPlayerReady);
				    loader.content.addEventListener("onError", onPlayerError);
				    loader.content.addEventListener("onStateChange", onPlayerStateChange);
				    loader.content.addEventListener("onPlaybackQualityChange", onVideoPlaybackQualityChange);    				
    			}
    		}			
		}
		
		/*
		 * to do after the you tube module is loaded
		 */
		function onPlayerReady(event:Event) : void 
		{
		    // Event.data contains the event parameter, which is the Player API ID 
//		    trace("yt player loaded:", Object(event).data, mcVideoPlayer.mcLoader.visible, mcVideoPlayer.mcLoader.alpha);
		    			
		    // add youtube module on the scene
		    ytPlayer = loader.content;
		    this.addChild(ytPlayer);
		    
		    // Set appropriate player dimensions for your application
		    ytPlayer.setSize(mcBack.width, mcBack.height);
		    
		    // change status
		    ytPlayerInitialized = true;		    		    
		    
		    // start playing video if is the case
//		    trace("youtube loaded", playingYT);
		    if(playingYT) startYouTube();
		}		    
		function startYouTube() : void
		{
			// show yt module
			ytPlayer.visible = true;
			
		    // tell the player that the video can load an play
		    canStart();
		    
		    // tell the player that the video is loaded and can start progres monitor
		    dispatchEvent(new Event("MediaBufferFull"));
		}
		
		/*
		 * to do if you tube module changes state
		 */		
		function onPlayerStateChange(event:Event) : void 
		{
			var eventNo : Number = Prototypes.readNumberVar(Object(event).data);
		    // Event.data contains the event parameter, which is the new player state
//		    trace("player state:", eventNo);
		    
		    // the video playing
		    if(eventNo == 1)
		    {
				// read total time
				totalTime = ytPlayer.getDuration();
				
				// set current volume
				ytPlayer.setVolume(mcVideoPlayer.getVolume * 100);
//				trace("yt volume", ytPlayer.getVolume());				
		    }
		    
		    // if the video ended
		    if(isNaN(eventNo))
			{
//				trace("yt video ended");
				dispatchEvent(new Event("MediaPlayingEnd"));
			}
		}
		/*
		 * to do if you tube module could not load
		 */		
		function onPlayerError(event:Event) : void 
		{
		    // Event.data contains the event parameter, which is the error code
		    trace("player error:", Object(event).data);
		}		
		/*
		 * to do if youtube module changes state
		 */		
		function onVideoPlaybackQualityChange(event:Event) : void 
		{
		    // Event.data contains the event parameter, which is the new video quality
//		    trace("video quality:", Object(event).data);
		}	    
		
		/*
		 * getter to detect if playing youtube video
		 */
		public function get playingYT() : Boolean
		{
			return (currVideoPath ? (currVideoPath.indexOf("youtube.com") >= 0) : false);
		}		


		/********************************************
		 * 			
		 * 			REGULAR video functions
		 * 			
		 ********************************************/
	   	/**
	     * load a new regular video inside the player
	     */
	    public function loadVideo() : void 
	    {    	
	        nConnection = new NetConnection();
	        //
			nConnection.objectEncoding = ObjectEncoding.AMF0; // FOR RTMP
			nConnection.addEventListener(AsyncErrorEvent.ASYNC_ERROR, asyncErrorHandler);
			nConnection.addEventListener(SecurityErrorEvent.SECURITY_ERROR, onSecurityError);
			// net status handler
	    	nConnection.addEventListener(NetStatusEvent.NET_STATUS, ncNetStatusHandler);
	    	
			// make the connection
			nConnection.connect(currVideoServer); //trace("Server: " + currVideoServer);
			//initPlay function will be called after the connection is succsesfully made
	    }

		/**
		 * checks the connection status and inits the netstream
		 */
		private function ncNetStatusHandler(event:NetStatusEvent) : void 
		{
			//trace("NetConnection: " + event.info.code);
			switch (event.info.code) 
			{
				case "NetConnection.Connect.Success":
					// init the netstream
					initPlay();
					break;
				case "NetConnection.Connect.Failed":
					// The connection failed because the server is unreachable. Perhaps try again
					// or simply tell the user that the server cannot be reached.
					mcVideoPlayer.showErrorMessage(false);
					break;
				case "NetConnection.Connect.Rejected":
					// The connection was rejected because of invalid credentials or parameters.
					// Perhaps prompt the user for valid information.
					mcVideoPlayer.showErrorMessage(false);
					break;
				case "NetConnection.Connect.InvalidApp":
					// The connection failed because no application by the specified name exists.
					break;
				case "NetConnection.Connect.Closed":
					// The connection was closed successfully by a command issued from the client.
					// Use the opportunity to remove any elements, such as video objects; go to
					// another screen; or otherwise inform the user of the closure.
					mcVideoPlayer.showErrorMessage(false);
					break;
				case "NetConnection.Connect.AppShutDown":
					// The application was shut down by an administrator or because the server is
					// being shut down or restarted.
					mcVideoPlayer.showErrorMessage(false);
					break;
			}
		}		
		
		/**
		 * prepares the netstream and the playing after the connection is made
		 */
		private function initPlay() : void 
		{
			// change metaflag
			medataFlag = false;			
			
			// NET STREAM
			if(nConnection.connected)
			{
				netStream = new NetStream(nConnection);
				netStream.addEventListener(NetStatusEvent.NET_STATUS, nsStatusHandler);
				netStream.addEventListener(AsyncErrorEvent.ASYNC_ERROR, asyncErrorHandler);
				 
				// NET STREAM
				netStream.client = metaDataObject; // this will call the nsMetadataHandler
	
				// SET THE BUFFER TIME
				if(mcVideoPlayer != null && currVideoServer != null && currVideoServer.lastIndexOf("rtmp") != -1) netStream.bufferTime = 0;
				else netStream.bufferTime = bufferTime;
				//trace(netStream.bufferTime);
				
				// dispatch event to make the player know that the video can start
				canStart();
			}
		}
		
		// dispatch event to make the player know that the video can start
		function canStart() : void
		{
			if(!MediaLoaded) 
			{
				MediaLoaded = true;
				dispatchEvent(new Event("MediaLoaded", true, false));
			}			
		}

		/**
		 * NET CONNECTIUON SECURITY ERRORS HANDLER
		 */
		public function onSecurityError(event : AsyncErrorEvent) : void 
		{
		    trace(event.text);
		}
		/**
		 * NET CONNECTIUON ASYN ERRORS HANDLER
		 */
		public function asyncErrorHandler(event : AsyncErrorEvent) : void 
		{
		    trace(event.text);
		}
		
		/**
	     * handles the onMetadata event for the netstream
	     */
	    private function nsCuePointHandler(infoObject : Object) : void
	    {
	    	trace("CUE POINT");
	    }
	    		
		/**
	     * handles the onMetadata event for the netstream
	     */
	    private function nsMetadataHandler(infoObject : Object) : void
	    {
			if(!medataFlag) 
			{
	            // DETERMINE THE TOTAL TIME
	            totalTime = Prototypes.readNumberVar(infoObject.duration, 0); //trace("Total time:>" + infoObject.duration + "<");
		    	
		    	// RECREATE THE VIDEO OBJECT
		    	if(videoObject)
		    	{
					this.removeChild(videoObject);
					videoObject = null;
		    	}
				videoObject = new Video(infoObject.width, infoObject.height); //trace(infoObject.width + " " + infoObject.height);
				videoObject.smoothing = true;
				this.addChild(videoObject);	//this.swapChildren(mcBack as DisplayObject, mcLoader as DisplayObject); //this.setChildIndex(this.videoObject, this.numChildren-2);
	            // resize video object for the current display area(player size or fullscreen)
				resizeVideoObject(mcBack.width, mcBack.height); //trace("video: ", videoObject.width, videoObject.height);
	            // attach the video			
				videoObject.attachNetStream(netStream);
				
				// HIDE THE LOADER
				mcVideoPlayer.mcLoader.visible = false;
				
				// if stop button was not pressed
				if(mcVideoPlayer.mcController.mcStopBt.mouseEnabled)
				{
					// set the total time it in timer
//	            	showTime(mcVideoPlayer.mcController.mcTimer.mcSign.tTotalTime, totalTime);
	            	//trace(mcVideoPlayer.mcController.mcTimer.mcSign.tTotalTime.text);
	          	
			    	// activate pause and video button
					mcVideoPlayer.mcVideoButton.mouseEnabled = true;
			    	mcVideoPlayer.mcController.mcPauseBt.mouseEnabled = true;   	
				}				
				
				
				// set volume from the volume bar
				setVolumeInstant(currentVolume); //trace("Stream volume after: " + getVolume);						
				
				
				// DELAY FOR MOV AND MP4... files
				// change the flag
				medataFlag = true;
				
				// hide the video				
				this.visible = false;
				
				// seek the video
				netStream.pause();
				netStream.seek(0);
				
				// show the video after a time
				clearTimeout(showVideoId);
				showVideoId = setTimeout(showVideo, 300);				
			}
		}
		
		// show the video object
		public function showVideo() : void
		{
			if(netStream != null) netStream.resume();
			if(mcVideoPlayer.isVideoMode) this.visible = true;	
		}
	    
	    /*
	     * handles the onstatus event
	     */
	    private function nsStatusHandler(info : Object) : void
	    {
//	    	trace("NetStream:", info.info.code);
			switch (info.info.code) 
	        {
				case "NetStream.Buffer.Full": 
					mcVideoPlayer.mcLoader.visible = false;
//					trace("MediaBufferFull");
					dispatchEvent(new Event("MediaBufferFull"));
					break;
				case "NetStream.Buffer.Empty":
					//if(currVideoURL.lastIndexOf("rtmp") == -1) 
//					mcVideoPlayer.mcLoader.visible = true;
					//trace("Show: " + mcVideoPlayer.mcLoader.visible);
					break;     	
	            case "NetStream.Buffer.Flush":
	            	//if(currVideoURL.lastIndexOf("rtmp") == -1) mcVideoPlayer.mcLoader.visible = true;
	            	//trace("Hide preloader: " + mcVideoPlayer.mcLoader.visible);
	                //clearInterval(this.bufferInterval);
	                //this.mcController.hidePreloader();
	                //trace("S-a terminat filmu!");			
	                break;
	            case "NetStream.Play.Start":
//	            	trace("video started");
					//if(mcVideoPlayer.mcController.isPlaying) 
//					mcVideoPlayer.mcLoader.visible = true;
	                break;
	            case "NetStream.Play.Stop":
	            	// hide the loader
	            	mcVideoPlayer.mcLoader.visible = false;

					// press the stop button if the playhead reached the end of the video
//					checkEnd();
					
					dispatchEvent(new Event("MediaPlayingEnd"));
					break;
				case "NetStream.Play.StreamNotFound":
					mcVideoPlayer.showErrorMessage(true);
					break;					
	        }	    	
	    }
	    
	    /*
	     * CHECKS END of the video
	     */	    
	    public function checkEnd() : void
	    {
	    	var endLimitDifference : Number = 0.15;
			if(netStream != null)
			{
//				trace("DISPATCH VIDEO END EVENT", netStream.time, totalTime);
//				if(netStream.time > 0 && totalTime > 0 && netStream.time >= totalTime - endLimitDifference)
		    	{
//		    		trace("video ended");
		    		dispatchEvent(new Event("MediaPlayingEnd"));
		    	}
			}
	    }


		/********************************************
		 * 			
		 * 			PLAYING functions
		 * 			
		 ********************************************/		
		/**
	     * START first time / PLAY / RESUME the video
	     */
	    public function playVideo() : void 
	    {
	    	if(currVideoPath)
	    	{
	    		// YT video
	    		if(playingYT)
	    		{
//	    			trace("play yt video:", ytPlayerInitialized);
	    			if(ytPlayerInitialized) 
	    			{
	    				// load the youtube video for the first time
	    				if(!videoPlayedFirstTime)
	    				{
							// change the loading status
							videoPlayedFirstTime = true;
							
							// load video
							ytPlayer.loadVideoByUrl(currVideoPath); // this will call the onPlayerStateChange handler that will start the video after the video is loaded inside the module
//							ytPlayer.cueVideoByUrl(currVideoPath); // this will call the onPlayerStateChange handler that will start the video after the video is loaded inside the module
	    				}
	    				// resume youtube video
	    				else 
	    				{
	    					// start video
	    					ytPlayer.playVideo();
	    				}
	    			}
	    			
					// show this module
					if(mcVideoPlayer.isVideoMode) this.visible = true;	    			
				}
	    		// regular video
	    		else
	    		{
					// play video for the first time
					if(!videoPlayedFirstTime)
					{
						//trace("nConnection.connected: " + nConnection.connected);
						// test if the connection was made to know if the video can start
						if(nConnection.connected)
						{
							// change the loading status
							videoPlayedFirstTime = true;
							
							// hide the preview image
	//						Tweener.removeTweens(mcVideoPlayer.mcImageHolder);									
							
							// start playing the current video for the first time
							if(netStream) netStream.play(currVideoPath); //trace("VIDEO stream:>" + currVideoPath + "<");
						}
						// show the message to the user that he / she should refresh the player
						else
						{
							mcVideoPlayer.showErrorMessage(false);
						}
					}
					// resume playing the video
					else
					{	
						// resume the video
						netStream.resume();
						
						// show this module
						if(mcVideoPlayer.isVideoMode) this.visible = true;
					}
	    		}
				
				// change the playing status
				isPlaying = true;
				
				// tell the player that the sound started
				dispatchEvent(new Event("MediaPlayingStart"));				
	    	}
	    	// show the message to the user that the path is not correct
	    	else mcVideoPlayer.showErrorMessage(true);
		}
		
		/**
	     * STOP the video
	     */
	    public function stopVideo() : void 
	    {
	    	//trace("S-a apasat STOP");
	    	// make the video invisible
			this.visible = false;
		
    		// YT video
    		if(playingYT)
    		{
    			if(ytPlayerInitialized) 
    			{
//    				ytPlayer.stopVideo();
    				ytPlayer.pauseVideo();
    				ytPlayer.seekTo(0);
    				setTimeout(ytPlayer.pauseVideo, 100);
    			}
			}		
			// regular video
			else
			{
				// seek back to 0
				if(netStream)
				{
					netStream.pause(); 
					netStream.seek(0);
				}
			}
			
			// change the playing status
			isPlaying = false;
			
			// arunca event ca s-a stopat sunetul
			dispatchEvent(new Event("MediaPlayingStop"));						
			
	    	// show 0 time in the timer
//	    	showTime(mcVideoPlayer.mcController.mcTimer.mcSign.tPassedTime, 0);	
//	    	showTime(mcVideoPlayer.mcController.mcTimer.mcSign.tTotalTime, 0);	
		}	    
		
	    /**
	     * PAUSE the video
	     */
	    public function pauseVideo() : void 
	    {
	    	// pause yt player
	    	if(playingYT) 
	    	{
	    		if(ytPlayerInitialized) ytPlayer.pauseVideo();
	    	}
			// pause the netstream
			else netStream.pause();
			
			// change the playing status
			isPlaying = false;	
			
			// tell the player that the sound paused
			dispatchEvent(new Event("MediaPlayingPause"));					
		}		
		

	    /**
	     * Called when video needs to seek to a specific time
	     * @param ptime the position where the video needs to seek
	     */
	    public function seekVideoToTime(ptime : Number) : void 
	    {
//	    	trace("seek to time:", ptime);
	    	if(ptime < 0) ptime = 0;
//			if(ptime > this.totalTime) ptime = this.totalTime;
				
			if(netStream != null) netStream.seek(ptime);
	    }
	    
	    /**
	     * Called when video needs to seek to a specific procent of time
	     * @param procent the position where the video needs to seek
	     */
	    public function seekVideoToProcent(percent : Number) : void 
	    {
	    	// video position
	    	var pos : Number = percent * totalTime;
	    	
	    	// seek
	    	if(playingYT) 
	    	{
	    		if(ytPlayerInitialized) ytPlayer.seekTo(pos);
	    	}
	    	else
	    	{	    	
				if(netStream != null) netStream.seek(pos);
	    	}
	    }
		
		
	    /**
	     * Called when video needs to seek forward with a specific time
	     * @param ptime to add to netsream time
	     */
	    public function forwardWith(ptime : Number = 5) : void 
	    {
	    	seekVideoToTime(netStream.time + ptime);
	    }

	    /**
	     * Called when video needs to rewind
	     * @param ptime to add to netsream time
	     */
	    public function rewind() : void 
	    {
	    	seekVideoToTime(0);
	    }		
		
		
		/********************************************
		 * 			
		 * 			SETTERS / GETTERS
		 * 			
		 ********************************************/		
		/**
	     * Sets the time in the controller's timer depending on the played time of the video
	     * called with interval during playing and on seeking
	     */
	    public function setTimeProgress() : void 
	    {
			if(netStream != null)
			{
				// show time in the timer
	    		showTime(mcVideoPlayer.mcController.mcTimer.mcSign.tPassedTime, netStream.time);
	    		showTime(mcVideoPlayer.mcController.mcTimer.mcSign.tTotalTime, totalTime);
			}	    	
	    }
	    //
		function showTime(textField : TextField, myTime : Number) : void
		{
			textField.htmlText = Prototypes.videoTimeConvert(myTime);
			//mcVideoPlayer.mcController.mcTimer.mcSign.tPassedTime.textColor = textColor;
		}

		/**
	     * Get total time
	     */
	    public function get getTotalTime() : Number 
	    {
	        return totalTime; 
		}

		/**
		 * Get loaded percentage
		 */
		public function get getLoadedPercent() : Number
		{
			var percent : Number = 0;
			
	    	if(playingYT) 
	    	{
	    		if(ytPlayerInitialized) percent = ytPlayer.getVideoBytesLoaded() / ytPlayer.getVideoBytesTotal();
	    	}
	    	else 
	    	{
				percent = (netStream != null && netStream.bytesTotal > 0 ? (netStream.bytesLoaded / netStream.bytesTotal) : (currVideoServer == null ? 0 : 1) );
	    	}
			
			return percent;
		}

		/**
		 * Get played percentage
		 */
		public function get getPlayedPercent() : Number
		{
			var percent : Number = 0;
			
	    	if(playingYT) 
	    	{
	    		if(ytPlayerInitialized) percent = (totalTime != 0 ? ytPlayer.getCurrentTime() / totalTime : 0);
	    	}
	    	else percent = (totalTime != 0 && netStream != null ? (netStream.time / totalTime) : 0);
	    	
			return percent;
		}
		
		/**
		 * Get the played time
		 */
		public function get getPlayedTime() : Number
		{
			return (netStream != null ? netStream.time : 0);
		}		
		
	    /**
	     * Set the buffer time
	     */
	    public function set setBufferTime(pbufferTime : Number) : void 
	    {			
			bufferTime = pbufferTime;
		}
		
		/**
	     * Get current buffered time
	     */
	    public function get getBufferTime() : Number 
	    {
	        return bufferTime;
		}
		
		
		/**
	     * Sets the video's volume
	     * @param pVolume the new volume's value
	     */
	    public function set setVolume(pVolume : Number) : void
	    {
	    	 setVolumeInstant(pVolume, fadeSoundTime);
	    }
	    public function setVolumeInstant(pVolume : Number, fadeTime : Number = 0) : void 
	    {
	    	if(playingYT)
	    	{
	    		if(ytPlayerInitialized) ytPlayer.setVolume(pVolume * 100);
			}
	    	else
			Tweener.addTween(st, {volume : pVolume, time : fadeTime, transition : "easeOutQuad", onUpdate : function() : void 
			{
				currentVolume = st.volume;
				
				if(netStream != null) netStream.soundTransform = st;
				else
				{
					//FIXME: ERROR Sound Channel is null
//					trace("Video Sound Channel is null!");
				}				
			}});
		}	
	
	    /**
	     * Get the current video's volume
	     * @return the current video's volume
	     */
	    public function get getVolume() : Number 
	    {
	        return (playingYT ? (ytPlayerInitialized ? ytPlayer.getVolume() : 0) : currentVolume);
		}	    
	    public function set setFadeTime(value : Number) : void
	    {
			fadeSoundTime = value;
		}							
	

	} // END OF THE CLASS
} // END OF THE PACKAGE
