﻿/**
 * Mp3 Gallery, December 2009
 * @author Vuzum, LLC.
 * @version 1; 
 * http://www.vuzum.com
 * email: office@vuzum.com
 */

package com.vuzum.mp3gallery 
{
	import com.vuzum.autoplayimagesgallery.AutoplayImagesGallery;
	import flash.display.StageDisplayState;
	import flash.events.MouseEvent;	
	import flash.events.Event;	
	import flash.display.MovieClip;
	
	// Tweener imports

	import caurina.transitions.properties.*;

	// Vuzum imports

	import com.vuzum.utils.*;
	import com.vuzum.mp3gallery.mp3player.*;

	public class Mp3Gallery extends MovieClip 
	{
		// CONSTANTS
		private static var instance : Mp3Gallery;
		private const DEFAULT_STAGE_WIDTH : Number = 300;
		private const DEFAULT_STAGE_HEIGHT : Number = 200;		
		
		/*
		 * COMPONENTS INSIDE
		 */
		public var mcLoader : MovieClip;
		//
		public var mcAlbumsGallery : AutoplayImagesGallery;
		public var mcMp3Player : Mp3Player;
		//
		public var mcBack : MovieClip;
		
		/*
		 * COMPONENT VARS
		 */
		public var componentWidth : Number;
		public var componentHeight : Number;
		//
		public var pathToFiles : String = "";
		//
		public var xmlPath : String;
		public var contentPath : String;
		
		
		/*
		 * INTERNAL MEMBERS
		 */
		// HANDLERS VARS
		private var currPressedObject : MovieClip;
		
		// GENERAL SETTINGS
		// background
		private var backgroundColor : Number;
		private var backgroundTransparency : Number = 0;
		public var embedObject : Object;
		
		// playing settings
		public var offset : Number = 10;
		public var selectedAlbum : Number = 0;
		public var selectedSong : Number = 1;
		//
		public var autostart : Boolean;
		public var shuffle : Boolean;
		public var shuffleAlbum : Boolean;
		public var loop : Boolean;
		public var loopAlbums : Boolean;

		// texts
		public var currency : String = "$";
		
		public var itemsBuyBtText : String = "Buy Track";
		public var rate : String = "";
		public var share : String = "";
		//
		public var shareWindowCloseBtText : String = "CLOSE";
		public var shareWindowTitle : String = "SHARE THIS";
		public var shareWindowCopyBt : String = "COPY CODE";
		//
		public var tracks : String = "";
		public var buyAlbum : String = "";
		public var randomAlbum : String;
		public var backToAlbum : String;		
		
		
		// ALBUMS GALLERY
		public var albumsGallerySettingsXMLList : XMLList;
		public var albumsGalleryContentXMLList : XMLList;
		//
		public var albumsArray : Array;
		public var nrAlbums : int = 0;
		public var hasMixAlbum : Boolean = false;
				
		
		// MP3 PLAYER
		public var mp3playerSettingsXMLList : XMLList;

		/**
		 * @return SINGLETON instance of the class
		 */
		public static function getInstance() : Mp3Gallery 
		{
			if (instance == null) instance = new Mp3Gallery();
			return instance;
		}


		/*
		 * CONSTRUCTOR
		 */
		public function Mp3Gallery() 
		{
			instance = this;
			
			ColorShortcuts.init();
			TextShortcuts.init();
			
			new Prototypes();
			
			// INIT & HIDE EVERYTHING
			show(false, true); 
		}
		
		public function prepareLoad() : void
		{	
			// HIDE EVERYTHING
			show(false, true);

			// CENTER THE LOADER
			mcLoader.centerOn(!isNaN(componentWidth) ? componentWidth : (stage ? stage.stageWidth : DEFAULT_STAGE_WIDTH), !isNaN(componentHeight) ? componentHeight : (stage ? stage.stageHeight : DEFAULT_STAGE_HEIGHT));				
		}		

		public function init(pComponentWidth : Number = NaN, pComponentHeight : Number = NaN, pPathToFiles : String = "", pXmlPath : String = "", pContentPath : String = "") : void 
		{
			// hide everything
			show(false, true);
			
			// read the params
			componentWidth = pComponentWidth;
			componentHeight = pComponentHeight;
			
			// path
			pathToFiles = Prototypes.readPathTo(pPathToFiles, pathToFiles);
			
			// settings and content xml paths
			xmlPath = Prototypes.readAssetPath(pXmlPath, pathToFiles);
			contentPath = Prototypes.readAssetPath(pContentPath, pathToFiles); //trace(contentPath);
			
			// create the embedObject
			embedObject = new Object();
			embedObject.componentWidth = componentWidth;
			embedObject.componentHeight = componentHeight;
			embedObject.pathToFiles = pathToFiles;
			embedObject.xmlPath = Prototypes.readStringVar(pXmlPath);
			embedObject.contentXMLPath = Prototypes.readStringVar(pContentPath);
			
			// centrate the loader
			prepareLoad();
			
			// read the SETTINGS xml file
			Prototypes.loadXML(xmlPath, settingsXmlLoaded, mcLoader);
		}

		// settings XML
		public function settingsXmlLoaded(xmlObject : XML) : void 
		{
			// read the COMPONENT DIMENSIONS if these were not defined in the flash vars
			if(isNaN(componentWidth)) componentWidth = Prototypes.readNumberVar(xmlObject.@width, (stage ? stage.stageWidth : DEFAULT_STAGE_WIDTH));
			if(isNaN(componentHeight)) componentHeight = Prototypes.readNumberVar(xmlObject.@height, (stage ? stage.stageHeight : DEFAULT_STAGE_HEIGHT));					
			//
			embedObject.componentWidth = componentWidth;
			embedObject.componentHeight = componentHeight;
			
			// GENERAL SETTINGS
			// colors
			backgroundColor = Prototypes.readNumberVar(xmlObject.settings.backgroundColor);
			backgroundTransparency = Prototypes.readNumberVar(xmlObject.settings.backgroundColor.@alpha, backgroundTransparency) / 100;
			// margin around			
			offset = Prototypes.readNumberVar(xmlObject.settings.marginAround, offset);
			
			// TEXTS
			var textNode : XMLList = xmlObject.settings.text;
			// header buttons
			
			randomAlbum = Prototypes.readStringVar(textNode.randomAlbumBtText, randomAlbum);
			backToAlbum = Prototypes.readStringVar(textNode.backToAlbumBtText, backToAlbum);
			// list title
			tracks = Prototypes.readStringVar(textNode.listTitle, tracks);
			// sound player controls
			
			// share window
			shareWindowCloseBtText = Prototypes.readStringVar(textNode.shareWindowCloseBt, shareWindowCloseBtText);
			shareWindowTitle = Prototypes.readStringVar(textNode.shareWindowTitle, shareWindowTitle);
			shareWindowCopyBt = Prototypes.readStringVar(textNode.shareWindowCopyBt, shareWindowCopyBt);
						
			
			// ALBUMS GALLERY SETTINGS
			albumsGallerySettingsXMLList = xmlObject.albumsgallery;			
			
			// for coverflow
			shuffleAlbum = Prototypes.readBooleanVar(xmlObject.settings.shuffleAlbum);
			loopAlbums = Prototypes.readBooleanVar(xmlObject.settings.loopAlbums);			
			// for audio player
			autostart = Prototypes.readBooleanVar(xmlObject.settings.autostart);
			shuffle = Prototypes.readBooleanVar(xmlObject.settings.shuffle);
			loop = Prototypes.readBooleanVar(xmlObject.settings.loop);			
			
			// ALBUM MP3 PLAYER SETTINGS
			mp3playerSettingsXMLList = xmlObject.mp3player;
			// list
			itemsBuyBtText = Prototypes.readStringVar(xmlObject.mp3player.list.buyBtText, itemsBuyBtText); //trace("itemsBuyBtText:", itemsBuyBtText);
			currency = Prototypes.readStringVar(xmlObject.mp3player.list.currency, currency); //trace("currency:", currency);
			
			
			// read the CONTENT XML file and START THE APPLICATION
			Prototypes.loadXML(contentPath, contentXmlLoaded, mcLoader);
		}

		// content XML
		public function contentXmlLoaded(xmlObject : XML) : void 
		{
			// read the albums gallery node
			albumsGalleryContentXMLList = xmlObject.albums;
			
			// read the number of albums
			var itemsNode : XMLList = (xmlObject.albums.children());
			nrAlbums = itemsNode.length(); //trace("no albums:", nrAlbums, itemsNode.length(), xmlObject.albums.album.length());
			
			// read the albums
			albumsArray = new Array();		
			var album : Album;	
			var track : Track;	
			for(var i : uint = 0; i < nrAlbums; i++) 
			{
				album = new Album();
				//
				album.type = Prototypes.readStringVar(itemsNode[i].@type, "regular"); //trace("author " + i + ": " + album.getAuthor);
				//
				album.setAuthor = Prototypes.readStringVar(itemsNode[i].author, ""); //trace("author " + i + ": " + album.getAuthor);
				
				// title
				album.setName = Prototypes.readStringVar(itemsNode[i].name, ""); // trace(album.getName);
				album.setNameInList = Prototypes.readBooleanVar(itemsNode[i].name.@alsoInList, false); // trace(album.getName);
				// description
				album.setCaption = Prototypes.readStringVar(itemsNode[i].caption, "");
				
				// image
				album.setImage = Prototypes.readAssetPath(Prototypes.readStringVar(itemsNode[i].image), pathToFiles); //trace(album.getImage);
				album.setLink = Prototypes.readStringVar(itemsNode[i].image.@url, "");
				album.setLinkTarget = Prototypes.readStringVar(itemsNode[i].image.@target, "_blank");
				// buy bt
				album.setPrice = Prototypes.readNumberVar(itemsNode[i].buy.@price, 0);
				album.setBuy = Prototypes.readStringVar(itemsNode[i].buy, "");
				album.setBuyTarget = Prototypes.readStringVar(itemsNode[i].buy.@target, "_blank");
				
				
				// read the TRACKS in each album
				var tracksNode : XMLList = (itemsNode[i].tracks.children());
				var tracksArray : Array = new Array();
				if(album.type == "mix")
				{
					hasMixAlbum = true;	
					tracksArray = Prototypes.readStringVar(itemsNode[i].tracks).split(",");
//					trace("mix tracksArray:", tracksArray);
				}
				else
				for(var j : uint = 0; j < tracksNode.length(); j++) 
				{
					track = new Track();
					//
					track.setIndex = j;
					track.ID = Prototypes.readNumberVar(tracksNode[j].@id);
					//
					track.albumIndex = i;
					track.albumID = Prototypes.readNumberVar(itemsNode[i].@id);
					track.albumName = album.getName;					
					track.albumImage = album.getImage;					
					//
					track.setTitle = Prototypes.readStringVar(tracksNode[j].title, ""); //trace(track.getTitle);
					track.setArtist = Prototypes.readStringVar(tracksNode[j].artist, "");
					track.setDuration = Prototypes.readStringVar(tracksNode[j].duration, "");
					//
					track.setStreamer = Prototypes.readStringVar(tracksNode[j].song.@streamer, null);
					track.setSong = (track.getStreamer == null ? Prototypes.readAssetPath(tracksNode[j].song, pathToFiles) : Prototypes.readStringVar(tracksNode[j].song));
					//
					track.imagePath = Prototypes.readAssetPath(Prototypes.readStringVar(tracksNode[j].image), pathToFiles);
					track.imageLink = Prototypes.readStringVar(tracksNode[j].image.@url);
					track.imageLinkTarget = Prototypes.readStringVar(tracksNode[j].image.@target, "_blank");
					//
					track.setBuy = Prototypes.readStringVar(tracksNode[j].buy, itemsBuyBtText); //trace(track.getBuy);
					track.setPrice = Prototypes.readNumberVar(tracksNode[j].buy.@price, 0);
					track.setBuyLink = Prototypes.readStringVar(tracksNode[j].buy.@url, ""); //trace(track.getBuyLink);
					track.setBuyTarget = Prototypes.readStringVar(tracksNode[j].buy.@target, "_self");
					//
					track.setRating = Prototypes.readNumberVar(tracksNode[j].rating, 0);
					track.setTotalVotes = Prototypes.readNumberVar(tracksNode[j].totalVotes, 0);
					track.voted = false;
					
					// add it to the array
					tracksArray.push(track);
				}
				// add all tracks to album
				album.setTracks = tracksArray;
				
				// if is mix album add it on position 0
				if(album.type == "mix") albumsArray = Prototypes.insert(albumsArray, 0, album); 
				// add the album in the array
				else albumsArray.push(album);
			}
			// if there is a mix album create its tracks list from other albums
			if(hasMixAlbum)
			{
				//trace("mix author " + i + ": " + albumsArray[0].getAuthor);
				var tracksIds : Array = (albumsArray[0] as Album).getTracks;
				var noTracksIds : Number = tracksIds.length;
				var newTracks : Array = new Array();
				// loop trough the other albums list to find the tracks based on the ids list
				for(i = 1; i < nrAlbums; i++)
				{
//					trace("albumsArray[" + i + "]:", albumsArray[i].getAuthor);
					for(j = 0; j < albumsArray[i].getTracks.length; j++)
						for(var k : Number = 0; k < noTracksIds; k++)
							if(tracksIds[k] == albumsArray[i].getTracks[j].ID) newTracks.push(albumsArray[i].getTracks[j]);
				}
						
				// set the tracks list
				albumsArray[0].setTracks = newTracks;
			}
			
			
			// START THE APP
			start();
		}

		/*
		 * Loads all images in an array of movie clips 
		 */
		private function start() : void 
		{
			// config background
			mcBack.setColor(backgroundColor);
			mcBack.alpha = backgroundTransparency;
			
			// DISPLAY COMPONENT'S elements
			show();						
			
			// init MP3 PLAYER
			mcMp3Player.setIterateFunction = mcAlbumsGallery.iterateAndSelect; 
			mcMp3Player.pathToFiles = pathToFiles;
			mcMp3Player.initWithXMLList(componentWidth - 2 * offset, componentHeight - 2 * offset, mp3playerSettingsXMLList);


			// init the ALBUM GALLERY
			var tempArray : Array = new Array();
			var i : int;
			for(i = 0; i < albumsArray.length; i++) 
			{
				tempArray.push({imageUrl : albumsArray[i].getImage});
				//trace(albumsArray[i].getImage);
			}			
			mcAlbumsGallery.pathToFiles = pathToFiles;
			mcAlbumsGallery.setExtSelectItemFunction = albumItemClick;
			if(hasMixAlbum) mcAlbumsGallery.selectedItemNo = 0;
			mcAlbumsGallery.initWithSettingsAndContentXMLList(componentWidth, componentHeight, albumsGallerySettingsXMLList, albumsGalleryContentXMLList);			


			// RESIZE THE COMPONENT
			resize(componentWidth, componentHeight);
			stage.addEventListener(Event.RESIZE, resizeHandler);
		}
		
		/**
		 * RESIZE EVENT HANDLER
		 */
		private function resizeHandler(event : Event) : void 
		{
			// make invisible the others and reposition the player
			if(stage.displayState == StageDisplayState.FULL_SCREEN)
			{
				// resize dimensions
				resize(stage.stageWidth, stage.stageHeight);				
			}
			// NORMAL STATE 
			else 
			{
				// resize dimensions
				resize(componentWidth, componentHeight);			
			}
		}		

		/*
		 * to do on selecting a coverflow item
		 */
		private function albumItemClick(id : Number) : void 
		{
			selectedAlbum = id;
			
			// if fullscreen, go small
			goSmall();
			
			// hide the albums gallery
			mcAlbumsGallery.visible = false;

			// load the new album inside the mp3 player with playlist
			mcMp3Player.loadAlbum(albumsArray[selectedAlbum]);
			mcMp3Player.visible = true;
		}

		public function goSmall() : void 
		{
			if(stage.displayState == StageDisplayState.FULL_SCREEN) stage.displayState = StageDisplayState.NORMAL;
		}		

		// select a coverflow item randomly
		public function selectRandomAlbum(flag : Boolean = true) : void 
		{
//			var tempId : Number = Prototypes.randomBetween(0, albumsArray.length-1);
//			trace("random ID:", tempId);
			
			// call the click function
			//coverFlowItemClick(tempId);
		}		

		/************************************************
		 * 
		 * 				EVENT HANDLERS
		 * 
		 ************************************************/		
		// resize component
		public function resize(w : Number, h : Number) : void 
		{
			// resize BACKGROUND
			mcBack.width = w;
			mcBack.height = h;
			
			// resize the ALBUMS GALLERY
//			mcAlbumsGallery.x = mcAlbumsGallery.y = 0;
			
			// resize & position the PLAYER
			mcMp3Player.x = offset;
			mcMp3Player.y = offset;			
			mcMp3Player.resize(w - 2 * offset, h - 2 * offset);
		}

		/**
		 * OVER EVENT HANDLER
		 */
		public function overHandler(event : MouseEvent) : void 
		{
//			var mc : Object = event.currentTarget;	
		}

		/**
		 * OUT HANDLER
		 */
		public function outHandler(event : MouseEvent) : void 
		{
//			var mc : Object = event.currentTarget;
		}

		/**
		 * PRESS EVENT HANDLER
		 */
		public function pressHandler(event : MouseEvent) : void 
		{
			var mc : MovieClip = event.currentTarget as MovieClip; 
			//trace("Event.target press..." + event.target);
			
			// set pressed the new item
			currPressedObject = mc;
		
			// add the release event on stage
			stage.addEventListener(MouseEvent.MOUSE_UP, releaseOutsideHandler);
			stage.addEventListener(Event.MOUSE_LEAVE, releaseOutsideHandler);
		}

		/**
		 * RELEASE OUTSIDE EVENT HANDLER
		 */
		public function releaseOutsideHandler(e : Event) : void 
		{
			stage.removeEventListener(MouseEvent.MOUSE_UP, releaseOutsideHandler);
			stage.removeEventListener(Event.MOUSE_LEAVE, releaseOutsideHandler);
		}

		/**
		 * RELEASE EVENT HANDLER
		 */
		public function releaseHandler(event : MouseEvent) : void 
		{
			var mc : MovieClip = event.currentTarget as MovieClip; 
						
			// test if the releasse event comes from the same item that was pressed
			if(mc == this.currPressedObject) 
			{
				releaseFunction(mc);
				currPressedObject = null;
			}
		}

		public function releaseFunction(mc : MovieClip) : void 
		{
		}

		/************************************************
		 * 
		 * 				  AUX FUNCTIONS
		 * 
		 ************************************************/		
		// show/hide all components
		public function show(flag : Boolean = true, loaderFlag : Boolean = false) : void 
		{
			mcLoader.visible = loaderFlag ? flag : !flag;
			
			// hide
			if(!flag) 
			{
				mcMp3Player.visible = flag;
			}
			
			// show
			mcAlbumsGallery.visible = flag;
			mcBack.visible = flag;	
		}

		public function get getScope() : Mp3Gallery 
		{
			return this;
		}
		
	} // END OF PACKAGE
} // END OF CLASS
