﻿/**
 * Copyright (c) 2009 Vuzum LLC <http://www.vuzum.com/>
 */

package com.vuzum.mp3gallery.mp3player 
{

	// FLASH IMPORTS
	import flash.display.MovieClip;

	// OTHER IMPORTS
	import caurina.transitions.properties.*;
	

	/**
	 * CONSTRUCTOR
	 */
	public class Album extends MovieClip
	{
		// INTERNAL MEMBERS		
		public var type : String = "regular";
		//
		private var albumAuthor : String = "";
		//
		private var albumName : String = "";
		private var albumNameInList : Boolean = true;
		//
		private var caption : String = "";
		//
		private var imagePath : String = "";
		//
		private var link : String = "";
		private var linkTarget : String = "_blank";
		//
		private var price : Number = 0;
		private var buy : String = "";
		private var buyTarget : String = "_blank";
		//
		private var tracksArray : Array;
		
		
		/**
		 * CONSTRUCTOR
		 */
		public function Album() 
		{
			// init PROTOTYPES
			ColorShortcuts.init();
			TextShortcuts.init();
		}

		
		// author
		public function get getAuthor() : String
		{
			return albumAuthor;
		}
		public function set setAuthor(pVal : String) : void
		{
			albumAuthor = pVal;
		}
		
		// name
		public function get getName() : String
		{
			return albumName;
		}
		public function set setName(pVal : String) : void
		{
			albumName = pVal;
		}
		
		// present in list
		public function get getNameInList() : Boolean
		{
			return albumNameInList;
		}			
		public function set setNameInList(pVal : Boolean) : void
		{
			albumNameInList = pVal;
		}		
		
		// image
		public function get getImage() : String
		{
			return imagePath;
		}
		public function set setImage(pVal : String) : void
		{
			imagePath = pVal;
		}
		
		
		// caption
		public function get getCaption() : String
		{
			return caption;
		}
		public function set setCaption(pVal : String) : void
		{
			caption = pVal;
		}
		
		
		// link
		public function get getLink() : String
		{
			return link;
		}
		
		public function set setLink(pVal : String) : void
		{
			link = pVal;
		}
		
		public function get getLinkTarget() : String
		{
			return linkTarget;
		}	
		
		public function set setLinkTarget(pval : String) : void
		{
			linkTarget = pval;
		}			
		
		
		// buy url
		public function get getBuy() : String
		{
			return buy;
		}
		
		public function set setBuy(pVal : String) : void
		{
			buy = pVal;
		}		
		
		// buy url target
		public function get getBuyTarget() : String
		{
			return buyTarget;
		}
		
		public function set setBuyTarget(pVal : String) : void
		{
			buyTarget = pVal;
		}
			
		// price
		public function get getPrice() : Number
		{
			return price;
		}
		
		public function set setPrice(pVal : Number) : void
		{
			price = pVal;
		}			
		
		
		
		// tracks array
		public function get getTracks() : Array
		{
			return tracksArray;
		}
		
		public function set setTracks(pVal : Array) : void
		{
			tracksArray = pVal;
		}
		
		
		// get single track
		public function getTrack(id : Number) : Object
		{
			return tracksArray[id];
		}
		
		// set single track
		public function setTrack(id : Number, pVal : Object) : void
		{
			if(!isNaN(id))
				tracksArray[id] = pVal;
			else
				tracksArray.push(pVal);
		}


		/****************************************************
		 * 
		 * 				AUX FUNCTIONS
		 * 
		 ****************************************************/
		public function get getScope() : Album
		{
			return this;
		}	
		
		public function traceTracks() : void
		{		
			for(var i : Number = 0; i < this.getTracks.length; i++)
				trace("mix track", i + ":", this.getTracks[i].getArtist, "-", this.getTracks[i].getTitle);			
		}

	}// FROM CLASS
}// FROM PACKAGE