﻿/**
 * Copyright (c) 2009 Vuzum LLC <http://www.vuzum.com/>
 */

package com.vuzum.mp3gallery.mp3player 
{

	// FLASH IMPORTS
	import com.vuzum.mediaplayer.SoundManager;
	import com.vuzum.list.List;
	import com.vuzum.mediaplayer.Controller;
	import com.vuzum.mediaplayer.MediaPlayer;
	import com.vuzum.utils.Share;
	import com.vuzum.utils.Rotator;
	import flash.display.MovieClip;
	import flash.events.MouseEvent;
	import flash.events.Event;	

	// OTHER IMPORTS
	import caurina.transitions.properties.*;
	//
	import com.zorked.URLNavigator;		
	
	// VUZUM IMPORTS
	import com.vuzum.mp3gallery.*;
	//
	import com.vuzum.utils.Prototypes;	
	import com.vuzum.list.Playlist;

	/**
	 * CONSTRUCTOR
	 */
	public class Mp3Player extends MovieClip
	{
		// COMPONENTS INSIDE
		// header clip
		public var mcAlbumName : MovieClip;
		public var mcLogo : MovieClip;
		public var mcRotator : Rotator;
		public var mcBackToAlbumsBt : MovieClip;
		public var mcHeaderBack : MovieClip;
		// info clip
		public var mcInfo : MovieClip;
		// playlist
		public var mcPlaylist : Playlist;
		// share window
		public var mcShare : Share;
		// audio player
		public var mcPlayer : MediaPlayer;
		//
		public var mcBackImage : MovieClip;
		public var mcBack : MovieClip;
		
		
		
		// INTERNAL MEMBERS
		// event handlers vars
		private var currPressedObject : MovieClip;		
		//
		private var mcMp3Gallery : Mp3Gallery;		
		private var extIterateFunction : Function;		
		// component vars
		public var componentWidth : Number;
		public var componentHeight : Number;
		public var pathToFiles : String = "";
		public var xmlPath : String;
		public var contentPath : String;
		
		// playlist xml array
		public var songsArray : Array;
		
		// SETTINGS VARS
		private var distBetweenElements : Number = 0;
		private var distBetweenElementsY : Number = 0;
		public var floatTextStep : Number = 1;
		public var textRightToLeft : Boolean;
		// header
		private var headerX : Number;
		private var headerY : Number;
		private var headerHeight : Number;
		private var headerMarginX : Number = 10;
		private var headerMarginY : Number = 5;
		//
		private var headerBackColor : Number;
		//
		private var headerArtistNameColor : Number;
		//		
		public var backToAlbumsDisable : Boolean = false;
		public var backToAlbumsBtText : String = "Back to albums";
		public var backToAlbumsBtTextNormalColor : Number;
		public var backToAlbumsBtTextOverColor : Number;		
		//	
		public var backToAlbumsBtFillNormalColor : Number;
		public var backToAlbumsBtFillOverColor : Number;
		//
		public var backToAlbumsBtStrokeNormalColor : Number;
		public var backToAlbumsBtStrokeOverColor : Number;
		//
		public var overButtonsTweenTime : Number = 0.5;
		// rotator
		public var headerRotatorXMLObject : *;
		// logo
		public var logoImagePath : String = "";
		public var logoClickURL : String = "";
		public var logoClickURLTarget : String = "";
		private var logoLoaded : Boolean = false;
		
		

		// info module on the left side
		public var albumInfoWidth : Number;
		public var albumInfoHeight : Number;
		public var albumInfoBorder : Number = 0;
		public var albumInfoDisable : Boolean;
		//
		public var albumInfoBackColor : Number;
		public var albumInfoBackOpacity : Number;
		// buy album bt
		public var buyAlbumText : String = "BUY";
		public var buyTextColor : Number = 0xFFFFFF;
		public var buyTextOverColor : Number = 0xFFFFFF;
		//
		public var buyFillColor : Number;
		public var buyFillOverColor : Number;
		//
		public var buyStrokeColor : Number;
		public var buyStrokeOverColor : Number;
		// prev next album buttons
		public var prevNextDisable : Boolean = false;
		public var prevNextAlbumBtNormalAlpha : Number = 0.5;
		public var prevNextAlbumBtOverAlpha : Number = 1;
		public var prevNextAlbumBtBackColor : Number;
		public var prevNextAlbumBtSignColor : Number;
		
		// list
		public var playlistObject : XMLList;
		private var listHeight : Number;
		
		// embed window
		public var embedWindowXMLList : XMLList;
		
		// audio player
		public var audioPlayerSettingsXMLList : XMLList;
		//
		public var audioPlayerProtectionXMLList : XMLList;
		public var protectionItemsNo : Number = 0;
		public var protectionCurrentItem : Number = 0;
		public var protectionPlayeveryXseconds : Number;
		public var protectionItems : Array;
		public var protectionSM : SoundManager;
		// list
		public var selectedItem : Object; // the song to start with from the list
		public var playlistSkipControls : Boolean; // to go next song after a song is done			
		
		
		// AUX VARS
		public var tempVar : *;
		public var live : Boolean = false;
		
		private var strokePixelIssue : Number = 0;
		private var loopList : *;
		private var currentInfoImage : String = "";

		/**
		 * CONSTRUCTOR
		 */
		public function Mp3Player() 
		{
			ColorShortcuts.init();
			TextShortcuts.init();
			
			new Prototypes();
			
//			mcShare.visible = false;
			mcInfo.mcLoader.centerOnClip(mcInfo.mcBack);
			mcBackImage.loaded = false;
			
			show(false); 
		}
		
		public function init(pComponentWidth : Number = NaN, pComponentHeight : Number = NaN, pPathToFiles : String = "", pXmlPath : String = "", pContentPath : String = "") : void
		{
			// hide everything
			show(false);
			
			// read the params
			componentWidth = pComponentWidth;
			componentHeight = pComponentHeight;
			
			// path
			pathToFiles = Prototypes.readPathTo(pPathToFiles, pathToFiles);
			xmlPath = Prototypes.readAssetPath(pXmlPath, pathToFiles);
			contentPath = Prototypes.readAssetPath(pContentPath, pathToFiles);
			
        	// read the xml file
			Prototypes.loadXML(xmlPath, xmlLoaded);
		}
		
		public function xmlLoaded(xmlObject : * = null) : void			
		{
			// make the first resize
			resize(componentWidth, componentHeight);
		}
		
		// this is used in this project
		public function initWithXMLList(pComponentWidth : Number = NaN, pComponentHeight : Number = NaN, xmlObject : XMLList = null) : void			
		{
			// read parent
			mcMp3Gallery = this.parent as Mp3Gallery;
			
			// READ THE DIMENSIONS
			componentWidth = pComponentWidth;
			componentHeight = pComponentHeight;
			//
			// read the COMPONENT DIMENSIONS if these were not defined in the flash vars
			if(isNaN(componentWidth)) componentWidth = Prototypes.readNumberVar(xmlObject.@width, stage.stageWidth);
			if(isNaN(componentHeight)) componentHeight = Prototypes.readNumberVar(xmlObject.@height, stage.stageHeight);	
			//trace(componentWidth, componentHeight);
						
			// READ THE XML SETTINGS
			distBetweenElements = Prototypes.readNumberVar(xmlObject.@distBetweenX, distBetweenElements);
			distBetweenElementsY = Prototypes.readNumberVar(xmlObject.@distBetweenY, distBetweenElementsY);
			
			textRightToLeft = Prototypes.readBooleanVar(xmlObject.textRightToLeft, false);
			
			// back image
			mcBackImage.backImagePath = Prototypes.readAssetPath(xmlObject.backImagePath, pathToFiles);
			
			// float text step
			floatTextStep = Prototypes.readNumberVar(xmlObject.floatTextSpeed, 1);
			
			// HEADER(up)
			// distances
			headerX = Prototypes.readNumberVar(xmlObject.header.@positionX, 0);
			headerY = Prototypes.readNumberVar(xmlObject.header.@positionY, 0);
			headerHeight = Prototypes.readNumberVar(xmlObject.header.@height, mcHeaderBack.height);
			//
			headerMarginX = Prototypes.readNumberVar(xmlObject.header.@marginX, headerMarginX);
			headerMarginY = Prototypes.readNumberVar(xmlObject.header.@marginY, headerMarginY);
			// background
			headerBackColor = Prototypes.readNumberVar(xmlObject.header.backColor);
			headerArtistNameColor = Prototypes.readNumberVar(xmlObject.header.artistNameColor);
			// back to albums button
			backToAlbumsDisable = Prototypes.readBooleanVar(xmlObject.header.backToAlbumsBt.@disable, true);
			//
			backToAlbumsBtText = Prototypes.readStringVar(xmlObject.header.backToAlbumsBt.text, backToAlbumsBtText);
			backToAlbumsBtTextNormalColor = Prototypes.readNumberVar(xmlObject.header.backToAlbumsBt.text.@normalColor, backToAlbumsBtTextNormalColor);
			backToAlbumsBtTextOverColor = Prototypes.readNumberVar(xmlObject.header.backToAlbumsBt.text.@overColor, backToAlbumsBtTextOverColor);			
			//
			backToAlbumsBtFillNormalColor = Prototypes.readNumberVar(xmlObject.header.backToAlbumsBt.backFillColor);
			backToAlbumsBtFillOverColor = Prototypes.readNumberVar(xmlObject.header.backToAlbumsBt.backFillOverColor);
			//
			backToAlbumsBtStrokeNormalColor = Prototypes.readNumberVar(xmlObject.header.backToAlbumsBt.backStrokeColor);
			backToAlbumsBtStrokeOverColor = Prototypes.readNumberVar(xmlObject.header.backToAlbumsBt.backStrokeOverColor);
			// rotator
			headerRotatorXMLObject = xmlObject.header.rotator;
			// logo
			logoImagePath = Prototypes.readAssetPath(xmlObject.header.logoImage, pathToFiles); 
			logoClickURL = Prototypes.readAssetPath(xmlObject.header.logoImage.@clickURL); 
			logoClickURLTarget = Prototypes.readAssetPath(xmlObject.header.logoImage.@clickURLTarget, "_blank"); 
			
			
			// INFO(left)
			albumInfoWidth = Prototypes.readNumberVar(xmlObject.info.@width);
			albumInfoHeight = Prototypes.readNumberVar(xmlObject.info.@height);
			albumInfoBorder = Prototypes.readNumberVar(xmlObject.info.@border, albumInfoBorder);
			albumInfoDisable = Prototypes.readBooleanVar(xmlObject.info.@disable);
			//
			albumInfoBackColor = Prototypes.readNumberVar(xmlObject.info.backColor);
			albumInfoBackOpacity = Prototypes.readNumberVar(xmlObject.info.backColor.@opacity, 100) / 100;
			// prev next bts
			prevNextDisable = Prototypes.readBooleanVar(xmlObject.info.prevNextBts.@disable, true);
			prevNextAlbumBtNormalAlpha = Prototypes.readNumberVar(xmlObject.info.prevNextBts.normalAlpha, prevNextAlbumBtNormalAlpha * 100) / 100;
			prevNextAlbumBtOverAlpha = Prototypes.readNumberVar(xmlObject.info.prevNextBts.overAlpha, prevNextAlbumBtOverAlpha * 100) / 100;
			prevNextAlbumBtBackColor = Prototypes.readNumberVar(xmlObject.info.prevNextBts.backColor);
			prevNextAlbumBtSignColor = Prototypes.readNumberVar(xmlObject.info.prevNextBts.arrowColor);
			// but button settings
			buyAlbumText = Prototypes.readStringVar(xmlObject.info.buyAlbumBtText);
			buyTextColor = Prototypes.readNumberVar(xmlObject.info.buyAlbumBtText.@normalColor);
			buyTextOverColor = Prototypes.readNumberVar(xmlObject.info.buyAlbumBtText.@overColor);
			//
			buyStrokeColor = Prototypes.readNumberVar(xmlObject.info.buyAlbumBtStrokeColor);
			buyStrokeOverColor = Prototypes.readNumberVar(xmlObject.info.buyAlbumBtStrokeOverColor);
			//
			buyFillColor = Prototypes.readNumberVar(xmlObject.info.buyAlbumBtFillColor);
			buyFillOverColor = Prototypes.readNumberVar(xmlObject.info.buyAlbumBtFillOverColor);			


			// ALBUM PLAYLIST(right)
			playlistObject = xmlObject.list;
			listHeight = Prototypes.readNumberVar(xmlObject.list.@height); //trace("listHeight:" , listHeight);	

			
			// audio player(down)
			audioPlayerSettingsXMLList = xmlObject.audioplayer;
			var temp : String = Prototypes.readStringVar(xmlObject.audioplayer.protectionSongs);
			audioPlayerProtectionXMLList = (temp != "" ? xmlObject.audioplayer.protectionSongs : null);
			
			// AUDIO PLAYER(down)
			embedWindowXMLList = xmlObject.shareWindow;			
			
			
			
			// START COMPONENT
			main();
		}	
		
		// MAIN FUNCTION
		public function main() : void
		{	
			// BACKGROUND
			mcBack.alpha = 0;
			
			// Back image
			mcBackImage.alpha = 0;
			if(mcBackImage.backImagePath) mcBackImage.loadContent(mcBackImage.backImagePath, function() : void 
			{
				mcBackImage.fitToRect(mcBack.width, mcBack.height - mcPlayer.mcBack.height);
				mcBackImage.fadeAlpha();
			}, null, false);
			
			
			// init HEADER
			// background
			mcHeaderBack.setColor(headerBackColor);
			mcHeaderBack.height = headerHeight;
			
			// logo
			mcLogo.mcMask.height = mcHeaderBack.height - 2 * headerMarginY;
			mcLogo.mcHolder.mask = mcLogo.mcMask;
			mcLogo.mcHolder.alpha = 0;
			//
			if(logoClickURL != "")
			{
				mcLogo.mcHolder.buttonMode = true;
				mcLogo.mcHolder.addEventListener(MouseEvent.CLICK, function() : void
				{
					URLNavigator.ChangePage(logoClickURL, logoClickURLTarget);
				});
			}
			//
			mcLogo.mcHolder.loadContent(logoImagePath, function() : void
			{
				logoLoaded = true;
				mcLogo.mcMask.width = mcLogo.mcHolder.width;
				positionLogo();
					
				mcLogo.mcHolder.centerOn(NaN, mcLogo.mcMask.height);
				mcLogo.mcHolder.fadeAlpha();
			}, null, false);
			
			// album name
			mcAlbumName.setColor(headerArtistNameColor);
			
			// back to albums button
			mcBackToAlbumsBt.visible = !backToAlbumsDisable;
			mcBackToAlbumsBt.mcText.mask = mcBackToAlbumsBt.mcMask;
			mcBackToAlbumsBt.mcText.txt.initText(backToAlbumsBtText);
			mcBackToAlbumsBt.mcText.setColor(backToAlbumsBtTextNormalColor);
			// back
			mcBackToAlbumsBt.mcBack.mcFill.width = 2 * mcBackToAlbumsBt.mcText.x + mcBackToAlbumsBt.mcText.width;
			mcBackToAlbumsBt.mcBack.mcStroke.width = mcBackToAlbumsBt.mcBack.mcFill.width-strokePixelIssue;
			if(mcBackToAlbumsBt.mcBack.width > mcHeaderBack.width / 2) 
			{
				mcBackToAlbumsBt.mcBack.mcFill.width = Math.round(mcHeaderBack.width / 2);
				mcBackToAlbumsBt.mcBack.mcStroke.width = mcBackToAlbumsBt.mcBack.mcFill.width-strokePixelIssue;
			}
			mcBackToAlbumsBt.mcBack.mcFill.setColor(backToAlbumsBtFillNormalColor);
			mcBackToAlbumsBt.mcBack.mcStroke.setColor(backToAlbumsBtStrokeNormalColor);
			//
			mcBackToAlbumsBt.mcMask.width = mcBackToAlbumsBt.mcBack.width - 2 * mcBackToAlbumsBt.mcText.x;
			//
			mcBackToAlbumsBt.addEvents(this);
			// rotator
			mcRotator.labelsColor = Prototypes.readNumberVar(headerRotatorXMLObject.labels.@color);
			mcRotator.textsColor = Prototypes.readNumberVar(headerRotatorXMLObject.texts.@color);
			mcRotator.movementDelay = Prototypes.readNumberVar(headerRotatorXMLObject.@stayTime, mcRotator.movementDelay);
			mcRotator.floatTextStep = floatTextStep;
			mcRotator.textRightToLeft = textRightToLeft;
			
			
			// init ALBUM INFO MODULE
			// visible
			mcInfo.visible = !albumInfoDisable;
			// back
			mcInfo.mcBack.width = albumInfoWidth;
			mcInfo.mcBack.height = albumInfoHeight;
			//
			mcInfo.mcBack.setColor(albumInfoBackColor);
			mcInfo.mcBack.alpha = albumInfoBackOpacity;

			// info loader
//			mcInfo.mcLoader.visible = false;
//			mcInfo.mcLoader.centerOnClip(mcInfo.mcBack);
			mcInfo.mcLoader.centerOn(mcInfo.mcBack.width, mcInfo.mcBack.height);
			mcInfo.mcLoader.x += albumInfoBorder;
			mcInfo.mcLoader.y += albumInfoBorder;
			
			// album image and mask
			mcInfo.mcMask.x = mcInfo.mcMask.y = mcInfo.mcHolder.x = mcInfo.mcHolder.y = albumInfoBorder;
			mcInfo.mcMask.width = mcInfo.mcBack.width - 2 * albumInfoBorder; 
			mcInfo.mcMask.height = mcInfo.mcBack.height - 2 * albumInfoBorder;
			// add events on the image
			mcInfo.mcHolder.addEvents(this);			 
			
			// prev button
			mcInfo.mcPrevBt.x = mcInfo.mcBack.x;
			mcInfo.mcPrevBt.y = mcInfo.mcBack.y + Math.round((mcInfo.mcBack.height - mcInfo.mcPrevBt.height) / 2);
			//			
			mcInfo.mcPrevBt.alpha = prevNextAlbumBtNormalAlpha;
			mcInfo.mcPrevBt.mcBack.setColor(prevNextAlbumBtBackColor);
			mcInfo.mcPrevBt.mcSign.setColor(prevNextAlbumBtSignColor);
			mcInfo.mcPrevBt.addEvents(this);
			mcInfo.mcPrevBt.visible = !prevNextDisable;
			// next button
			mcInfo.mcNextBt.x = mcInfo.mcBack.x + mcInfo.mcBack.width - mcInfo.mcNextBt.width;
			mcInfo.mcNextBt.y = mcInfo.mcBack.y + Math.round((mcInfo.mcBack.height - mcInfo.mcNextBt.height) / 2);
			//			
			mcInfo.mcNextBt.alpha = prevNextAlbumBtNormalAlpha;
			mcInfo.mcNextBt.mcBack.setColor(prevNextAlbumBtBackColor);
			mcInfo.mcNextBt.mcSign.setColor(prevNextAlbumBtSignColor);
			mcInfo.mcNextBt.addEvents(this);
			mcInfo.mcNextBt.visible = !prevNextDisable;
			
			// album buy button
			mcInfo.mcBuy.centerOn(mcInfo.mcBack.width);
			mcInfo.mcBuy.y = mcInfo.mcHolder.y + mcInfo.mcHolder.height - mcInfo.mcBuy.height;
			//			
			mcInfo.mcBuy.mcText.mask = mcInfo.mcBuy.mcMask;
			mcInfo.mcBuy.mcText.setColor(buyTextColor);
			//
			mcInfo.mcBuy.mcBack.mcFill.setColor(buyFillColor);
			mcInfo.mcBuy.mcBack.mcStroke.setColor(buyStrokeColor);
			//
			mcInfo.mcBuy.addEvents(this);
			//
			mcInfo.mcBuy.visible = false;


			// init ALBUM PLAYLIST module
			mcPlaylist.init(NaN, NaN, mcMp3Gallery.albumsArray[mcMp3Gallery.selectedAlbum].getName, 
							mcMp3Gallery.albumsArray[mcMp3Gallery.selectedAlbum].getNameInList, 
							mcMp3Gallery.albumsArray[mcMp3Gallery.selectedAlbum].getCaption, textRightToLeft, playlistObject);//, mcMp3Gallery.logoPath, mcMp3Gallery.logoURL, mcMp3Gallery.logoWidth);
			mcPlaylist.mcBack.width = componentWidth - (mcInfo.width + distBetweenElements);
			//			
			mcPlaylist.mcList.setCurrency(mcMp3Gallery.currency);
			mcPlaylist.mcList.setTextOrientation(textRightToLeft);
			
			mcPlaylist.mcList.floatTextStep = floatTextStep;
			mcPlaylist.mcList.initWithXMLAndArray(mcPlaylist.mcBack.width - 2 * mcPlaylist.mcList.x, mcPlaylist.mcBack.height - mcPlaylist.mcList.y, 
											mcMp3Gallery.pathToFiles, playlistObject, null, 
											playlistItemRelease, beginOfAlbumListFunction, endOfAlbumListFunction);
			
			// init AUDIO PLAYER
			// read protection songs
			if(audioPlayerProtectionXMLList != null)
			{
				var protectionItemsNodes : * = audioPlayerProtectionXMLList.song;				
				protectionItemsNo = protectionItemsNodes.length();
				protectionPlayeveryXseconds = Prototypes.readNumberVar(audioPlayerProtectionXMLList.@playeveryXseconds, -1); //trace("protectionPlayeveryXseconds:", protectionPlayeveryXseconds);
			}
			if(protectionItemsNo > 0)
			{
				protectionItems = new Array();
				for(var i : uint = 0; i < protectionItemsNo; i++)
				{
					protectionItems.push(Prototypes.readAssetPath(protectionItemsNodes[i], pathToFiles));
	//				trace("protection song no " + i + ":", protectionItems[i]);
				}
			}
			// init protection manager
			if(hasProtection)
			{
				protectionSM = new SoundManager();
				protectionCurrentItem = 0;
				protectionSM.addEventListener("MediaPlayingEnd", function() : void
				{
					protectionCurrentItem++;
					if(protectionCurrentItem > protectionItemsNo - 1) protectionCurrentItem = 0;
					protectionSM.loadNewSound(protectionItems[protectionCurrentItem], true);
					protectionSM.playAudio();
				});
				protectionSM.setVolumeInstant(0.5);
				protectionSM.loadNewSound(protectionItems[protectionCurrentItem]);
			}
			// rewind button
			mcPlayer.mcController.mcRewindBt.addEventListener(MouseEvent.CLICK, function() : void
			{
				mcPlaylist.mcList.prev(true);
			});
			mcPlayer.mcController.mcForwardBt.addEventListener(MouseEvent.CLICK, function() : void
			{
				// test if it should repeat the list or the album
				mcPlaylist.mcList.next(true);
			});
			// shuffle bt
			mcPlayer.mcController.mcShuffleBt.selected = false;
			mcPlayer.mcController.mcShuffleBt.addEventListener(MouseEvent.CLICK, function() : void
			{
				mcPlayer.mcController.mcShuffleBt.selected = !mcPlayer.mcController.mcShuffleBt.selected;
				mcPlaylist.mcList.setRandom(mcPlayer.mcController.mcShuffleBt.selected);
			});
			mcPlayer.mcController.mcEmbedBt.addEventListener(MouseEvent.CLICK, function() : void
			{
				if(mcPlayer.isPlaying) mcPlayer.pausePlaying();
				mcShare.toggleShow();
				//URLNavigator.ChangePage(mcMp3Gallery.shareLink, "_blank");
			});
			// repeat button
			mcPlayer.mcController.mcRepeatBt.mcSign.mcNumber.visible = false;
			mcPlayer.mcController.mcRepeatBt.selected = false;	
			mcPlayer.mcController.mcRepeatBt.mouseChildren = false;
			mcPlayer.mcController.mcRepeatBt.addEventListener(MouseEvent.CLICK, function() : void
			{
				var mc : MovieClip = mcPlayer.mcController.mcRepeatBt;
				 
				// change to repeat list
				if(!mc.selected) 
				{
					//trace("list");
					mc.selected = !mc.selected;
				}
				// change to (repeat song) / (no repeat)
				else 
				{
					// deselect total
					if(mc.mcSign.mcNumber.visible) 
					{
						//trace("album");
						mc.selected = !mc.selected;
					}
					else
					{
						//trace("song");
					}
					
					// show / hide the numebr
					mc.mcSign.mcNumber.visible = !mc.mcSign.mcNumber.visible;
				}
				
				mcPlaylist.mcList.hasToRepeat = (mc.selected && !mc.mcSign.mcNumber.visible);
				
			});
			
			this.addEventListener("reachedEndOfTheList", function():void
			{
				mcPlayer.stopAction(false);
			});
			
			mcPlayer.addEventListener("MediaPlayingStart", function() : void
			{
				// start/resume secure sounds
//				trace("MEDIA STARTED OUTSIDE PLAYER");
				if(hasProtection) protectionSM.playAudio();
			});
			mcPlayer.addEventListener("MediaPlayingPause", function() : void
			{
				// stop secure sounds
//				trace("MEDIA PAUSED OUTSIDE PLAYER");
				if(hasProtection) protectionSM.pauseAudio();				
			});			
			mcPlayer.addEventListener("MediaPlayingStop", function() : void
			{
//				trace("MEDIA STOPPED OUTSIDE PLAYER");
				if(hasProtection) protectionSM.stopAudio();
			});			
			mcPlayer.addEventListener("MediaPlayingEnd", function() : void
			{
//				trace("MEDIA ENDED OUTSIDE PLAYER");
				if(hasProtection) protectionSM.stopAudio();
				
				// repeat
				if(mcPlayer.autoStart)
				{
					// go next song
					if(!mcPlayer.mcController.mcRepeatBt.mcSign.mcNumber.visible)
					{
//						trace("go next song");
						mcPlaylist.mcList.next(true);
					}
					// repeat song
					else
					{
//						trace("repeat media");
						mcPlayer.seekVideoToProcent(0);
						if(hasProtection) protectionSM.playAudio();
					}
				}
				// stop song
				else
				{
					// stop song
//					trace("stop song");
//					mcPlayer.mcController.releaseFunction(mcPlayer.mcController.mcStopBt);
					mcPlayer.stopAction();
				}
			});									
			mcPlayer.initWithXMLObject(componentWidth, 40, "", "audio", audioPlayerSettingsXMLList);
			
			
			// make the first RESIZE
			resize(componentWidth, componentHeight);
			
			// init rotator
			mcRotator.initWithArray(mcHeaderBack.width - mcBackToAlbumsBt.mcBack.width - 2 * headerMarginX, NaN);
			mcRotator.visible = !Prototypes.readBooleanVar(headerRotatorXMLObject.@disable, false);
			
			// init SHARE WINDOW
			mcShare.visible = false;
			mcShare.y = mcPlayer.y;
			mcShare.initWithXMLObject(mcBack.width, mcPlayer.y, mcMp3Gallery.embedObject, embedWindowXMLList);
			
			// SHOW EVERYTHING
			show();
		}

		/*
		 * GET - detects if there are protection sounds
		 */
		public function get hasProtection() : Boolean
		{
			return (protectionItems != null && protectionItemsNo > 0);
		}		
		
		/*
		 * called to load a new album inside the player 
		 */
		public function loadAlbum(album : Album) : void	
		{
			// HEADER
			// album author
			mcAlbumName.txt.initText(album.getAuthor);			
			// rotator
			mcRotator.initWithArray(NaN, NaN, 
									[{label : headerRotatorXMLObject.labels.albumLabel, text : album.getName}, 
									{label : headerRotatorXMLObject.labels.nowPlayingLabel, text : album.getTracks[0].getTitle}]);
			
			// INFO
			// buy button
			mcInfo.mcBuy.visible = false;
			// load album image
			mcInfo.mcHolder.showObject(false);
			mcInfo.mcHolder.loadContent(album.getImage, onInfoImageLoaded, mcInfo.mcLoader, false);
			
			// AUDIO PLAYER
			var isMix : Boolean = (album.type == "mix");
			//
			mcPlayer.mcController.mcShuffleBt.selected = isMix;
			mcPlayer.mcController.overToggle(mcPlayer.mcController.mcShuffleBt, isMix);
			//
			mcPlayer.mcController.mcRepeatBt.selected = isMix;
			mcPlayer.mcController.overToggle(mcPlayer.mcController.mcRepeatBt, isMix);
			mcPlayer.mcController.mcRepeatBt.mcSign.mcNumber.visible = false;
			//
			mcPlayer.mcController.resetSkipBts(!isMix);

			// load ALBUM info in playlist
			mcPlaylist.mcList.visible = !isMix;
			mcPlaylist.loadInfo(album.getName, album.getNameInList, album.getCaption, album.getTracks, isMix);
		}
		
		
		/*
		 * to do after the info image is loaded
		 */
		public function onInfoImageLoaded(mc : MovieClip) : void
		{
			var mcParentMask : MovieClip = MovieClip(mc.parent).mcBack;
			
			// resize image
			mc.fitToRect(mcParentMask.width, mcParentMask.height);
			
			// reposition
//			mc.centerOnClip(mcParentMask);
			mc.x += mcParentMask.x;
			mc.y += mcParentMask.y;

			// show image
			mc.showObject();
			
			// buy bt
			if(mcMp3Gallery.albumsArray[mcMp3Gallery.selectedAlbum].getBuy != "")
			{
				mcInfo.mcBuy.mcText.txt.initText(buyAlbumText + (mcMp3Gallery.albumsArray[mcMp3Gallery.selectedAlbum].getPrice > 0 ? ("(" + mcMp3Gallery.currency + mcMp3Gallery.albumsArray[mcMp3Gallery.selectedAlbum].getPrice + ")") : ""));
				//
				mcInfo.mcBuy.mcBack.mcFill.width = Math.min(mcInfo.mcHolder.width, 2 * mcInfo.mcBuy.mcText.x + mcInfo.mcBuy.mcText.width) - 1;
				mcInfo.mcBuy.mcBack.mcStroke.width = mcInfo.mcBuy.mcBack.mcFill.width - strokePixelIssue;
				//
				mcInfo.mcBuy.mcMask.x = mcInfo.mcBuy.mcText.x;
				mcInfo.mcBuy.mcMask.width = mcInfo.mcBuy.mcBack.width - 2 * mcInfo.mcBuy.mcText.x; 
				//
				mcInfo.mcBuy.x = Math.round((mcInfo.mcBack.width - mcInfo.mcBuy.mcBack.width) / 2);
				mcInfo.mcBuy.y = mcInfo.mcHolder.y + mcInfo.mcHolder.height - mcInfo.mcBuy.mcBack.height - 5;
				mcInfo.mcBuy.visible = true;
				//trace("BUY LINK:<>" + mcMp3Gallery.albumsArray[mcMp3Gallery.selectedAlbum].getBuy + "<>");
			}		
			else mcInfo.mcBuy.visible = false;	
		}			
		
		/*
		 * called to load a new song inside the sound player 
		 */		
		public function playlistItemRelease(obj : Object) : void
		{
			var album : Album = mcMp3Gallery.albumsArray[mcMp3Gallery.selectedAlbum];
			var isMix : Boolean = (album.type == "mix");
			var albumName : String = (isMix ? obj.albumName : album.getName);

			// write the info in the rotator
			var rotatarArray : Array = [{label : headerRotatorXMLObject.labels.albumLabel, text : albumName}];
			if(Prototypes.readStringVar(headerRotatorXMLObject.labels.artistLabel) != "") rotatarArray.push({label : headerRotatorXMLObject.labels.artistLabel, text : obj.getArtist});
			rotatarArray.push({label : headerRotatorXMLObject.labels.nowPlayingLabel, text : obj.getTitle});
			mcRotator.createList(rotatarArray);
			
			// decide the image path
//			var imagePath : String = (isMix ? obj.albumImage : obj.imagePath); // on click of image will call the 
			var imagePath : String = (obj.imagePath == "" ? obj.albumImage : obj.imagePath); // on click of image will call the 
			
			// load the track's album/own image if is the case
//			trace("imagePath:", imagePath);
			if(imagePath != "" && currentInfoImage != imagePath)
			{	
				currentInfoImage = imagePath;
				
				mcInfo.mcHolder.showObject(false);
				mcInfo.mcHolder.loadContent(imagePath, onInfoImageLoaded, mcInfo.mcLoader, false);
			}
			
			// update selected item
			selectedItem = obj;				  			
			
			// load the new mp3 inside the player
			mcPlayer.loadNewHDVideo(obj.getSong, "", "", obj.getStreamer, null, obj.getDuration); //			trace(obj.getSong, "", obj.getStreamer);
		}

		/*
		 * go to prev album if the current album's list just started
		 */
		public function beginOfAlbumListFunction() : void
		{
//			trace("GO PREV ALBUM");
			// go next album
//			mcMp3Gallery.mcCoverflow.mcCoverflow.prev();
			
			// select the new album
//			mcMp3Gallery.mcCoverflow.mcCoverflow.itemClick();
		}		
		
		/*
		 * go to next album if the current album's list is done
		 */
		public function endOfAlbumListFunction() : void
		{
//			trace("GO NEXT ALBUM");
			// go next album
//			mcMp3Gallery.mcCoverflow.mcCoverflow.next();
			
			// select the new album
//			mcMp3Gallery.mcCoverflow.mcCoverflow.itemClick();
		}	



		/****************************************************
		 * 
		 * 				EVENTS HANDLERS
		 * 
		 ****************************************************/

		/*
		 * RESIZE function
		 */
		public function resize(w : Number, h : Number) : void
		{
			// BACKGROUND
			mcBack.width = w;
			mcBack.height = h;
			
			// BACK IMAGE
			if(mcBackImage.loaded) mcBackImage.fitToRect(mcBack.width, mcBack.height - mcPlayer.mcBack.height);
			
			// HEADER BACK
			mcHeaderBack.x = headerX;
			mcHeaderBack.y = headerY;
			//
			mcHeaderBack.width = mcBack.width - 2 * mcHeaderBack.x;
			
			// ARTIST NAME
			mcAlbumName.x = mcHeaderBack.x + headerMarginX;
			mcAlbumName.y = mcHeaderBack.y + headerMarginY;
			
			// LOGO
			positionLogo();
			
			// BACK TO ALBUMS bt
			mcBackToAlbumsBt.x = mcHeaderBack.x + mcHeaderBack.width - mcBackToAlbumsBt.width - headerMarginX;
			mcBackToAlbumsBt.y = mcHeaderBack.y + Math.round((mcHeaderBack.height - mcBackToAlbumsBt.mcBack.height) / 2);

			// ALBUM AND SONG ROTATOR
			mcRotator.x = mcHeaderBack.x + headerMarginX;
			//mcRotator.y = mcAlbumName.y + mcAlbumName.height;
			mcRotator.y = mcHeaderBack.y + mcHeaderBack.height - mcRotator.mcBack.height;
			mcRotator.resize(mcBackToAlbumsBt.x - mcRotator.x - headerMarginX);

			// AUDIO PLAYER
			mcPlayer.resize(w);
			mcPlayer.y = Math.round(mcBack.height - mcPlayer.mcBack.height);
			
			// SHARE WINDOW
//			mcShare.y = mcPlayer.y;
			
			// INFO MODULE
			mcInfo.x = 0;
			mcInfo.y = mcHeaderBack.y + mcHeaderBack.height + Math.round((mcPlayer.y - (mcHeaderBack.y + mcHeaderBack.height) - mcInfo.mcBack.height) / 2);
			
			// PLAYLIST
			mcPlaylist.x = mcInfo.x + (mcInfo.visible ? mcInfo.width + distBetweenElements : 0);
			mcPlaylist.y = mcInfo.y + Math.round((mcInfo.mcBack.height - listHeight) / 2);
			mcPlaylist.resize(w - mcPlaylist.x, listHeight);
//			mcPlaylist.y = mcHeaderBack.y + mcHeaderBack.height + distBetweenElements;			
//			mcPlaylist.resize(w - (mcInfo.mcBack.width + distBetweenElements), mcPlayer.y - mcPlaylist.y - 2 * distBetweenElements + 5);
		}
		
		private function positionLogo() : void
		{
			if(logoLoaded)
			{
				mcLogo.x = mcHeaderBack.x + mcHeaderBack.width - mcLogo.mcMask.width - headerMarginX;
				mcLogo.y = headerMarginY;//mcHeaderBack.y + Math.round((mcHeaderBack.height - mcLogo.height) / 2);
			}
		}	

		/**
		 * OVER EVENT HANDLER
		 */
		public function overHandler(event : MouseEvent) : void
		{
			var mc : Object = event.currentTarget;	
			
			switch(mc)
			{
				case mcBackToAlbumsBt:
					mc.mcBack.mcFill.setColor(backToAlbumsBtFillOverColor, overButtonsTweenTime);
					mc.mcBack.mcStroke.setColor(backToAlbumsBtStrokeOverColor, overButtonsTweenTime);
					mc.mcText.setColor(backToAlbumsBtTextOverColor, overButtonsTweenTime);
					break;
				
				case mcInfo.mcBuy:
					mc.mcBack.mcFill.setColor(buyFillOverColor, overButtonsTweenTime);
					mc.mcBack.mcStroke.setColor(buyStrokeOverColor, overButtonsTweenTime);
					mc.mcText.setColor(buyTextOverColor, overButtonsTweenTime);
				break;
				
				case mcInfo.mcPrevBt:
				case mcInfo.mcNextBt:
					mc.fadeAlpha(prevNextAlbumBtOverAlpha, overButtonsTweenTime); 
				break;				
			}
		}

		
		/**
		 * OUT HANDLER
		 */
		public function outHandler(event : MouseEvent) : void
		{
			var mc : Object = event.currentTarget;
			
			switch(mc)
			{
				case mcBackToAlbumsBt:
					mc.mcBack.mcFill.setColor(backToAlbumsBtFillNormalColor, overButtonsTweenTime);
					mc.mcBack.mcStroke.setColor(backToAlbumsBtStrokeNormalColor, overButtonsTweenTime);
					mc.mcText.setColor(backToAlbumsBtTextNormalColor, overButtonsTweenTime);
				break;					
				
				case mcInfo.mcBuy:
					mc.mcBack.mcFill.setColor(buyFillColor, overButtonsTweenTime);
					mc.mcBack.mcStroke.setColor(buyStrokeColor, overButtonsTweenTime);
					mc.mcText.setColor(buyTextColor, overButtonsTweenTime);
				break;
				
				case mcInfo.mcPrevBt:
				case mcInfo.mcNextBt:
					mc.fadeAlpha(prevNextAlbumBtNormalAlpha, overButtonsTweenTime); 
				break;				
			}
		}

		/**
		 * PRESS EVENT HANDLER
		 */
		public function pressHandler(event : MouseEvent) : void
		{
			var mc : MovieClip = event.currentTarget as MovieClip; 
			//trace("Event.target press..." + event.target);
			
			// set pressed the new item
			currPressedObject = mc;
		
			// add the release event on stage
			stage.addEventListener(MouseEvent.MOUSE_UP, releaseOutsideHandler);
			stage.addEventListener(Event.MOUSE_LEAVE, releaseOutsideHandler);
		}
		

		/**
		 * RELEASE OUTSIDE EVENT HANDLER
		 */
		public function releaseOutsideHandler(e : Event) : void 
		{
			stage.removeEventListener(MouseEvent.MOUSE_UP, releaseOutsideHandler);
			stage.removeEventListener(Event.MOUSE_LEAVE, releaseOutsideHandler);
	       // Main.getInstance().ttrace("OUTSIDE " + currPressedObject.name);
		}
		

		/**
		 * RELEASE EVENT HANDLER
		 */
		 
		public function releaseHandler(event : MouseEvent) : void
		{
			var mc : MovieClip = event.currentTarget as MovieClip; 
						
			// test if the releasse event comes from the same item that was pressed
			if(mc == currPressedObject)
			{
				releaseFunction(mc);
				currPressedObject = null;
			}
		}
		
		public function releaseFunction(mc : MovieClip) : void 
		{
			switch(mc)
			{
				case mcInfo.mcPrevBt:
				case mcInfo.mcNextBt:
					if(extIterateFunction.length) extIterateFunction(mc == mcInfo.mcPrevBt);
					else extIterateFunction();					 
				break;	
								
				case mcInfo.mcBuy:
					URLNavigator.ChangePage(mcMp3Gallery.albumsArray[mcMp3Gallery.selectedAlbum].getBuy, mcMp3Gallery.albumsArray[mcMp3Gallery.selectedAlbum].getBuyTarget);
				break;
				
				// click on left image art
				case mcInfo.mcHolder:
					// select the current selected track's album
					if(mcMp3Gallery.albumsArray[mcMp3Gallery.selectedAlbum].type == "mix")
					{
						mcMp3Gallery.mcAlbumsGallery.selectItemNo(selectedItem.albumIndex, true);
					}
					// go to album's / track's image link
					else
					{ 
						var url : String = (selectedItem.imageLink != "" ? selectedItem.imageLink : mcMp3Gallery.albumsArray[mcMp3Gallery.selectedAlbum].getLink);
						var target : String = (selectedItem.imageLink != "" ? selectedItem.imageLinkTarget : mcMp3Gallery.albumsArray[mcMp3Gallery.selectedAlbum].getLinkTarget);
						
						if(url != "") URLNavigator.ChangePage(url, target);
					}
				break;				
				
				case mcBackToAlbumsBt:
					this.visible = false;
					mcPlayer.stopAction();
					mcMp3Gallery.mcAlbumsGallery.visible = true;
					break;
			}
		}	
		
		/****************************************************
		 * 
		 * 				AUX FUNCTIONS
		 * 
		 ****************************************************/
		public function get getScope() : Mp3Player
		{
			return this;
		}		
		
		public function set setIterateFunction(val : Function) : void
		{
			this.extIterateFunction = val;
		}		
		
		// show/hide all components
		public function show(flag : Boolean = true, loaderFlag : Boolean = false) : void
		{
			//mcLoader.visible = loaderFlag ? flag : !flag;
			mcPlayer.visible = flag;
			mcPlaylist.visible = flag;	
			
			mcBack.visible = flag;
			
			if(!flag) 
			{
				mcInfo.visible = flag;	
			}
		}
		
		
	}// FROM CLASS
}// FROM PACKAGE