﻿/**
* Simple AS3 flash video player - Flabell.com Product, January 2010
* @author Vuzum, LLC.
* @version 1; 
* http://www.vuzum.com
* email: office@vuzum.com
*/
package com.vuzum.utils
{
	// FLASH IMPORTS
	import flash.text.TextField;
	import flash.external.ExternalInterface;	
	import flash.display.MovieClip;
	import flash.display.StageDisplayState;
	import flash.events.MouseEvent;
	import flash.system.System;
	import flash.net.URLRequest;
	import flash.net.URLVariables;
	import flash.net.URLLoader;
	import flash.net.URLRequestMethod;
	import flash.events.Event;
	import flash.events.IOErrorEvent;
	import flash.net.URLLoaderDataFormat;
	
	// OTHER'S IMPORTS
	import caurina.transitions.Tweener;
	
	// MY IMPORTS
		

	// CLASS
	public class Share extends MovieClip 
	{
		// COMPONENTS INSIDE
	    public var mcBack : MovieClip;
	    public var mcBox : MovieClip;
	    
		// COMPONENT'S VARS
		public var componentWidth : Number;
		public var componentHeight : Number;	    

		// HANDLERS VARS	    
	    private var currPressedObject : MovieClip;
	    	
	    // INTERNAL MEMBERS
	    public var embedObject : Object = null;
	    
	    // background color
	    private var backStrokeColor : Number;
	    private var backFillColor : Number;
	    
	    // dist between elements
	    private var verticalDistBetween : Number = 15;
	    
	    // text settings
	    private var codeSize : Number = 13;
	    private var codeColor : Number;
	    
	    // close button
		private var closeBtMarginAround : Number = 10;
		private var closeBtBackNormalColor : Number;
		private var closeBtBackOverColor : Number;
		private var closeBtSignNormalColor : Number;
		private var closeBtSignOverColor : Number;
		
		// copy button
		private var copyBtBackNormalColor : Number;
		private var copyBtBackOverColor : Number;
		private var copyBtText : String = "Copy"; 
		private var copyBtTextNormalColor : Number; 
		private var copyBtTextOverColor : Number;
	    
	    
	    // AUX VARS
		private var showItemTweenTime : Number = 0.7;
		private var normalColor : Number;
		private var overColor : Number;

		/**
	     * CONSTRUCTOR
	     */
	    function Share() 
	    {
	    	//trace("EMBED CONSTRUCTOR");
	    	
	    	// init the prototypes
	    	new Prototypes();

	        // set up the embed
	        mcBox.mcCloseBt.txt.embedFonts = true;
	        mcBox.mcCloseBt.txt.mouseEnabled = false;
	        //
	        mcBox.labelTxt.embedFonts = true;
	        //
	        mcBox.embedTxt.embedFonts = true;
	        //mcBox.embedTxt.backgroundColor = 0xF5ED40;
	        //
	        mcBox.mcCopyBt.txt.embedFonts = true;
	        mcBox.mcCopyBt.txt.mouseEnabled = false;
	        
	        // set the tab indexes
			mcBox.mcCloseBt.tabIndex = 0;
			mcBox.embedTxt.tabIndex = 1;
			mcBox.mcCopyBt.tabIndex = 2;
	    }
	
	    /**
	     * inits the share
	     */
	    public function init(pWidth : Number, pHeight : Number, pEmbedObject : Object = null, pXmlPath : String = "") : void    
	    {
	    	// READ PARAMS
	    	// dimensions
	    	componentWidth = pWidth;
	    	componentHeight = pHeight;
	    		    	
	    	// read embed object
	    	embedObject = pEmbedObject;
	    	
		    // START COMPONENT
		    start();
	    }
	    
	    public function initWithXMLObject(pWidth : Number = NaN, pHeight : Number = NaN, pEmbedObject : Object = null, pXmlObject : * = null) : void    
	    {
	    	// READ PARAMS
	    	// dimensions
	    	componentWidth = pWidth;
	    	componentHeight = pHeight;
	    	

	    	// READ THE SETTINGS XML
	    	backStrokeColor = Prototypes.readNumberVar(pXmlObject.backColor.@stroke);
	    	mcBox.mcBack.mcStroke.setColor(backStrokeColor);
	    	backFillColor = Prototypes.readNumberVar(pXmlObject.backColor.@fill);
	    	mcBox.mcBack.mcFill.setColor(backFillColor);
	    	
	    	// distbetween
	    	verticalDistBetween = Prototypes.readNumberVar(pXmlObject.@verticalDistBetween, verticalDistBetween);
	    	
	    	// embed code object
	    	embedObject = pEmbedObject;
	    	
			// read settings
			var textText : String = (pXmlObject != null ? Prototypes.readStringVar(pXmlObject.title, mcBox.labelTxt.text) : mcBox.labelTxt.text);
			var textSize : Number = Prototypes.readNumberVar(pXmlObject.title.@dimension, 13); 
			var textColor : Number = Prototypes.readNumberVar(pXmlObject.title.@color); 
			mcBox.labelTxt.initText(textText);
			mcBox.labelTxt.format(textSize, textColor);
			//
			codeSize = Prototypes.readNumberVar(pXmlObject.title.@dimension, codeSize); 
			codeColor = Prototypes.readNumberVar(pXmlObject.title.@color); 
			mcBox.labelTxt.format(textSize, textColor);

			// close bt
			closeBtMarginAround = Prototypes.readNumberVar(pXmlObject.closeBt.@marginAround, closeBtMarginAround);
			// 
			closeBtBackNormalColor = Prototypes.readNumberVar(pXmlObject.closeBt.@backNormalColor); 
			closeBtBackOverColor = Prototypes.readNumberVar(pXmlObject.closeBt.@backOverColor);
			// 
			closeBtSignNormalColor = Prototypes.readNumberVar(pXmlObject.closeBt.@signNormalColor); 
			closeBtSignOverColor = Prototypes.readNumberVar(pXmlObject.closeBt.@signOverColor); 
			//
			mcBox.mcCloseBt.mcSign.setColor(closeBtSignNormalColor);
			
			// copy bt
			copyBtBackNormalColor = Prototypes.readNumberVar(pXmlObject.copyBt.@backNormalColor); 
			copyBtBackOverColor = Prototypes.readNumberVar(pXmlObject.copyBt.@backOverColor);
			//
			copyBtText = Prototypes.readStringVar(pXmlObject.copyBt, copyBtText);
			copyBtTextNormalColor = Prototypes.readNumberVar(pXmlObject.copyBt.@textNormalColor); 
			copyBtTextOverColor = Prototypes.readNumberVar(pXmlObject.copyBt.@textOverColor); 


		    // START COMPONENT
		    start();			
	    }	   
	    
	    
	    // START COMPONENT
	    public function start() : void
	    {
	    	// RESIZE
			resize(componentWidth, componentHeight);	    	
	    	
	    	// close button
	        mcBox.mcCloseBt.addEvents(this);

			// embed code text
	        writeEmbed();	        
	        
	        // embed copy button
	        mcBox.mcCopyBt.addEvents(this);

	    	// hide it for the first time
	    	this.scaleY = 0; 
	    }
	    
	    /**
	     * writes the embed code in the textfield
	     */
	    public function writeEmbed() : void
	    {
	    	// WRITE THE EMBED CODE
	    	if(embedObject != null)
		    {
				// get swf url
				var swfUrl : String = stage.loaderInfo.url;
				// path to files
				var pozLastSlash : uint = swfUrl.lastIndexOf("/");				
				var pathToFiles : String = embedObject.pathToFiles;
				if(pathToFiles.indexOf("http://") < 0) pathToFiles = swfUrl.substring(0, pozLastSlash + 1) + pathToFiles;
		    	
		    	// write embed code
		        this.mcBox.embedTxt.text = '<embed id="FlashComponent"\n';
		        //
		        this.mcBox.embedTxt.text += '	src="' + swfUrl + '"\n';
		        this.mcBox.embedTxt.text += '	bgColor = "#000000"\n';
		        this.mcBox.embedTxt.text += '	width="' + embedObject.componentWidth + '"\n';
		        this.mcBox.embedTxt.text += '	height="' + embedObject.componentHeight + '"\n';
		        this.mcBox.embedTxt.text += '	allowfullscreen="true"\n';
		        this.mcBox.embedTxt.text += '	allowScriptAccess="always"\n';
		        // flashvars
		        this.mcBox.embedTxt.text += '	flashVars="';
		        //
		        this.mcBox.embedTxt.text += 'pathToFiles=' + pathToFiles;
		        //
		        this.mcBox.embedTxt.text += '&componentWidth=' + embedObject.componentWidth;
		        this.mcBox.embedTxt.text += '&componentHeight=' + embedObject.componentHeight;
		        //
		        if(embedObject.xmlPath != "") this.mcBox.embedTxt.text += '&xmlPath=' + embedObject.xmlPath;
		        if(embedObject.contentXMLPath != "") this.mcBox.embedTxt.text += '&contentXMLPath=' + embedObject.contentXMLPath;
		        //
		        this.mcBox.embedTxt.text += '"></embed>';
		    }	    		
	    }
	    
	    
		/****************************************************************************
		 *
		 *							EVENT HANDLERS
		 * 
		 *****************************************************************************/	        
	    /**
	     * Repositions and resizes the STAF window
	     */
	    public function resize(pWidth : Number, pHeight : Number) : void
	    {
	        mcBack.width = pWidth;
	        mcBack.height = pHeight;
	        
	        componentWidth = mcBack.width;
	        componentHeight = mcBack.height;
	        
	        // position box
			mcBox.x = Math.round((this.mcBack.width - this.mcBox.width) / 2);
			mcBox.y = Math.round((this.mcBack.height - this.mcBox.height) / 2);
	    }
	    
		/*
		 * over button event handler
		 */
		public function overHandler(event : MouseEvent) : void
		{
			var mc : MovieClip = event.currentTarget as MovieClip; //trace(mc.name + " " + event.target.name);
			overFunction(mc);
		}
		
		/*
		 * out button event handler
		 */
		public function outHandler(event : MouseEvent) : void
		{
			var mc : MovieClip = event.currentTarget as MovieClip; //trace(mc.name + " " + event.target.name);
			overFunction(mc, false);
		}
		
		public function overFunction(mc : MovieClip, flag : Boolean = true) : void
		{
			// if is the close button
			if(mc == this.mcBox.mcCloseBt) 
			{
				// change the color of the background			
				mcBox.mcCloseBt.mcSign.setColor(!flag ? closeBtSignNormalColor : closeBtSignOverColor);
				mcBox.mcCloseBt.mcBack.setColor(!flag ? closeBtBackNormalColor : closeBtBackOverColor);
			}
			
			// if is the copy button
			if(mc == this.mcBox.mcCopyBt) 
			{
				// change the color of the background			
				mcBox.mcCopyBt.txt.setColor(!flag ? copyBtTextNormalColor : copyBtTextOverColor);
				mcBox.mcCopyBt.mcBack.setColor(!flag ? copyBtBackNormalColor : copyBtBackOverColor);
			}						
		}		
		
		/*
		 * press button event handler
		 */
		public function pressHandler(event : MouseEvent) : void
		{
			var mc : Object = event.currentTarget; //trace("PRESSED: " + mc.name);
			
			// set pressed this item
			this.currPressedObject = MovieClip(mc);
		}
		
		/*
		 * release button event handler 
		 */
		public function releaseHandler(event : MouseEvent) : void
		{
			var mc : Object = event.currentTarget; //trace("RELEASED: " + mc.name);
			
			if(mc == this.currPressedObject)
			{
				releaseFunction(MovieClip(mc));
			}			
			else// TO DO ON RELEASE THE SCENE:
			{
				//trace("SCENE RELEASED - releaseoutside");
				//trace(this.currPressedObject.name);
			}			
		}	
		
		/*
		 * release button function 
		 */
		public function releaseFunction(mc : MovieClip) : void
		{
			switch(mc)
	        {
	           	case mcBox.mcCloseBt:
					toggleShow();
	                break;
	            case mcBox.mcCopyBt:
	            	copyBtFunction();
	                break;
	        }
		}
		
		
		
		
		
		/****************************************************************************
		 *
		 *							AUX FUNCTIONS
		 * 
		 *****************************************************************************/
	    /**
	     * Called when the Copy button for embed is released
	     */
	    private function copyBtFunction() : void 
	    {
	    	// set focus
	        stage.focus = mcBox.embedTxt;
	        
	        // select text
	        mcBox.embedTxt.setSelection(0, mcBox.embedTxt.text.length);
	        
	        // set text in clipboard
	        System.setClipboard(mcBox.embedTxt.text);
	    }
	
		/*
		 * shows or hides the share window 
		 */
		public function toggleShow() : void
		{
			show(scaleY==0);
		}
		public function show(flag : Boolean = true) : void
		{
			var endY : Number;
			var endYScale : Number;
			var hide : Boolean = true;
			
			if(!flag) // hide
			{
				hide = false;
				endY = this.mcBack.height;
				endYScale = 0;
			}
			else // show
			{
				// write the embed code
				//writeEmbed();

				// calculate the tween vars
				hide = this.visible = true;
				endY = 0;
				endYScale = 1;
			}
			
			// move on y
			Tweener.addTween(this, {y : endY, time : showItemTweenTime, transition : "easeOutExpo"});
			
			// scale on y				
			Tweener.addTween(this, {scaleY : endYScale, time : showItemTweenTime, transition : "easeOutExpo", onComplete : function () :void { shareMotionFinished(hide); } });
		}
		
		//private function shareMotionFinished(event : TweenEvent) : void
		private function shareMotionFinished(hide : Boolean) : void
		{
			this.visible = hide;
		}
		
	
	
	} // FROM CLASS
} // FROM PACKAGE